2014-08-25  Brendan Long  <b.long@cablelabs.com>

        [GStreamer] ASSERT failure in WebKitWebSource in StreamingClient
        https://bugs.webkit.org/show_bug.cgi?id=136132

        adoptGRef() has an ASSERT failure if it's used on a floating pointer. For some reason,
        WebKitWebSrc* src in StreamingClient's constructor is floating. Since we
        don't construct this ourselves, I assume this is happening in Playbin.

        If we remove the ref and adopt, GRefPtr's constructor calls gst_object_ref_sink,
        which removes the floating reference and doesn't increment the reference count.
        This should work, but actually causes the page to either lock up or crash (different
        results for different testers).

        In this case, it seems like the adoptGRef / gst_object_ref was the correct thing to do,
        but adoptGRef won't actually let us do. Removing the ASSERT is a bad idea, because
        usually we don't want to adopt floating pointers.

        This is all a long way of saying that making m_src a raw pointer and manually
        calling gst_object_ref(), and calling gst_object_unref in the destructor is the
        best solution in this case, since it fixes the problem while leaving the ASSERT
        to protect us in the much more common case where adopting a floating reference is bad.

        Reviewed by Philippe Normand.

        * platform/graphics/gstreamer/WebKitWebSourceGStreamer.cpp:
        (StreamingClient::StreamingClient): Make m_src a raw pointer instead of a GRefPtr.
        (StreamingClient::~StreamingClient): Unref m_src.
        (StreamingClient::createReadBuffer): Replace m_src.get() with m_src, since it's a raw pointer now.
        (StreamingClient::handleResponseReceived): Same.
        (StreamingClient::handleDataReceived): Same.
        (StreamingClient::handleNotifyFinished): Same.
        (CachedResourceStreamingClient::notifyFinished): Same.
        (ResourceHandleStreamingClient::didFail): Same.
        (ResourceHandleStreamingClient::wasBlocked): Same.
        (ResourceHandleStreamingClient::cannotShowURL): Same.

2014-08-24  Michael Catanzaro  <mcatanzaro@igalia.com>

        [GTK] Toggle buttons visually broken with GTK+ 3.13.7
        https://bugs.webkit.org/show_bug.cgi?id=136130

        Reviewed by Martin Robinson.

        No new tests. Hopefully covered by existing tests, and our tests only
        run with GTK+ 3.6 anyway.

        * platform/gtk/RenderThemeGtk3.cpp:
        (WebCore::paintToggle): use GTK_STATE_FLAG_CHECKED when compiling for
        GTK+ 3.13.7 and above to ensure toggle buttons display as toggled.

2014-08-26  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Selection background is rendered white when unfocused with recent GTK+
        https://bugs.webkit.org/show_bug.cgi?id=136251

        Reviewed by Martin Robinson.

        This is due to a change in the GTK+ theme, but because we are not
        using the right flags to get the selections colors. We should use
        GTK_STATE_FLAG_SELECTED | GTK_STATE_FLAG_FOCUSED when focused and
        GTK_STATE_FLAG_SELECTED when unfocused, instead of
        GTK_STATE_FLAG_ACTIVE when unfocused.

        * platform/gtk/RenderThemeGtk3.cpp:
        (WebCore::RenderThemeGtk::platformActiveSelectionBackgroundColor):
        (WebCore::RenderThemeGtk::platformInactiveSelectionBackgroundColor):
        (WebCore::RenderThemeGtk::platformActiveSelectionForegroundColor):
        (WebCore::RenderThemeGtk::platformInactiveSelectionForegroundColor):
        (WebCore::RenderThemeGtk::platformActiveListBoxSelectionBackgroundColor):
        (WebCore::RenderThemeGtk::platformInactiveListBoxSelectionBackgroundColor):
        (WebCore::RenderThemeGtk::platformActiveListBoxSelectionForegroundColor):
        (WebCore::RenderThemeGtk::platformInactiveListBoxSelectionForegroundColor):

2014-09-17  Philippe Normand  <pnormand@igalia.com>

        [GStreamer] Cannot play Vimeo video
        https://bugs.webkit.org/show_bug.cgi?id=134969

        Reviewed by Sergio Villar Senin.

        Ensure the GStreamer HTTP source element also sends cookies when
        it's sending its requests. Some streaming platforms such as Vimeo
        do server-side cookie checks on incoming requests before serving
        media data.

        Test: http/tests/media/hls/video-cookie.html

        * platform/graphics/gstreamer/WebKitWebSourceGStreamer.cpp:
        (webKitWebSrcStart): Set first-party cookie URL to the request so
        the ResourceLoader properly sets cookies in the HTTP request.

2014-08-07  Simon Fraser  <simon.fraser@apple.com>

        HTML <sub> and <sup> elements do not work in some 64-bit builds
        https://bugs.webkit.org/show_bug.cgi?id=135736

        Reviewed by Tim Horton.
        
        RootInlineBox::verticalPositionForBox() had some implicit conversions between
        LayoutUnit and int that caused overflow, and resulted in different comparison
        behavior with an int constant in different architectures, since overflow behavior
        is undefined.
        
        Specifically, VerticalPositionCache was written in terms of ints with a special
        0x80000000 "not found" value. However, 0x80000000 was being assigned to
        a LayoutUnit, which multiplies by 64 causing overflow. The result was then
        compared again with 0x80000000 which could pass or fail depending on overflow
        behavior.
        
        Fix by converting VerticalPositionCache to use LayoutUnits, and to have a bool
        return value with a result out param, instead of a special return value.

        Not easily testable, since the difference does not show in DRT output,
        and a ref test would be flakey.

        * rendering/RootInlineBox.cpp:
        (WebCore::RootInlineBox::ascentAndDescentForBox):
        * rendering/VerticalPositionCache.h:
        (WebCore::VerticalPositionCache::get):
        (WebCore::VerticalPositionCache::set):

2014-08-12  Fabien Vallée  <fvallee@connected-labs.com>

        [GStreamer] playback rate is rounded to integer
        https://bugs.webkit.org/show_bug.cgi?id=135802

        Reviewed by Philippe Normand.

        Test: media/video-ended-event-slow-motion-playback.html

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::setRate):

2014-08-24  Michael Catanzaro  <mcatanzaro@igalia.com>

        [GTK] Toggle buttons visually broken with GTK+ 3.13.7
        https://bugs.webkit.org/show_bug.cgi?id=136130

        Reviewed by Martin Robinson.

        No new tests. Hopefully covered by existing tests, and our tests only
        run with GTK+ 3.6 anyway.

        * platform/gtk/RenderThemeGtk3.cpp:
        (WebCore::paintToggle): use GTK_STATE_FLAG_CHECKED when compiling for
        GTK+ 3.13.7 and above to ensure toggle buttons display as toggled.

2014-08-21  Víctor Manuel Jáquez Leal  <vjaquez@igalia.com>

        [GTK] WebkitWebProcess crashing navigating away from ogg video element
        https://bugs.webkit.org/show_bug.cgi?id=135348

        Reviewed by Philippe Normand.

        Let GraphicsLayerTextureMapper know it needs to detach the platform
        layer when a MediaPlayerPrivateGStreamerBase is destroyed.

        No new test since media/restore-from-page-cache.html covers it.

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamerBase.cpp:
        (WebCore::MediaPlayerPrivateGStreamerBase::~MediaPlayerPrivateGStreamerBase):

2014-07-08  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.am:

2014-07-04  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK][Stable] Google Maps doesn't work with Version/X in the user agent
        https://bugs.webkit.org/show_bug.cgi?id=134631

        Reviewed by Sergio Villar Senin.

        Because of the JSC version used in stable branch, when the
        Version/X string is present in the user agent, google maps uses
        JavaScript API that we don't support. Move the google domain quirks
        from WebKit1 to WebCore and add a quirk for google maps.

        * platform/gtk/UserAgentGtk.cpp:
        (WebCore::googleDomains):
        (WebCore::otherGoogleDomains):
        (WebCore::isGoogleDomain): Returns whether the given host is a
        known google domain
        (WebCore::buildUserAgentString): Do not include the Version/X
        string in the user agent if the ShouldNotIncludeSafariVersion
        quirk is present.
        (WebCore::standardUserAgentForURL): Add RequiresStandardUserAgent
        quirk for any google doamin and ShouldNotIncludeSafariVersion for
        Google Maps.

2014-06-27  Philippe Normand  <pnormand@igalia.com>

        [GTK] 8tracks.com triggers annoying pop-up window/installation of "About protocol source plugin" (GStreamer?)
        https://bugs.webkit.org/show_bug.cgi?id=133605

        Reviewed by Carlos Garcia Campos.

        Don't attempt to load blank URLs with the GStreamer media
        player. Those URLs trigger the codec installer which is useless in
        this scenario. This patch also renames some of the variables of
        the ::load method, as suggested by Carlos.

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::~MediaPlayerPrivateGStreamer):
        Check video-sink validity before disconnecting its signal handlers.
        (WebCore::MediaPlayerPrivateGStreamer::load): Don't load blank
        URLs (about:blank).
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamerBase.cpp:
        (WebCore::MediaPlayerPrivateGStreamerBase::~MediaPlayerPrivateGStreamerBase):
        Disconnect repaint handler only if it's valid.

2014-06-12  Alberto Garcia  <berto@igalia.com>

        [GTK] fails to build with --disable-webgl --disable-accelerated-compositing
        https://bugs.webkit.org/show_bug.cgi?id=131267

        Reviewed by Philippe Normand.

        Add missing headers needed for Float32Array::create().

        * Modules/webaudio/AudioBuffer.cpp:

2014-06-13  Alberto Garcia  <berto@igalia.com>

        [GTK] GLContextEGL.cpp: conflicting declaration 'typedef ptrdiff_t GLintptr'
        https://bugs.webkit.org/show_bug.cgi?id=133550

        Reviewed by Gustavo Noronha Silva.

        Cairo includes some definitions from GLX that conflict with the
        ones provided by our GLES2 headers (GLintptr, GLsizeiptr).

        Since GLContextEGL doesn't use any GLX functions we can safely
        disable the inclusion of those functions in that source file.

        * platform/graphics/egl/GLContextEGL.cpp:

2014-06-24  Jarek Czekalski  <jarekczek@poczta.onet.pl>

        [ATK] Don't ignore links rendered as blocks.
        https://bugs.webkit.org/show_bug.cgi?id=130941

        Reviewed by Mario Sanchez Prada.

        * /m/usr/src/webkit-trunk/Source/WebCore/accessibility/atk/WebKitAccessibleWrapperAtk.cpp:
        (WebCore::AccessibilityObject::objectFocusedAndCaretOffsetUnignored): Don't ignore links
        when they are renderered with display:block.

2014-06-13  Jarek Czekalski  <jarekczek@poczta.onet.pl>

        [ATK] Fix text inside "span" block in "a" block was not accessible.
        https://bugs.webkit.org/show_bug.cgi?id=132349

        Reviewed by Mario Sanchez Prada.

        * accessibility/atk/WebKitAccessibleWrapperAtk.cpp: Add link role
          to the list of roles whose objects always expose atk_text interface.

2014-06-11  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Use a different user agent string depending on the site
        https://bugs.webkit.org/show_bug.cgi?id=132681

        Reviewed by Anders Carlsson.

        We have changed the user agent string several times to try to fix
        broken websites that require specific things in the UA string to
        properly work. But everytime we change the UA string to fix a
        website we break others. We could use different UA string
        depending on the website. UserAgentGtk code has also been cleaned
        up, using NeverDestroyed instead of DEPRECATED_DEFINE_STATIC_LOCAL
        and avoiding unneeded conversions to UTF-8.

        * platform/gtk/UserAgentGtk.cpp:
        (WebCore::UserAgentQuirks::UserAgentQuirks): New helper private
        class to handle user agent quirks.
        (WebCore::UserAgentQuirks::add):
        (WebCore::UserAgentQuirks::contains):
        (WebCore::UserAgentQuirks::isEmpty):
        (WebCore::platformForUAString): Bring back this method that was
        removed to always pretend to be Macintosh.
        (WebCore::platformVersionForUAString): Return a different platform
        version depending on the actual platform.
        (WebCore::versionForUAString): Return the WebKit version.
        (WebCore::buildUserAgentString): Helper function to build the user
        agent taking into account the UserAgentQuirks received.
        (WebCore::standardUserAgentStatic): Standard user agent string
        when no quirks are present.
        (WebCore::standardUserAgent):
        (WebCore::standardUserAgentForURL): New method that returns the
        user agent string for the given URL.
        * platform/gtk/UserAgentGtk.h:

2014-06-13  Sergio Villar Senin  <svillar@igalia.com>

        [Gtk] [Stable] Fix the "Safari" part of the UA
        https://bugs.webkit.org/show_bug.cgi?id=133855

        Reviewed by Martin Robinson.

        We claim to be Safari (among others) to ensure maximum
        compatibility with existing web sites. Since Safari 3.0 valid
        Safari UA strings look like this "Version/X Safari/Y" while in our
        UA it's "Safari/Y Version/6.0".

        This is wrong and is causing "unsupported browser" issues in
        many important sites as live.com our icloud.com.

        Apart from that I'm bumping the Safari Version in the UA to 8.0 as
        we're already claiming to be "Safari/538.15" which should be
        pretty equivalent to Safari 8 in terms of features.

        * platform/gtk/UserAgentGtk.cpp:
        (WebCore::standardUserAgent):

2014-05-25  Milan Crha  <mcrha@redhat.com>

        [Stable] [GTK] GdiObject.h missing in WebKitGTK 2.4.1 tarball
        https://bugs.webkit.org/show_bug.cgi?id=132814

        Reviewed by Carlos Garcia Campos.

        Add missing files and includes to fix the mingw32 build.

        * GNUmakefile.list.am:
        * platform/graphics/win/GraphicsContextCairoWin.cpp:

2014-05-22  Piotr Grad  <p.grad@samsung.com>

        Video is resumed with old playback rate.
        https://bugs.webkit.org/show_bug.cgi?id=132905

        Reviewed by Philippe Normand.

        Setting '0' playback rate is causing pipeline to pause.
        GStreamer player impl. exposed this information to upper layers but it should not.
        Solution is to hidden such situation behind m_playbackRatePause flag.

        Test: media/video-paused-0-rate.html

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::MediaPlayerPrivateGStreamer):
        (WebCore::MediaPlayerPrivateGStreamer::play):
        (WebCore::MediaPlayerPrivateGStreamer::pause):
        (WebCore::MediaPlayerPrivateGStreamer::doSeek):
        (WebCore::MediaPlayerPrivateGStreamer::updatePlaybackRate):
        (WebCore::MediaPlayerPrivateGStreamer::paused):
        (WebCore::MediaPlayerPrivateGStreamer::setRate):
        (WebCore::MediaPlayerPrivateGStreamer::updateStates):
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.h:

2014-04-30  Víctor Manuel Jáquez Leal  <vjaquez@igalia.com>

        [GStreamer] Use GstMetaVideo
        https://bugs.webkit.org/show_bug.cgi?id=132247

        Reviewed by Philippe Normand.

        In WebKitVideoSink we announce the usage of GstMetaVideo, but we do
        not use it when handling the video frames. This might break
        some decoders and filters that rely on buffer's meta, rather
        that in the caps structures.

        This patch enables the use of GstMetaVideo through the GstVideoFrame
        API. And it is used everywhere the buffer mapping is required.

        Also this patch changes to nullptr where zeros were used.

        Also, compile conditionally the video buffer conversion when it is
        ARGB/BGRA, since it is only required for the Cairo backend.

        No new tests, already covered by current tests.

        * platform/graphics/gstreamer/GStreamerUtilities.cpp:
        (WebCore::getVideoSizeAndFormatFromCaps): init the GstVideoInfo before
        used and remove caps fixate check since it is done by
        gst_video_info_from_caps().
        * platform/graphics/gstreamer/ImageGStreamer.h:
        * platform/graphics/gstreamer/ImageGStreamerCairo.cpp:
        (ImageGStreamer::ImageGStreamer): use GstVideoFrame for buffer mapping
        and unmapping.
        (ImageGStreamer::~ImageGStreamer): ditto.
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamerBase.cpp:
        (WebCore::MediaPlayerPrivateGStreamerBase::updateTexture): ditto.
        (WebCore::MediaPlayerPrivateGStreamerBase::currentVideoSinkCaps):
        return nullptr if failed.
        * platform/graphics/gstreamer/VideoSinkGStreamer.cpp:
        (webkitVideoSinkRender): rely on GstVideoInfo rather than on the
        caps. Use GstVideoFrame for buffer mapping and unmapping. Add guards
        for buffer transformation, since it's only used by Cairo.
        (webkitVideoSinkDispose): remove glib version guards.
        (webkitVideoSinkSetCaps): update the value of the private
        GstVideoInfo.

2014-05-06  Myles C. Maxfield  <mmaxfield@apple.com>

        Dragging text from one paragraph to another does not render as expected
        https://bugs.webkit.org/show_bug.cgi?id=132633

        Reviewed by Darin Adler and Ryosuke Niwa.

        When we are dragging and dropping into a content editable field, we detect
        if we are trying to put a <p> into an existing <p>, and if so, split the
        outer <p> and insert the new <p> as its sibling. However, the outer <p>
        might not be editable, so we don't want to do any splitting and inserting
        at that location.

        Test: editing/pasteboard/drag-drop-paragraph-crasher.html

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::makeInsertedContentRoundTrippableWithHTMLTreeBuilder):

2014-05-07  Carlos Garcia Campos  <cgarcia@igalia.com>

        [SOUP] TLSErrors do not cause page load to fail when not ignored
        https://bugs.webkit.org/show_bug.cgi?id=121548

        Reviewed by Sergio Villar Senin.

        This only happens in case of redirection, when the initial URL is
        an HTTPS site with an invalid certificate, that redirects to
        another location. We are starting the redirection without checking
        the TLS errors.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::sendRequestCallback): Check TLS errors before starting a
        possible redirection.

2014-05-05  Zan Dobersek  <zdobersek@igalia.com>

        [Soup] Use std::unique_ptr<char[]> for the read buffer in SocketStreamHandle
        https://bugs.webkit.org/show_bug.cgi?id=132559

        Reviewed by Carlos Garcia Campos.

        Manage the read buffer array through a std::unique_ptr<char[]> object.
        This avoids handling with the raw pointer and also ensures that the memory
        allocated with the new[] operator is deleted with the delete[] operator,
        a problem exposed by the AddressSanitizer in WebSocket tests.

        * platform/network/soup/SocketStreamHandle.h:
        * platform/network/soup/SocketStreamHandleSoup.cpp:
        (WebCore::SocketStreamHandle::SocketStreamHandle):
        (WebCore::SocketStreamHandle::connected):
        (WebCore::SocketStreamHandle::readBytes):
        (WebCore::SocketStreamHandle::platformClose):

2014-04-22  Brent Fulgham  <bfulgham@apple.com>

        Check (rather than assume) element is a RenderTableSection before using it
        https://bugs.webkit.org/show_bug.cgi?id=121858

        Reviewed by David Kilzer.

        Test: fast/table/table-insert-object-before-td-crash.html

        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::addChild): Check that lastBox is a table section before
        using the node as if it was one.

2014-04-19  Alexey Proskuryakov  <ap@apple.com>

        Crashes in HTMLFormElement::submit.
        https://bugs.webkit.org/show_bug.cgi?id=131910
        <rdar://problem/15661790>

        Based on a patch by Kent Tamura.

        Reviewed by Anders Carlsson.

        Tests: fast/forms/form-submission-crash-2.html
               fast/forms/form-submission-crash.html

        Code that executes arbitrary JS needs to protect objects that it uses afterwards.

        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::prepareForSubmission):
        (WebCore::HTMLFormElement::submit):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::submitForm):

2014-04-18  Jon Honeycutt  <jhoneycutt@apple.com>

        Harden RenderInline::inlineElementContinuation()

        <https://bugs.webkit.org/show_bug.cgi?id=131858>

        Reviewed by Sam Weinig.

        No new tests, as there are no known cases of this happening.

        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::inlineElementContinuation):
        Return nullptr if the continuation is neither a RenderInline nor a
        RenderBlock.

2014-04-17  Darin Adler  <darin@apple.com>

        origin spoofing possible (HTTP Origin, postMessage event.origin) due to inappropriate URL escape sequence decoding
        https://bugs.webkit.org/show_bug.cgi?id=131837
        rdar://problem/15211936

        Reviewed by Anders Carlsson and Dave Hyatt.

        Tests: fast/dom/DOMURL/parsing.html
               fast/dom/HTMLAnchorElement/anchor-element-href-parsing.html

        * platform/URL.cpp:
        (WebCore::URL::host): Removed unnecessary call to decodeURLEscapeSequences, which caused
        problems and was not needed.

2014-04-03  David Hyatt  <hyatt@apple.com>

        Continuations casting issue.
        https://bugs.webkit.org/show_bug.cgi?id=130057
        <rdar://problem/16283406>

        Reviewed by Simon Fraser.

        The code to update relative positioned anonymous block continuations should not
        have assumed that all siblings were RenderBlocks. Make the code smarter and
        make it bail when it hits something that isn't part of the block continuation
        chain.

        Added fast/block/continuation-crash.html

        * rendering/RenderInline.cpp:
        (WebCore::updateStyleOfAnonymousBlockContinuations):

2014-04-14  Jon Honeycutt  <jhoneycutt@apple.com>

        Assertion failure under FEImage::determineAbsolutePaintRect()

        <https://bugs.webkit.org/show_bug.cgi?id=131660>
        <rdar://problem/15669294>

        This patch merges Chromium r149536 (see
        <https://chromiumcodereview.appspot.com/14701012>), which moves
        m_absoluteTransform out of SVGFilter and into the base Filter class, so
        that it isn't necessary to cast a Filter to SVGFilter to get the
        absolute transform.

        Reviewed by Geoffrey Garen.

        Test: svg/filters/feImage-filter-assertion.html

        * platform/graphics/filters/Filter.h:
        (WebCore::Filter::Filter):
        Changed to take the absolute transform.
        (WebCore::Filter::absoluteTransform):
        Moved from SVGFilter.
        (WebCore::Filter::mapAbsolutePointToLocalPoint):
        Ditto.

        * rendering/FilterEffectRenderer.cpp:
        (WebCore::FilterEffectRenderer::FilterEffectRenderer):
        Pass a default AffineTransform() to the Filter base class.

        * svg/graphics/filters/SVGFEImage.cpp:
        (WebCore::FEImage::determineAbsolutePaintRect):
        Use the Filter without casting it to SVGFilter.
        (WebCore::FEImage::platformApplySoftware):
        Ditto.

        * svg/graphics/filters/SVGFilter.cpp:
        (WebCore::SVGFilter::SVGFilter):
        Pass the transform to the base class, and remove initialization of a
        removed member var.

        * svg/graphics/filters/SVGFilter.h:
        Member var moved to Filter.h.

2014-04-14  Jon Honeycutt  <jhoneycutt@apple.com>

        Assertion failure !node || node->isElementNode() in
        WebCore::RenderBlock::inlineElementContinuation
  
        https://bugs.webkit.org/show_bug.cgi?id=108829
        <rdar://problem/13666405>
  
        I can't reproduce this assertion failure, but there seems to be an
        invalid assumption in RenderBlock::inlineElementContinuation() that
        anything with the "isInline()" bit set is a RenderInline.
        
        No new test because the test case in the bug does not repro for me.

        Reviewed by Brent Fulgham.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::inlineElementContinuation):
        Dave Hyatt says that this function should only return RenderInline
        objects (not non-RenderInline inline objects), so update the checks
        from isInline() to isRenderInline() before casting with
        toRenderInline().

        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::inlineElementContinuation):
        Ditto.

2014-04-11  Jon Honeycutt  <jhoneycutt@apple.com>

        Assertion failure changing select element size during focus event
        dispatch
        <https://bugs.webkit.org/show_bug.cgi?id=131566>
        <rdar://problem/16400735>

        Reviewed by Andy Estes.

        Test: fast/forms/select-change-size-during-focus.html

        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::listBoxDefaultEventHandler):
        Adopt the fix from Chromium r171216; check that the renderer is still
        of the expected type, and return early if it is not.

2014-04-08  Jon Honeycutt  <jhoneycutt@apple.com>

        Assertion failure in WebCore::FlexBoxIterator::next()
        <https://bugs.webkit.org/show_bug.cgi?id=117176>
        <rdar://problem/14054549>

        Code added in r115687 began removing anonymous wrappers when children
        become inline. However, there are some objects, like
        RenderDeprecatedFlexBox, whose children should always be blocks.

        Reviewed by Tim Horton.

        * rendering/RenderBlock.h:
        (WebCore::RenderBlock::canCollapseAnonymousBlockChild):
        Made public.

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::removeAnonymousWrappersForInlinesIfNecessary):
        Return early if we can't collapse anonymous block children.

2014-04-07  Jon Honeycutt  <jhoneycutt@apple.com>

        Assertion failure, !node || node->isElementNode(), in
        WebCore::RenderBlock::clone()
        <https://bugs.webkit.org/show_bug.cgi?id=110489>
        <rdar://problem/13666425>

        Reviewed by Antti Koivisto.

        We're ending up in RenderBlock::splitBlocks() with |this| ==
        |fromBlock|.  We then try to climb the ancestor block chain from
        this->parent() to |fromBlock|, but this->parent() is already above
        |fromBlock|, so we end up climbing up to the RenderView and trying to
        clone it, causing the assertion failure.

        Adopt Chromium's mitigation for this from
        <https://codereview.chromium.org/13852041>. This is not intended as a
        fix for the underlying issue.

        Also, fix another issue that occurs with this fuzzed test case that's
        not handled by the Chromium fix.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::splitBlocks):
        Ensure while we're in the loop that |curr| is a descendant of
        |fromBlock|. From the Chromium patch:

            We need to check in every iteration of the loop because
            moveChildrenTo could have moved |curr|. This is a mitigation and
            not really a fix against a class of tree craziness.

        Finally, before moving children from |fromBlock| to |toBlock|, ensure
        that the children are children of |fromBlock|. If we never entered the
        loop, they will be siblings of |fromBlock|, not children.

2014-04-17  David Kilzer  <ddkilzer@apple.com>

        Tidy up isIsolatedInline() and highestContainingIsolateWithinRoot()
        <http://webkit.org/b/131117>

        Reviewed by Daniel Bates.

        Based on review feedback for r166650.

        * rendering/InlineIterator.h:
        (WebCore::isIsolatedInline):
        - Switch argument to a reference since it is never called with a
          nullptr.
        (WebCore::highestContainingIsolateWithinRoot):
        - Switch first argument to a reference since it's never a
          nullptr.
        - Use nullptr for pointer initialization.
        - Switch while() loop to for() loop. Pass reference to
          isIsolatedInline().
        (WebCore::numberOfIsolateAncestors):
        - Switch while() loop to for() loop. Pass reference to
          isIsolatedInline().
        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::constructBidiRunsForSegment):
        - Rename startObj to startObject.
        - No longer need to pass the address of startObject here.

2014-04-02  David Kilzer  <ddkilzer@apple.com>

        Use outermost containing isolate when constructing bidi runs
        <http://webkit.org/b/131107>
        <rdar://problem/15690021>

        Reviewed by Darin Adler.

        Merged from Blink (patch by jww@chromium.org):
        https://src.chromium.org/viewvc/blink?revision=157268&view=revision
        http://crbug.com/279277

            Update containingIsolate to go back all the way to top
            isolate from current root, rather than stopping at the first
            isolate it finds. This works because the current root is
            always updated with each isolate run.

        Tests: fast/text/international/unicode-bidi-isolate-nested-with-removes-not-adjacent.html
               fast/text/international/unicode-bidi-isolate-nested-with-removes.html

        * rendering/InlineIterator.h:
        (WebCore::highestContainingIsolateWithinRoot):
        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::constructBidiRunsForSegment):

2014-04-01  Daniel Bates  <dabates@apple.com>

        RenderQuote must destroy remaining text renderer before first letter renderer
        https://bugs.webkit.org/show_bug.cgi?id=78023
        <rdar://problem/10830009>

        Reviewed by Brent Fulgham.

        Merged from Blink (patch by Abhishek Arya):
        https://src.chromium.org/viewvc/blink?view=rev&revision=151270

        Following the fix for <https://bugs.webkit.org/show_bug.cgi?id=114586>, a
        RenderQuote may have child render objects for the first letter of its text
        and everything following the first letter so as to support the CSS first-
        letter property. The latter renderer is responsible for destroying the former
        on destruction. It's sufficient to reverse the destruction of the children of
        RenderQuote to ensure that we destroy the remaining text renderer before we
        destroy the first letter renderer.

        Test: fast/css-generated-content/quote-first-letter-crash.html

        * rendering/RenderQuote.cpp:
        (WebCore::RenderQuote::updateText):

2014-04-01  David Kilzer  <ddkilzer@apple.com>

        Do not allow HTTP refresh headers to refresh to javascript: URLs
        <http://webkit.org/b/119051>
        <rdar://problem/14536453>

        Reviewed by Alexey Proskuryakov.

        Merged from Blink (patch by tsepez@chromium.org):
        https://src.chromium.org/viewvc/blink?revision=153912&view=revision
        http://crbug.com/258151

            This behaviour has been standard in IE since IE7.  This makes us both
            more compatible and less vulnerable to XSS.

        Tests: http/tests/security/no-javascript-location-percent-escaped.html
               http/tests/security/no-javascript-location.html
               http/tests/security/no-javascript-refresh-percent-escaped.php
               http/tests/security/no-javascript-refresh-spaces.php
               http/tests/security/no-javascript-refresh-static-percent-escaped.html
               http/tests/security/no-javascript-refresh-static-spaces.html
               http/tests/security/no-javascript-refresh-static.html
               http/tests/security/no-javascript-refresh.php

        * dom/Document.cpp:
        (WebCore::Document::processHttpEquiv):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::receivedFirstData):
        - Do not fire meta http refresh for a javascript: URL protocol.

2014-03-29  David Kilzer  <ddkilzer@apple.com>

        Preserve selection end positions in directionOfSelection
        <http://webkit.org/b/104813>
        <rdar://problem/13666417>

        Reviewed by Brent Fulgham.

        Merged from Blink (patch by kenrb@chromium.org):
        https://src.chromium.org/viewvc/blink?revision=150621&view=revision
        http://crbug.com/164263

            VisibleSelection::visibleStart() and VisibleSelection::visibleEnd()
            can both cause layouts, which has the potential to invalidate any
            rendertree-based objects. This was causing a problem in
            FrameSelection::directionOfSelection(), where a reference to a
            lineBox was being held across a call to visibleEnd().

            This patch ensures that the any layout is completed before linebox
            references are retrieved.

        Test: editing/selection/layout-during-move-selection-crash.html

        * editing/FrameSelection.cpp:
        (WebCore::FrameSelection::directionOfSelection):

2014-03-28  Radu Stavila  <stavila@adobe.com>

        In some situations, partial layouts of floating elements produce incorrect results.
        https://bugs.webkit.org/show_bug.cgi?id=122668

        Reviewed by David Hyatt.

        When performing partial layout of float elements and checking if other float
        elements are encountered, incorrect results were obtained by not checking
        the size of the existing floats vector.

        Test: fast/block/float/floats-in-clean-line-crash.html

        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::RenderBlockFlow::checkFloatsInCleanLine):

2014-03-28  Myles C. Maxfield  <mmaxfield@apple.com>

        Clear SVGInlineTextBox fragments when the text changes.
        https://bugs.webkit.org/show_bug.cgi?id=130879

        Reviewed by Darin Adler.

        Ported from Blink: https://src.chromium.org/viewvc/blink?revision=150456&view=revision

        This patch modifies SVGInlineTextBox::dirtyLineBoxes to clear all
        following text boxes when invoked. Typically this method is called
        when the underlying text string changes, and that change needs to
        be propagated to all the boxes that use the text beyond the point
        where the text is first modified.
        
        Also cleans up final function keywords for SVGRootInlineBox.

        Test: svg/custom/unicode-in-tspan-multi-svg-crash.html

        * rendering/InlineTextBox.h: Added (non-recursive) dirtyOwnLineBoxes() function
        (WebCore::InlineTextBox::dirtyOwnLineBoxes): Calls dirtyLineBoxes()
        * rendering/svg/SVGInlineTextBox.h: Added (non-recursive) dirtyOwnLineBoxes() function
        (WebCore::SVGInlineTextBox::dirtyOwnLineBoxes):
        * rendering/svg/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::dirtyOwnLineBoxes): Non-recursive part of dirtyLineBoxes()
        (WebCore::SVGInlineTextBox::dirtyLineBoxes): Calls dirtyOwnLineBoxes() in a loop
        * rendering/svg/SVGRootInlineBox.h:

2014-02-02  Andreas Kling  <akling@apple.com>

        Minor SVGRootInlineBox cleanup.
        <https://webkit.org/b/128094>

        Remove two virtual functions and sprinkle some missing overrides.

        Reviewed by Anders Carlsson.

        * rendering/svg/SVGRootInlineBox.h:

2014-03-03  David Kilzer  <ddkilzer@apple.com>

        SVGPropertyTearOffs should detachChildren before deleting its value.
        <http://webkit.org/b/129618>
        <rdar://problem/15661617>

        Reviewed by Maciej Stachowiak.

        Merged from Blink (patch by kouhei@chromium.org):
        https://src.chromium.org/viewvc/blink?revision=158563&view=revision
        http://crbug.com/296276

        Test: svg/transforms/svg-matrix-tearoff-crash.html

        NOTE: The test does not reproduce a crash on WebKit using
        JavaScriptCore.

        * svg/properties/SVGPropertyTearOff.h:
        (WebCore::SVGPropertyTearOff::setValue):
        (WebCore::SVGPropertyTearOff::~SVGPropertyTearOff):
        - Call detachChildren() if m_value is a copy.  The original
          Blink patch did not modify the destructor code path, although
          that seems obvious via code inspection.

2014-03-01  David Kilzer  <ddkilzer@apple.com>

        Fix lifetime handling of SVGPropertyTearOffs
        <http://webkit.org/b/129211>
        <rdar://problem/15696025>

        Reviewed by Maciej Stachowiak.

        Merged from Blink (patch by Ojan Vafai):
        https://src.chromium.org/viewvc/blink?revision=157801&view=revision
        http://crbug.com/288771

            -Replace SVGStaticPropertyWithParentTearOff with SVGMatrixTearOff
            since it's only used in that one place. This means we can get rid
            of the templatizing and the method pointer.
            -Change SVGPropertyTearOff to keep track of it's child tearoffs
            and call detachWrapper on its child tearoffs when it's destroyed
            or when it's wrapper is detached.
            -Have SVGPropertyTearOff hold WeakPtrs to the child tearoffs
            to avoid having a cycle.

        Test: svg/transforms/svg-matrix-tearoff-crash.html

        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/scripts/CodeGeneratorJS.pm:
        (NativeToJSValue):
        * svg/properties/SVGMatrixTearOff.h: Renamed from Source/WebCore/svg/properties/SVGStaticPropertyWithParentTearOff.h.
        (WebCore::SVGMatrixTearOff::create):
        (WebCore::SVGMatrixTearOff::commitChange):
        (WebCore::SVGMatrixTearOff::SVGMatrixTearOff):
        * svg/properties/SVGPropertyTearOff.h:
        (WebCore::SVGPropertyTearOff::addChild):
        (WebCore::SVGPropertyTearOff::detachChildren):

2014-03-25  David Kilzer  <ddkilzer@apple.com>

        Hold a reference to firstSuccessfulSubmitButton in HTMLFormElement::submit
        <http://webkit.org/b/130713>
        <rdar://problem/15661876>

        Reviewed by Darin Adler.

        Merged from Blink (patch by Ian Beer):
        http://crbug.com/303657
        https://src.chromium.org/viewvc/blink?view=rev&revision=158938

        Test: fast/forms/form-submission-crash-successful-submit-button.html

        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::submit):

2014-03-21  Andreas Kling  <akling@apple.com>

        HTMLFrameOwnerElement should obey the SubframeLoadingDisabler when creating subframes
        <rdar://problem/15675780>

        Merge Blink r156744 by Adam Klein.

        Test: fast/frames/set-iframe-src-in-pagehide-crash.html

        * loader/SubframeLoader.cpp:
        (WebCore::SubframeLoader::loadSubframe):

2014-04-13  Youenn Fablet  <youenn.fablet@crf.canon.fr>

        [GStreamer] No CORS support for media elements
        https://bugs.webkit.org/show_bug.cgi?id=99037

        Reviewed by Philippe Normand.

        Added CORS access control check to media sources when crossorigin attribute is set.

        Added getter to CORS access control check status (used to compute whether the stream is tainted or not).
        Related test is http/tests/security/video-cross-origin-readback.html.

        Disabled access to cross-origin streams that fail CORS check when crossorigin attribute is set.
        Related test is http/tests/security/video-cross-origin-accessfailure.html.

        Tests: http/tests/security/video-cross-origin-accessfailure.html
               http/tests/security/video-cross-origin-accesssameorigin.html

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::didPassCORSAccessCheck): Return whether media is cross-origin (tainted) or not by querying the gstreamer source layer.
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.h: Added MediaPlayerPrivateGStreamer::didPassCORSAccessCheck declaration.
        * platform/graphics/gstreamer/WebKitWebSourceGStreamer.cpp:
        (webKitWebSrcStart): Passed CORS mode parameter to the streaming client. In case of CORS check failure, stop the resource loading.
        (webKitSrcPassedCORSAccessCheck): Return whether CORS access control check was done and successful.
        (StreamingClient::handleResponseReceived): Take a parameter to assign the CORS access control check result.
        (CachedResourceStreamingClient::CachedResourceStreamingClient): Updated setting of the ResourceLoaderOptions according CORS mode.
        (CachedResourceStreamingClient::responseReceived): Check CORS and pass result to handleResponseReceived.
        (ResourceHandleStreamingClient::didReceiveResponse): No CORS check.
        * platform/graphics/gstreamer/WebKitWebSourceGStreamer.h: Added webKitSrcPassedCORSAccessCheck declaration.

2014-03-26  Jer Noble  <jer.noble@apple.com>

        REGRESSION(r162679): Poster image visible under the video
        https://bugs.webkit.org/show_bug.cgi?id=130783

        Reviewed by Simon Fraser.

        In the listed revision, we started checking for isRenderImage()
        instead of isImage(). RenderMedias return 'true' for the first
        but 'false' for the second. Change the if() statement to check
        for isRenderMedia() in addition to !isRenderImage().

        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::isDirectlyCompositedImage):

2014-03-21  Oliver Hunt  <oliver@apple.com>

        Fix a crash when assigning an object to document.location
        https://bugs.webkit.org/show_bug.cgi?id=130213

        Reviewed by Geoffrey Garen.

        Convert location to string before we make use the document.
        This prevents us from attempting to navigate a frame that
        has already been removed.

        Test: fast/dom/navigation-with-sideeffects-crash.html

        * bindings/js/JSDocumentCustom.cpp:
        (WebCore::JSDocument::location):
        (WebCore::JSDocument::setLocation):

2014-03-19  Antti Koivisto  <antti@apple.com>

        Crash with long selector list
        https://bugs.webkit.org/show_bug.cgi?id=123006

        Reviewed by Andreas Kling.

        Test: fast/css/long-selector-list-crash.html

        * css/CSSSelectorList.cpp:
        (WebCore::CSSSelectorList::CSSSelectorList):
        (WebCore::CSSSelectorList::adoptSelectorVector):
        (WebCore::CSSSelectorList::operator=):
        * css/StyleRule.cpp:
        (WebCore::StyleRule::create):

            Add a bunch of asserts.

        (WebCore::StyleRule::splitIntoMultipleRulesWithMaximumSelectorComponentCount):
        
            This could produce a zero-length selector list.

2014-03-18  Antti Koivisto  <antti@apple.com>

        Mutating rules returned by getMatchedCSSRules can result in crash
        https://bugs.webkit.org/show_bug.cgi?id=130209

        Reviewed by Andreas Kling.
        
        The non-standard getMatchedCSSRules API returns CSSStyleRule objects that don't
        have parent stylesheet pointer (as we don't know which sheet the rule originated from).
        Mutating the rule via such wrapper can lead to crashes later as we fail to invalidate
        the underlying stylesheet.
        
        Fix by disallowing mutation of style rules that don't have parent sheet pointer. CSSStyleRule
        has two mutable properties selectorText and style. The latter gives back CSSStyleDeclaration.
        This patch disallows mutations in both cases for CSSStyleRules that don't have parent stylesheet
        pointer.
        
        While it is technically possible to have CSSRules that are legitimately disconnected
        from stylesheet (by removing rule from sheet while holding a reference to it) it never
        makes sense to mutate such rule as there is no way to do anything with it afterwards.

        Tests: fast/css/getMatchedCSSProperties-rule-mutation.html
               fast/css/getMatchedCSSRules-crash.html

        * css/CSSStyleRule.cpp:
        (WebCore::CSSStyleRule::setSelectorText):

            Bail out if parent stylesheet is null.

        * css/PropertySetCSSStyleDeclaration.cpp:
        (WebCore::PropertySetCSSStyleDeclaration::setCssText):
        (WebCore::PropertySetCSSStyleDeclaration::setProperty):
        (WebCore::PropertySetCSSStyleDeclaration::removeProperty):
        (WebCore::PropertySetCSSStyleDeclaration::setPropertyInternal):
        
            Allow StyleRuleCSSStyleDeclaration subclass cancel the mutation via
            boolean return value from willMutate.

        (WebCore::StyleRuleCSSStyleDeclaration::willMutate):
        
            Disallow mutation if the owning CSSStyleRule is null or has null stylesheet.

        (WebCore::StyleRuleCSSStyleDeclaration::didMutate):
        
            We never get here with null rule or stylesheet anymore.

        * css/PropertySetCSSStyleDeclaration.h:
        (WebCore::PropertySetCSSStyleDeclaration::willMutate):

2014-03-13  Andreas Kling  <akling@apple.com>

        Don't send synchronous resize events when FrameView has auto-sizing enabled.
        <https://webkit.org/b/130198>
        <rdar://problem/15991333>

        Reviewed by Dan Bernstein.

        * page/FrameView.cpp:
        (WebCore::FrameView::sendResizeEventIfNeeded):

2014-03-08  Oliver Hunt  <oliver@apple.com>

        SerializedScriptValue may move Identifiers between worlds
        https://bugs.webkit.org/show_bug.cgi?id=129979

        Reviewed by Andreas Kling.

        Test: fast/workers/worker-copy-shared-blob-url.html

        Don't use Strings to store blob URLs as String's may be Identifiers
        and they can only exist in one world/thread at a time.

        * Modules/indexeddb/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::put):
        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::CloneDeserializer::deserializeString):
        (WebCore::SerializedScriptValue::addBlobURL):
        (WebCore::SerializedScriptValue::SerializedScriptValue):
        * bindings/js/SerializedScriptValue.h:

2014-03-05  Daniel Bates  <dabates@apple.com>
            And Alexey Proskuryakov  <ap@apple.com>

        ASSERT(newestManifest) fails in WebCore::ApplicationCacheGroup::didFinishLoadingManifest()
        https://bugs.webkit.org/show_bug.cgi?id=129753
        <rdar://problem/12069835>

        Reviewed by Alexey Proskuryakov.

        Fixes an issue where an assertion failure would occur when visiting a web site whose on-disk
        app cache doesn't contain a manifest resource.

        For some reason an app cache for a web site may be partially written to disk. In particular, the
        app cache may only contain a CacheGroups entry. That is, the manifest resource and origin records
        may not be persisted to disk. From looking over the code, we're unclear how such a situation can occur
        and hence have been unable to create such an app cache. We were able to reproduce this issue using
        an app cache database file that was provided by a person that was affected by this issue.

        No test included because it's not straightforward to write a test for this change.

        * loader/appcache/ApplicationCacheGroup.cpp:
        (WebCore::ApplicationCacheGroup::checkIfLoadIsComplete): Assert that m_cacheBeingUpdated->manifestResource()
        is non-null. Currently we only document this assumption in a code comment. Also separated a single assertion
        expression into two assertion expressions to make it straightforward to identify the failing sub-expression
        on failure.
        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::store): Modified to call ApplicationCacheStorage::deleteCacheGroupRecord()
        to remove a cache group and associated cache records (if applicable) before inserting a cache group entry.
        This replacement approach will ultimately repair incomplete app cache data for people affected by this bug.
        (WebCore::ApplicationCacheStorage::loadCache): Log an error and return nullptr if the cache we loaded doesn't
        have a manifest resource.
        (WebCore::ApplicationCacheStorage::deleteCacheGroupRecord): Added.
        (WebCore::ApplicationCacheStorage::deleteCacheGroup): Extracted deletion logic for cache group record into
        ApplicationCacheStorage::deleteCacheGroupRecord().
        * loader/appcache/ApplicationCacheStorage.h:

2014-03-05  David Kilzer  <ddkilzer@apple.com>

        Fix crash in CompositeEditCommand::cloneParagraphUnderNewElement()
        <http://webkit.org/b/129751>
        <rdar://problem/16237965>

        Reviewed by Jon Honeycutt.

        Merged from Blink (patch by Yuta Kitamura):
        https://src.chromium.org/viewvc/blink?revision=168160&view=revision
        http://crbug.com/345005

            The root cause is CompositeEditCommand::moveParagraphWithClones() passing
            two positions |start| and |end| which do not follow the document order,
            i.e. in some situations |start| is located after |end| because of
            the difference in affinity.

            This patch fixes this crash by normalizing |end| to |start| in such situations.
            It also adds an ASSERT that checks the relationship between |start| and |end|.

        Test: editing/execCommand/format-block-crash.html

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::cloneParagraphUnderNewElement):
        (WebCore::CompositeEditCommand::moveParagraphWithClones):
        * editing/CompositeEditCommand.h:

2014-03-01  David Kilzer  <ddkilzer@apple.com>

        Ensure keySplines is valid in SMIL animations
        <http://webkit.org/b/129547>
        <rdar://problem/15676128>

        Reviewed by Darin Adler.

        Merged from Blink (patch by Philip Rogers):
        https://src.chromium.org/viewvc/blink?revision=156452&view=revision
        http://crbug.com/276111

            This patch fixes a crash in SMIL animations when keySplines are not
            specified. The SMIL spec is clear on this:
            http://www.w3.org/TR/2001/REC-smil-animation-20010904/#AnimFuncCalcMode
            "If there are any errors in the keyTimes specification (bad values,
            too many or too few values), the animation will have no effect."

            This patch simply checks that keyTimes is not empty. Previously,
            splinesCount was set to be m_keySplines.size() + 1 in
            SVGAnimationElement.cpp; this patch changes splinesCount to be equal
            to m_keySplines.size() to make the logic easier to follow and to
            match other checks in SVGAnimationElement::startedActiveInterval.

        Test: svg/animations/animate-keysplines-crash.html

        * svg/SVGAnimationElement.cpp:
        (WebCore::SVGAnimationElement::startedActiveInterval):

2014-02-28  Bem Jones-Bey  <bjonesbe@adobe.com>

        Properly clear m_logicallyLastRun to remove use-after-free possibility
        https://bugs.webkit.org/show_bug.cgi?id=129489

        Reviewed by David Hyatt.

        A use-after-free issue was caught in Blink because m_logicallyLastRun
        is not cleared when the item it points to is deleted. Clearing it
        turns the use-after-free into a segfault, and prevents any future
        use-after-frees from happening.

        * platform/text/BidiRunList.h:
        (WebCore::BidiRunList<Run>::deleteRuns):

2014-02-19  Daniel Bates  <dabates@apple.com>

        Do not dispatch change event twice in single step action
        https://bugs.webkit.org/show_bug.cgi?id=116936
        <rdar://problem/16086828>

        Reviewed by Ryosuke Niwa.

        Merged from Blink (patch by Kent Tamura):
        https://src.chromium.org/viewvc/blink?view=rev&revision=151175

        Test: fast/forms/number/number-type-update-by-change-event.html

        * html/InputType.cpp:
        (WebCore::InputType::stepUpFromRenderer):

2014-02-17  Chris Fleizach  <cfleizach@apple.com>

        AX: Invalid cast in WebCore::AccessibilityTable::isDataTable (CRBug 280352)
        <https://webkit.org/b/128925>
        <rdar://problem/16087351>

        Merged from Blink (patch by Dominic Mazzoni):
        https://src.chromium.org/viewvc/blink?revision=159711&view=revision

        Reviewed by Oliver Hunt.

        Don't cast to a table cell element unless we are sure it is one.

        Test: accessibility/display-table-cell-causes-crash.html

        * accessibility/AccessibilityTable.cpp:
        (WebCore::AccessibilityTable::isDataTable):

2014-02-16  Andreas Kling  <akling@apple.com>

        Ensure that removing an iframe from the DOM tree disconnects its Frame.
        <https://webkit.org/b/128889>
        <rdar://problem/15671221>

        Merged from Blink (patch by Adam Klein):
        https://src.chromium.org/viewvc/blink?revision=156174&view=revision

        SubframeLoadingDisabler wasn't catching the case when an <iframe> was,
        in its unload handler, removed and re-added to the same parent.
        Fix this by using a count of SubframeLoadingDisablers that are on the
        stack for a given root, rather than a simple boolean.

        Test: fast/frames/reattach-in-unload.html

        * html/HTMLFrameOwnerElement.h:
        (WebCore::SubframeLoadingDisabler::disabledSubtreeRoots):

2014-02-15  Renata Hodovan  <rhodovan.u-szeged@partner.samsung.com>

        ASSERT_WITH_SECURITY_IMPLICATION in WebCore::toElement
        https://bugs.webkit.org/show_bug.cgi?id=128810

        Reviewed by Ryosuke Niwa.

        Make CompositeEditCommand::cloneParagraphUnderNewElement() to work when |outerNode|
        doesn't contain |start|.

        Before this patch, CompositeEditCommand::cloneParagraphUnderNewElement() tried to copy
        ancestry nodes from |start| to Document node when |start| position isn't in |outerNode|. This
        patch changes CompositeEditCommand::cloneParagraphUnderNewElement() to copy |start| to
        |outerNode| only if |outerNode| contains |start| position.

        Merged from Blink https://src.chromium.org/viewvc/blink?revision=161762&view=revision by yosin@chromium.org.

        Test: editing/execCommand/indent-with-uneditable-crash.html

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::cloneParagraphUnderNewElement):

2014-02-06  Jeffrey Pfau  <jpfau@apple.com>

        loadSubframe can return null in SubframeLoader::loadOrRedirectSubframe
        https://bugs.webkit.org/show_bug.cgi?id=128344

        Reviewed by Ryosuke Niwa.

        * loader/SubframeLoader.cpp:
        (WebCore::SubframeLoader::loadOrRedirectSubframe):

2014-02-04  Jeffrey Pfau  <jpfau@apple.com>

        Make adoption agency use the task queue
        https://bugs.webkit.org/show_bug.cgi?id=109445

        Reviewed by Ryosuke Niwa.

        Tests: fast/parser/adoption-agency-crash-01.html
               fast/parser/adoption-agency-crash-02.html
               fast/parser/adoption-agency-crash-03.html

        * html/parser/HTMLConstructionSite.cpp:
        (WebCore::insert):
        (WebCore::executeInsertTask):
        (WebCore::executeReparentTask):
        (WebCore::executeInsertAlreadyParsedChildTask):
        (WebCore::executeTakeAllChildrenTask):
        (WebCore::executeTask):
        (WebCore::HTMLConstructionSite::attachLater):
        (WebCore::HTMLConstructionSite::executeQueuedTasks):
        (WebCore::HTMLConstructionSite::insertTextNode):
        (WebCore::HTMLConstructionSite::reparent):
        (WebCore::HTMLConstructionSite::insertAlreadyParsedChild):
        (WebCore::HTMLConstructionSite::takeAllChildren):
        (WebCore::HTMLConstructionSite::fosterParent):
        * html/parser/HTMLConstructionSite.h:
        (WebCore::HTMLConstructionSiteTask::HTMLConstructionSiteTask):
        (WebCore::HTMLConstructionSiteTask::oldParent):
        * html/parser/HTMLTreeBuilder.cpp:
        (WebCore::HTMLTreeBuilder::callTheAdoptionAgency):

2014-02-04  Myles C. Maxfield  <mmaxfield@apple.com>

        Move characterAt index checks from InlineIterator to RenderText
        https://bugs.webkit.org/show_bug.cgi?id=128224

        Reviewed by Simon Fraser.

        Move characterAt index checks from InlineIterator to RenderText
        so that all RenderText calls are covered. Few safe instances are
        now covered with uncheckedCharacterAt.

        Merged from Blink:
        http://src.chromium.org/viewvc/blink?view=revision&revision=150830

        Test: fast/text/character-at-crash.html

        * rendering/InlineIterator.h:
        (WebCore::InlineIterator::characterAt):
        * rendering/RenderText.cpp:
        (WebCore::RenderText::computePreferredLogicalWidths):
        * rendering/RenderText.h:
        (WebCore::RenderText::operator[]):
        (WebCore::RenderText::uncheckedCharacterAt):
        (WebCore::RenderText::characterAt):

2014-04-12  Youenn Fablet  <youenn.fablet@crf.canon.fr>

        [SOUP] Libsoup internal credential setting should be controlled by loader decision
        https://bugs.webkit.org/show_bug.cgi?id=130963

        Reviewed by Darin Adler.

        Disabled libsoup internal authentication manager for messages for which no credential is available and no stored credentials should be used.
        Updated synchronous loader to return whether using credentials or not according StoredCredential loader option parameter.
        Unskipped test http/tests/xmlhttprequest/cross-origin-no-authorization.html covers the patch.

        * platform/network/ResourceHandleInternal.h:
        (WebCore::ResourceHandleInternal::ResourceHandleInternal): Added m_useAuthenticationManager boolean to control whether disable authentication manager or not.
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::WebCoreSynchronousLoader::WebCoreSynchronousLoader): Added m_storedCredentials member.
        (WebCore::WebCoreSynchronousLoader::shouldUseCredentialStorage): Return true if stored credentials are allowed.
        (WebCore::applyAuthenticationToRequest): Set m_useAuthenticationManager value to disable authentication manager if cannot use stored credentials and ResourceHandleInternal has no username and password.
        (WebCore::createSoupMessageForHandleAndRequest): Disable authentication mananger according m_useAuthenticationManager value.
        (WebCore::ResourceHandle::platformLoadResourceSynchronously): Added StoredCredentials loader option to the sync loader constructor.

2014-04-08  Youenn Fablet  <youenn.fablet@crf.canon.fr>

        [SOUP] Control cookie management according ResourceRequest.allowCookies()
        https://bugs.webkit.org/show_bug.cgi?id=131026

        Reviewed by Sergio Villar Senin.

        Added per soup-message disabling of cookie jar manager when related ResourceRequest does not allow cookies (e.g. some cross-origin requests).

        Patch is covered by unskipped test http/tests/xmlhttprequest/cross-origin-cookie-storage.html.

        * platform/network/soup/ResourceRequestSoup.cpp:
        (WebCore::ResourceRequest::updateSoupMessageMembers): Added disabling of cookie jar manager if cookies are not allowed.

2014-04-11  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. [GTK] Plugin process crashes when loading totem plugin
        https://bugs.webkit.org/show_bug.cgi?id=131357

        Make Netscape browser functions static to avoid conflicts with
        plugins defining those functions as well.

        * GNUmakefile.list.am: Do not build npapi.cpp.
        * plugins/PluginPackage.cpp:
        (WebCore::pluginViewForInstance):
        (WebCore::NPN_MemAlloc):
        (WebCore::NPN_MemFree):
        (WebCore::NPN_MemFlush):
        (WebCore::NPN_ReloadPlugins):
        (WebCore::NPN_RequestRead):
        (WebCore::NPN_GetURLNotify):
        (WebCore::NPN_GetURL):
        (WebCore::NPN_PostURLNotify):
        (WebCore::NPN_PostURL):
        (WebCore::NPN_NewStream):
        (WebCore::NPN_Write):
        (WebCore::NPN_DestroyStream):
        (WebCore::NPN_UserAgent):
        (WebCore::NPN_Status):
        (WebCore::NPN_InvalidateRect):
        (WebCore::NPN_InvalidateRegion):
        (WebCore::NPN_ForceRedraw):
        (WebCore::NPN_GetValue):
        (WebCore::NPN_SetValue):
        (WebCore::NPN_GetJavaEnv):
        (WebCore::NPN_GetJavaPeer):
        (WebCore::NPN_PushPopupsEnabledState):
        (WebCore::NPN_PopPopupsEnabledState):
        (WebCore::NPN_PluginThreadAsyncCall):
        (WebCore::NPN_GetValueForURL):
        (WebCore::NPN_SetValueForURL):
        (WebCore::NPN_GetAuthenticationInfo):
        (WebCore::NPN_PopUpContextMenu):
        * plugins/PluginPackage.h:
        (WebCore::PluginPackage::browserFuncs): Add accessor to browser
        function pointers.
        * plugins/PluginView.cpp:
        (WebCore::PluginView::stop): Use browser function pointers instead
        of NPN wrappers that are now private.
        (WebCore::PluginView::getValueForURL): Ditto.

2014-04-01  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Readonly attributes installed as readwrite in GObject DOM bindings
        https://bugs.webkit.org/show_bug.cgi?id=130978

        Reviewed by Carlos Garcia Campos.

        Unify how we decide if an attribute is readable or writeable and improve the code.
        This results in some attributes now being marked as read-only which didn't have
        corresponding case statements in the set_property switch statements and also correctly
        installs set_property support for some more POD types.

        * bindings/scripts/CodeGeneratorGObject.pm:
        (IsPropertyReadable): Added this helper to simplify deciding if an attribute is readable.
        (IsPropertyWriteable): Added this helper to simplify deciding if an attribute is writeable. Also
        update the list of types to reflect the full list of types we can generate setters for.
        (GenerateProperty): Use the IsPropertyWriteable helper instead of checking whether the attribute is read-only.
        Also fix generation of the blurb by using $mutableString instead of $mutableStringconst which isn't used.
        (GenerateProperties): Use grep and the new helpers to simplify the code.
        (GetReadableProperties): Deleted.
        (GetWriteableProperties): Deleted.
        * bindings/scripts/test/GObject: Update results

2014-03-30  Xabier Rodriguez Calvar  <calvaris@igalia.com>

        [GTK] [TextureMapper] Weird brightness with some videos with acceletared compositing
        https://bugs.webkit.org/show_bug.cgi?id=130665

        Reviewed by Martin Robinson.

        When we uploaded a video texture to the mapper we were not
        considering that some videos could be decoded into a format
        without alpha component. Now we check if the video has alpha and
        if it does not, we remove the alpha flag when retrieving the
        texture from the pool. For this, the method to get the texture
        from the pool was modified to receive the flags, that is mapped to
        have alpha by default in order not to break any other existing
        code.

        Though we have a problem with AC in WTR and that makes it
        currently not testable, no new tests are needed because once this
        is fixed the current test set suffices to detect a possible
        regression in this.

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamerBase.cpp:
        (WebCore::MediaPlayerPrivateGStreamerBase::updateTexture): Check
        the video format and decide if the texture shall be pulled with
        alpha support or not.
        * platform/graphics/texmap/TextureMapper.cpp:
        (WebCore::TextureMapper::acquireTextureFromPool): Use the flags
        when resetting the texture.
        * platform/graphics/texmap/TextureMapper.h:
        (WebCore::BitmapTexture::Flag::None): Added with 0x00.
        (WebCore::TextureMapper::acquireTextureFromPool): Added flag
        parameter to set up the texture with the default for including
        alpha channel.

2014-03-28  Mario Sanchez Prada  <mario.prada@samsung.com>

        [GTK] Geoclue2 providers won't work after reloading
        https://bugs.webkit.org/show_bug.cgi?id=130898

        Reviewed by Martin Robinson.

        Don't reuse the Geoclue2 client proxy between different calls to
        startPosition(), and create a new client proxy each time instead.

        * platform/geoclue/GeolocationProviderGeoclue2.cpp:
        (GeolocationProviderGeoclue::startUpdating): Don't reuse the
        client proxy, by always calling geoclue_manager_call_get_client().
        (GeolocationProviderGeoclue::stopUpdating): Disconnect from the
        'location-updated' signal and dispose the client proxy.

2014-03-28  Diego Pino Garcia  <dpino@igalia.com>

        [GTK] Too many redirects visiting www.globalforestwatch.org
        https://bugs.webkit.org/show_bug.cgi?id=129681

        Reviewed by Martin Robinson.

        * platform/gtk/UserAgentGtk.cpp:
        (WebCore::standardUserAgent): Append Safari version to UserAgent
        string.

2014-03-19  Claudio Saavedra  <csaavedra@igalia.com>

        [GStreamer] Clean timeout source ids
        https://bugs.webkit.org/show_bug.cgi?id=130450

        Reviewed by Philippe Normand.

        Sources IDs need to be cleaned up if the callback removes the
        source, otherwise we'll be attempting to remove an empty source at
        some point.

        * platform/graphics/gstreamer/WebKitMediaSourceGStreamer.cpp:
        (webKitMediaVideoSrcStart): Clean the source id.
        (webKitMediaAudioSrcStart): Ditto.
        (webKitMediaVideoSrcSeekMainCb): Ditto.
        (webKitMediaAudioSrcSeekMainCb): Ditto.

2014-03-12  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] [Stable] deadlock in gobject introspection
        https://bugs.webkit.org/show_bug.cgi?id=125651

        Reviewed by Sergio Villar Senin.

        Make the default SoupNetworkSession a destroyable object to ensure
        the wrapped SoupSession is finalized when the process finishes. This
        is important because soup cancels any ongoing connection when finalized.

        * platform/network/soup/SoupNetworkSession.cpp:
        (WebCore::SoupNetworkSession::defaultSession): Do not use NeverDestroyed.
        * platform/network/soup/SoupNetworkSession.h:

2014-03-10  Mario Sanchez Prada  <mario.prada@samsung.com>

        [GTK] Add support for Geoclue2
        https://bugs.webkit.org/show_bug.cgi?id=120185

        Reviewed by Carlos Garcia Campos.

        Patch by Anton Obzhirov <a.obzhirov@samsung.com> and Mario Sanchez Prada <mario.prada@samsung.com>

        Implement a new geolocation provider based on Geoclue2, which will only
        be used if a good enough version of Geoclue2 is found  at configure time.

        * GNUmakefile.am: Generate C-API for accessing the D-Bus API
        provided by Geoclue2, and place it in DerivedSources.
        * GNUmakefile.list.am: Add GeolocationProviderGeoclue2.cpp, and
        include the generated proxy files when using Geoclue2.
        * PlatformGTK.cmake: Likewise, for CMake based builds.
        * platform/geoclue/GeolocationProviderGeoclue.h: Modified to
        accomodate the needs both for Geoclue and Geoclue2 providers.
        * platform/geoclue/GeolocationProviderGeoclue1.cpp: Renamed from Source/WebCore/platform/geoclue/GeolocationProviderGeoclue.cpp.
        (GeolocationProviderGeoclue::getPositionCallback):
        (GeolocationProviderGeoclue::positionChangedCallback):
        (GeolocationProviderGeoclue::createGeocluePositionCallback):
        (GeolocationProviderGeoclue::geoclueClientSetRequirementsCallback):
        (GeolocationProviderGeoclue::createGeoclueClientCallback):
        (GeolocationProviderGeoclue::GeolocationProviderGeoclue):
        (GeolocationProviderGeoclue::~GeolocationProviderGeoclue):
        (GeolocationProviderGeoclue::startUpdating):
        (GeolocationProviderGeoclue::stopUpdating):
        (GeolocationProviderGeoclue::setEnableHighAccuracy):
        (GeolocationProviderGeoclue::initializeGeoclueClient):
        (GeolocationProviderGeoclue::initializeGeocluePosition):
        (GeolocationProviderGeoclue::updateClientRequirements):
        (GeolocationProviderGeoclue::positionChanged):
        (GeolocationProviderGeoclue::errorOccurred):
        * platform/geoclue/GeolocationProviderGeoclue2.cpp: Added.
        (GeolocationProviderGeoclue::GeolocationProviderGeoclue):
        (GeolocationProviderGeoclue::~GeolocationProviderGeoclue):
        (GeolocationProviderGeoclue::startUpdating):
        (GeolocationProviderGeoclue::stopUpdating):
        (GeolocationProviderGeoclue::setEnableHighAccuracy):
        (GeolocationProviderGeoclue::createGeoclueManagerProxyCallback):
        (GeolocationProviderGeoclue::getGeoclueClientCallback):
        (GeolocationProviderGeoclue::createGeoclueClientProxyCallback):
        (GeolocationProviderGeoclue::startClientCallback):
        (GeolocationProviderGeoclue::locationUpdatedCallback):
        (GeolocationProviderGeoclue::createLocationProxyCallback):
        (GeolocationProviderGeoclue::startGeoclueClient):
        (GeolocationProviderGeoclue::updateLocation):
        (GeolocationProviderGeoclue::errorOccurred):
        (GeolocationProviderGeoclue::updateClientRequirements):

2014-03-07  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Timeout sources not correctly removed
        https://bugs.webkit.org/show_bug.cgi?id=129877

        Reviewed by Philippe Normand.

        Set source ID variables to 0 after removing the sources from the
        context. Also give a name to the sources.

        * platform/graphics/gstreamer/TrackPrivateBaseGStreamer.cpp:
        (WebCore::TrackPrivateBaseGStreamer::disconnect):
        (WebCore::TrackPrivateBaseGStreamer::activeChanged):
        (WebCore::TrackPrivateBaseGStreamer::tagsChanged):
        (WebCore::TrackPrivateBaseGStreamer::notifyTrackOfActiveChanged):

2014-03-03  Lorenzo Tilve  <ltilve@igalia.com>

        Optimize StylePropertiesSet::findPropertyIndex() to improve CSS properties performance
        https://bugs.webkit.org/show_bug.cgi?id=129605

        Reviewed by Andreas Kling.

        Merged from Blink (patch by Mikhail Pozdnyakov):
        https://src.chromium.org/viewvc/blink?view=revision&revision=167325

        Avoid checking whether 'StylePropertiesSet' is mutable and accesing directly to its
        data members to achieve performance improvements

        Before the optimization applied:
            mean: 3064.8337171934063 runs/s
            median: 3097.5899379343855 runs/s
            stdev: 66.89274074044187 runs/s
            min: 2891.7479324362585 runs/s
            max: 3113.288683440125 runs/s

        After the optimization applied:
            mean: 3343.8356114138105 runs/s
            median: 3356.25682957446 runs/s
            stdev: 36.297533087489036 runs/s
            min: 3238.5468032264243 runs/s
            max: 3368.664837531425 runs/s

        Performance gain for the average value is approx. 9.1%, in the
        range of the 10% - 8.2% for the min and max measured
        values (Linux desktop x64).

        * css/StyleProperties.cpp:
        (WebCore::ImmutableStyleProperties::findPropertyIndex):
        (WebCore::MutableStyleProperties::findPropertyIndex):
        * css/StyleProperties.h:
        (WebCore::toMutableStyleProperties):
        (WebCore::toImmutableStyleProperties):
        (WebCore::StyleProperties::findPropertyIndex):

2014-03-03  Tomas Popela  <tpopela@redhat.com>

        [GTK] webkit_dom_range_compare_boundary_points fails when 0 is passed as how parameter
        https://bugs.webkit.org/show_bug.cgi?id=129145

        Reviewed by Carlos Garcia Campos.

        While generating GObject DOM API the generator should skip non pointer
        types while generating the g_return_val_if_fail macro.
        This will avoid the situation when Range.START_TO_START is defined as 0,
        thus the webkit_dom_range_compare_boundary_points function will fail
        everytime it is called with 0 as how value.

        * bindings/scripts/CodeGeneratorGObject.pm:
        (GenerateFunction):

2014-02-06  Koop Mast <kwm@FreeBSD.org>

        Use system default compiler instead of gcc, as final fall through.
        https://bugs.webkit.org/show_bug.cgi?id=126773

        Reviewed by Alexey Proskuryakov.

        * dom/make_names.pl:

2014-02-17  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am: Add missing header files.

2014-02-11  Piotr Grad  <p.grad@samsung.com>

        [GStreamer] High playback rate causes crash
        https://bugs.webkit.org/show_bug.cgi?id=128453

        Reviewed by Philippe Normand.

        To high playback rate passed to GStreamer was causing crash.
        Added guard in setRate method.

        Test: media/video-extreme-playbackrate-crash.html

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::setRate):

2014-02-10  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GLIB] Add GUniqueOutPtr and use it instead of GOwnPtr
        https://bugs.webkit.org/show_bug.cgi?id=127554

        Reviewed by Gustavo Noronha Silva.

        Use GUniqueOutPtr instead of GOwnPtr.

        * GNUmakefile.list.am:
        * PlatformEfl.cmake:
        * PlatformGTK.cmake:
        * platform/audio/gstreamer/AudioDestinationGStreamer.cpp:
        (WebCore::AudioDestinationGStreamer::handleMessage):
        * platform/audio/gstreamer/AudioFileReaderGStreamer.cpp:
        (WebCore::AudioFileReader::handleMessage):
        * platform/glib/BatteryProviderUPower.cpp:
        (BatteryProviderUPower::startUpdating):
        * platform/graphics/gstreamer/GStreamerUtilities.cpp:
        (WebCore::initializeGStreamer):
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::handleMessage):
        * platform/graphics/gstreamer/TrackPrivateBaseGStreamer.cpp:
        (WebCore::TrackPrivateBaseGStreamer::getTag):
        * platform/graphics/gtk/ImageBufferGtk.cpp:
        (WebCore::encodeImage):
        (WebCore::ImageBuffer::toDataURL):
        * platform/graphics/gtk/ImageGtk.cpp:
        (WebCore::loadResourceSharedBuffer):
        * platform/gtk/DataObjectGtk.cpp:
        (WebCore::DataObjectGtk::setURIList):
        * platform/gtk/FileSystemGtk.cpp:
        (WebCore::readFromFile):
        * platform/gtk/GamepadsGtk.cpp:
        (WebCore::GamepadDeviceGtk::readCallback):
        * platform/gtk/GtkInputMethodFilter.cpp:
        (WebCore::GtkInputMethodFilter::handlePreeditChanged):
        * platform/gtk/PasteboardHelper.cpp:
        (WebCore::PasteboardHelper::fillDataObjectFromDropData):
        * platform/gtk/RenderThemeGtk.cpp:
        (WebCore::RenderThemeGtk::systemFont):
        * platform/gtk/SharedBufferGtk.cpp:
        (WebCore::SharedBuffer::createWithContentsOfFile):
        * platform/network/gtk/CredentialBackingStore.cpp:
        (WebCore::credentialForChallengeAsyncReadyCallback):
        * platform/network/soup/GOwnPtrSoup.cpp: Removed.
        * platform/network/soup/GOwnPtrSoup.h: Removed.
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::redirectSkipCallback):
        (WebCore::nextMultipartResponsePartCallback):
        (WebCore::sendRequestCallback):
        (WebCore::addFileToSoupMessageBody):
        (WebCore::createSoupRequestAndMessageForHandle):
        (WebCore::readCallback):
        * platform/network/soup/SocketStreamHandleSoup.cpp:
        (WebCore::SocketStreamHandle::platformSend):
        (WebCore::SocketStreamHandle::platformClose):
        (WebCore::connectedCallback):
        (WebCore::readReadyCallback):
        * platform/network/soup/SoupNetworkSession.cpp:
        (WebCore::SoupNetworkSession::httpProxy):

2014-02-09  Carlos Garnacho  <carlosg@gnome.org>

        [GTK] Add touch-events related code to build
        https://bugs.webkit.org/show_bug.cgi?id=98931

        Reviewed by Carlos Garcia Campos.

        Tests in fast/events/touch have been enabled on GTK+ now that touch
        support is implemented, and thus all expected bits are there.

        * platform/gtk/GtkTouchContextHelper.cpp:
        * platform/gtk/GtkTouchContextHelper.h: Add helper object to track all touchpoints, handy
        when creating WebTouchEvents.
        * GNUmakefile.list.am:
        * PlatformGTK.cmake:
        * bindings/gobject/GNUmakefile.am: Add touch related code and idls to build, those are
        necessary now that GTK+ implements touch events.

2014-02-05  Ryuan Choi  <ryuan.choi@samsung.com>

        MediaPlayerPrivateGStreamerBase should have virtual destructor
        https://bugs.webkit.org/show_bug.cgi?id=128238

        Reviewed by Carlos Garcia Campos.

        MediaPlayerPrivateGStreamer inherit MediaPlayerPrivateGStreamerBase.
        So MediaPlayerPrivateGStreamerBase should have virtual destructor.

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamerBase.h: Made destructor as virtual.

2014-02-03  Radu Stavila  <stavila@adobe.com>

        REGRESSION (r163018): Can’t scroll in <select> lists
        https://bugs.webkit.org/show_bug.cgi?id=128090

        The regression was caused by the fact that a new method scrollWithWheelEventLocation() was added
        to RenderBox to replace the generic scroll() method for the particular case of scrolling using 
        the mouse wheel. This turned out to be a mistake because in the case of some elements, like select lists, 
        the scroll method was overriden and now the incorrect method was being called.
        The solution was to remove the new method and just add two default parameters to the generic
        scroll method.

        Reviewed by Simon Fraser.

        Test: fast/scrolling/scroll-select-list.html

        * page/EventHandler.cpp:
        (WebCore::scrollNode):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::scroll):
        * rendering/RenderBox.h:
        * rendering/RenderEmbeddedObject.cpp:
        (WebCore::RenderEmbeddedObject::scroll):
        * rendering/RenderEmbeddedObject.h:
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::scroll):
        * rendering/RenderListBox.h:
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::scroll):
        * rendering/RenderTextControlSingleLine.h:

2014-02-05  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am:

2014-02-04  Zan Dobersek  <zdobersek@igalia.com>

        Partially revert r162947 so that Document::topDocument() again Walk over the chain of
        owner Elements. This fixes the crashes related to creating and accessing the AXObjectCache
        of documents that were introduced in that revision, which determined the top document by
        returning the Document of the main frame. This fails badly when the frame in question is cached.

        * dom/Document.cpp:
        (WebCore::Document::topDocument):

2014-01-31  Anders Carlsson  <andersca@apple.com>

        Don't allocate a new XMLHttpRequestStaticData every time staticData() is called
        https://bugs.webkit.org/show_bug.cgi?id=127996

        Reviewed by Andreas Kling.

        std::once_flag should be static.

        * xml/XMLHttpRequest.cpp:
        (WebCore::staticData):

2014-01-30  Csaba Osztrogonác  <ossy@webkit.org>

        [SOUP] Fix the build if !ENABLE(WEB_TIMING)
        https://bugs.webkit.org/show_bug.cgi?id=127906

        Reviewed by Gustavo Noronha Silva.

        * platform/network/soup/SoupNetworkSession.cpp:

2014-01-29  Csaba Osztrogonác  <ossy@webkit.org>

        Remove ENABLE(JAVASCRIPT_DEBUGGER) leftovers
        https://bugs.webkit.org/show_bug.cgi?id=127845

        Reviewed by Joseph Pecoraro.

        * Configurations/FeatureDefines.xcconfig:
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::JSDOMWindowBase::supportsProfiling):

2014-01-29  Dan Bernstein  <mitz@apple.com>

        Fixed the iOS build.

        * bindings/js/JSDOMWindowCustom.cpp: Updated for header renames.

2014-01-29  Csaba Osztrogonác  <ossy@webkit.org>

        Remove ENABLE(JAVASCRIPT_DEBUGGER) guards
        https://bugs.webkit.org/show_bug.cgi?id=127840

        Reviewed by Mark Lam.

        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::JSDOMWindowBase::supportsProfiling):
        (WebCore::JSDOMWindowBase::supportsRichSourceInfo):
        * bindings/js/PageScriptDebugServer.cpp:
        * bindings/js/PageScriptDebugServer.h:
        * bindings/js/ScriptProfile.cpp:
        * bindings/js/ScriptProfile.h:
        * bindings/js/ScriptProfileNode.h:
        * bindings/js/ScriptProfiler.cpp:
        * bindings/js/ScriptProfiler.h:
        * bindings/js/WorkerScriptDebugServer.cpp:
        * bindings/js/WorkerScriptDebugServer.h:
        * inspector/InspectorConsoleAgent.h:
        * inspector/InspectorConsoleInstrumentation.h:
        (WebCore::InspectorInstrumentation::getCurrentUserInitiatedProfileName):
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        (WebCore::InspectorController::resume):
        * inspector/InspectorController.h:
        * inspector/InspectorDOMDebuggerAgent.cpp:
        * inspector/InspectorDOMDebuggerAgent.h:
        * inspector/InspectorHeapProfilerAgent.cpp:
        * inspector/InspectorHeapProfilerAgent.h:
        * inspector/InspectorInstrumentation.cpp:
        (WebCore::InspectorInstrumentation::didClearWindowObjectInWorldImpl):
        (WebCore::InspectorInstrumentation::isDebuggerPausedImpl):
        (WebCore::InspectorInstrumentation::willInsertDOMNodeImpl):
        (WebCore::InspectorInstrumentation::didInsertDOMNodeImpl):
        (WebCore::InspectorInstrumentation::willRemoveDOMNodeImpl):
        (WebCore::InspectorInstrumentation::didRemoveDOMNodeImpl):
        (WebCore::InspectorInstrumentation::willModifyDOMAttrImpl):
        (WebCore::InspectorInstrumentation::didInvalidateStyleAttrImpl):
        (WebCore::InspectorInstrumentation::willSendXMLHttpRequestImpl):
        (WebCore::InspectorInstrumentation::scriptExecutionBlockedByCSPImpl):
        (WebCore::InspectorInstrumentation::didCommitLoadImpl):
        (WebCore::InspectorInstrumentation::addMessageToConsoleImpl):
        (WebCore::InspectorInstrumentation::profilerEnabledImpl):
        (WebCore::InspectorInstrumentation::willEvaluateWorkerScript):
        (WebCore::InspectorInstrumentation::pauseOnNativeEventIfNeeded):
        (WebCore::InspectorInstrumentation::cancelPauseOnNativeEvent):
        * inspector/InspectorInstrumentation.h:
        * inspector/InspectorProfilerAgent.cpp:
        * inspector/InspectorProfilerAgent.h:
        * inspector/InstrumentingAgents.cpp:
        (WebCore::InstrumentingAgents::InstrumentingAgents):
        (WebCore::InstrumentingAgents::reset):
        * inspector/InstrumentingAgents.h:
        * inspector/PageDebuggerAgent.cpp:
        * inspector/PageDebuggerAgent.h:
        * inspector/ScriptProfile.idl:
        * inspector/ScriptProfileNode.idl:
        * inspector/WebDebuggerAgent.cpp:
        * inspector/WebDebuggerAgent.h:
        * inspector/WorkerDebuggerAgent.cpp:
        * inspector/WorkerDebuggerAgent.h:
        * inspector/WorkerInspectorController.cpp:
        (WebCore::WorkerInspectorController::WorkerInspectorController):
        (WebCore::WorkerInspectorController::resume):
        * inspector/WorkerInspectorController.h:
        * inspector/WorkerRuntimeAgent.cpp:
        (WebCore::WorkerRuntimeAgent::pauseWorkerGlobalScope):
        * inspector/WorkerRuntimeAgent.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::continueLoadAfterNavigationPolicy):
        * page/Console.cpp:
        * page/Console.h:
        * page/Console.idl:
        * testing/Internals.cpp:
        (WebCore::Internals::resetToConsistentState):
        * workers/WorkerMessagingProxy.cpp:
        (WebCore::connectToWorkerGlobalScopeInspectorTask):
        (WebCore::WorkerMessagingProxy::connectToInspector):
        (WebCore::disconnectFromWorkerGlobalScopeInspectorTask):
        (WebCore::WorkerMessagingProxy::disconnectFromInspector):
        (WebCore::dispatchOnInspectorBackendTask):
        (WebCore::WorkerMessagingProxy::sendMessageToInspector):

2014-01-29  Eric Carlson  <eric.carlson@apple.com>

        [iOS] cleanup MediaPlayer.cpp
        https://bugs.webkit.org/show_bug.cgi?id=127821

        Reviewed by Jer Noble.

        Don't register MediaPlayerPrivateIOS unless the runtime setting for media player proxy is set.

        * platform/graphics/MediaPlayer.cpp: Don't define PlatformMediaEngineClassName on iOS
        (WebCore::installedMediaEngines): Drive by cleanup to return early if registration has
            already happened.
        (WebCore::MediaPlayer::MediaPlayer): Don't force-register the first media engine unless 
            isVideoPluginProxyEnabled returns true.

2014-01-29  Youenn Fablet  <youennf@gmail.com>

        Have XHR.getResponseHeader() return null and XHR.getAllResponseHeader() return the empty string in initial ready states
        https://bugs.webkit.org/show_bug.cgi?id=125840

        Reviewed by Alexey Proskuryakov.

        Merging https://chromium.googlesource.com/chromium/blink/+/d201caf874a0bd6f101f517462b3cf1d8c5fce3d
        This patch makes it clear that null/empty string is returned whenever the error flag is set.
        This new code path is covered by the added test.
        
        Test: http/tests/xmlhttprequest/response-access-on-error.html

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::getAllResponseHeaders):
        (WebCore::XMLHttpRequest::getResponseHeader):
        * xml/XMLHttpRequest.h:
        * xml/XMLHttpRequest.idl:

2014-01-29  Antti Koivisto  <antti@apple.com>

        REGRESSION (r162947): Repaint test results are different between WK1 and WK2
        https://bugs.webkit.org/show_bug.cgi?id=127814

        Reviewed by Anders Carlsson.

        * page/FrameView.cpp:
        (WebCore::FrameView::repaintContentRectangle):
        
            Move repaint rect logging to RenderView.

        * rendering/RenderView.cpp:
        (WebCore::RenderView::repaintViewRectangle):
        
            Record raw repaint rects instead of optimized ones.

2014-01-29  Brady Eidson  <beidson@apple.com>

        IDB: Serialize IDBKeyDatas to disk, not IDBKeys
        https://bugs.webkit.org/show_bug.cgi?id=127829

        Reviewed by Tim Horton.

        Move encode/decode from IDBKey to IDBKeyData.

        * Modules/indexeddb/IDBKey.cpp:
        * Modules/indexeddb/IDBKey.h:

        * Modules/indexeddb/IDBKeyData.cpp:
        (WebCore::IDBKeyData::IDBKeyData):
        (WebCore::IDBKeyData::encode):
        (WebCore::IDBKeyData::decode):
        * Modules/indexeddb/IDBKeyData.h:

        * WebCore.exp.in:

2014-01-29  Antti Koivisto  <antti@apple.com>

        REGRESSION (r162947): css3/flexbox/multiline-justify-content.html and css3/flexbox/position-absolute-child.html are timing out
        https://bugs.webkit.org/show_bug.cgi?id=127809

        Reviewed by Anders Carlsson.

        These tests generate very large number of small repaint rectangles that overwhelm the region code.

        * page/FrameView.cpp:
        (WebCore::FrameView::repaintContentRectangle):
        * platform/graphics/Region.h:
        (WebCore::Region::gridSize):
        (WebCore::Region::Shape::gridSize):
        
            Add accessor for getting the current region grid complexity.

        * rendering/RenderView.cpp:
        (WebCore::RenderView::repaintViewRectangle):
        
            If the region gets very complex merge the repaint rects into a single big rectangle.

2014-01-29  Radu Stavila  <stavila@adobe.com>

        [CSSRegions] Unable to scroll a scrollable container for regions using mouse wheel
        https://bugs.webkit.org/show_bug.cgi?id=123886

        When an element flowed into a scrollable region is scrolled using the mouse wheel, the event 
        needs to be propagated to the region containing that element, on top of which the cursor
        is located.

        Reviewed by Antti Koivisto.

        Tests: fast/regions/wheel-scroll-abspos.html
               fast/regions/wheel-scroll.html

        * page/EventHandler.cpp:
        (WebCore::scrollNode):
        (WebCore::EventHandler::defaultWheelEventHandler):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::scroll):
        (WebCore::RenderBox::scrollWithWheelEventLocation):
        * rendering/RenderBox.h:
        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::regionFromAbsolutePointAndBox):
        * rendering/RenderFlowThread.h:

2014-01-29  Carlos Garcia Campos  <cgarcia@igalia.com>

        REGRESSION(r162922): [SOUP] Several tests are failing in EFL and GTK+ after r162922
        https://bugs.webkit.org/show_bug.cgi?id=127836

        Reviewed by Gustavo Noronha Silva.

        The problem is that I assumed that several things done in
        ResourceRequest::soupURI() were always desired, so I moved them to
        URL. This patch restores the previous behaviour, so that those
        tings are only done right before making a request.

        * platform/network/soup/ResourceRequestSoup.cpp:
        (WebCore::ResourceRequest::createSoupURI):
        * platform/soup/URLSoup.cpp:
        (WebCore::URL::createSoupURI):

2014-01-29  Krzysztof Czech  <k.czech@samsung.com>

        [ATK] Expose aria-describedby with ATK_RELATION_DESCRIBED_BY
        https://bugs.webkit.org/show_bug.cgi?id=121684

        Reviewed by Mario Sanchez Prada.

        Exposed aria-describedby by ATK_RELATION_DESCRIBED_BY.
        Moved elementsFromAttribut to AccessibilityObject to have common interface
        for AccessibilityNodeObject and AccessibilityRenderObject. Implemented
        supportsARIADescribedBy and ariaDescribedByElements to better deal with aria-describedby attribute.

        No new tests. Covered by existed one.

        * accessibility/AccessibilityNodeObject.cpp:
        * accessibility/AccessibilityNodeObject.h:
        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::elementsFromAttribute):
        * accessibility/AccessibilityObject.h:
        (WebCore::AccessibilityObject::supportsARIADescribedBy):
        (WebCore::AccessibilityObject::ariaDescribedByElements):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::supportsARIADescribedBy):
        (WebCore::AccessibilityRenderObject::ariaDescribedByElements):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/atk/WebKitAccessibleWrapperAtk.cpp:
        (setAtkRelationSetFromCoreObject):

2014-01-29  Sergio Villar Senin  <svillar@igalia.com>

        [CSS Grid Layout] minmax() should be a CSSFunction instead of a CSSValueList
        https://bugs.webkit.org/show_bug.cgi?id=127057

        Reviewed by Antti Koivisto.

        We were incorrectly dumping minmax(x,y) as "x y" instead of
        "minmax(x,y)". That's because we were treating minmax() internally
        as a CSSValueList instead of a CSSFunction. Replaced that and also
        added some extra information to our tests in order to check that
        we don't regress. From now on the CSS grid layout testing helper
        functions print not only the computed style but also the contents
        of element.style.webkitGridDefinition{Columns|Rows}.

        * css/CSSFunctionValue.h:
        (WebCore::CSSFunctionValue::arguments):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseGridTrackList):
        (WebCore::CSSParser::parseGridTrackRepeatFunction):
        (WebCore::CSSParser::parseGridTrackSize):
        * css/CSSParser.h:
        * css/StyleResolver.cpp:
        (WebCore::createGridTrackSize):

2014-01-29  Ryosuke Niwa  <rniwa@webkit.org>

        Rename notifyRendererOfSelectionChange
        https://bugs.webkit.org/show_bug.cgi?id=127831

        Reviewed by Antti Koivisto.

        Renamed notifyRendererOfSelectionChange to updateSelectionCachesIfSelectionIsInsideTextFormControl.

        * WebCore.order: Removed the exported symbol name as it's not used in WebKit or WebKit2 code.
        * editing/FrameSelection.cpp:
        (WebCore::FrameSelection::setSelection):
        (WebCore::FrameSelection::selectAll):
        (WebCore::FrameSelection::updateSelectionCachesIfSelectionIsInsideTextFormControl): Don't update the style since the existence
        of text form control's shadow DOM no longer depends on renderer.
        * editing/FrameSelection.h:
        * html/HTMLTextFormControlElement.cpp:
        (WebCore::HTMLTextFormControlElement::selectionChanged): Don't check renderer() for the same reason.
        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleMouseReleaseEvent):

2014-01-28  Jer Noble  <jer.noble@apple.com>

        [Mac] Handle NSURLAuthenticationMethodServerTrust challenges from -resourceLoader:shouldWaitForResponseToAuthenticationChallenge:
        https://bugs.webkit.org/show_bug.cgi?id=127806

        Reviewed by Eric Carlson.

        In addition to the normal "user/password" NSURLAuthenticationChallenges, the 
        -resourceLoader:shouldWaitForResponseToAuthenticationChallenge: delegate method will
        ask us to confirm server certificate chains. Rather than pop up an authentication
        dialog (which won't work anyway) we will now just drop such requests and continue
        on normally.

        * platform/graphics/avfoundation/objc/MediaPlayerPrivateAVFoundationObjC.mm:
        (-[WebCoreAVFLoaderDelegate resourceLoader:shouldWaitForResponseToAuthenticationChallenge:]):

2014-01-28  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r162987.
        http://trac.webkit.org/changeset/162987
        https://bugs.webkit.org/show_bug.cgi?id=127825

        Broke Mountain Lion build (Requested by andersca on #webkit).

        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateGetOwnPropertySlotBody):
        (GenerateAttributesHashTable):
        (GenerateImplementation):
        * bindings/scripts/test/JS/JSTestActiveDOMObject.cpp:
        (WebCore::jsTestActiveDOMObjectConstructor):
        * bindings/scripts/test/JS/JSTestCustomNamedGetter.cpp:
        (WebCore::jsTestCustomNamedGetterConstructor):
        * bindings/scripts/test/JS/JSTestEventConstructor.cpp:
        (WebCore::jsTestEventConstructorConstructor):
        * bindings/scripts/test/JS/JSTestEventTarget.cpp:
        (WebCore::jsTestEventTargetConstructor):
        * bindings/scripts/test/JS/JSTestException.cpp:
        (WebCore::jsTestExceptionConstructor):
        * bindings/scripts/test/JS/JSTestGenerateIsReachable.cpp:
        (WebCore::jsTestGenerateIsReachableConstructor):
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::jsTestInterfaceConstructor):
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp:
        (WebCore::jsTestMediaQueryListListenerConstructor):
        * bindings/scripts/test/JS/JSTestNamedConstructor.cpp:
        (WebCore::jsTestNamedConstructorConstructor):
        * bindings/scripts/test/JS/JSTestNode.cpp:
        (WebCore::jsTestNodeConstructor):
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::jsTestObjConstructor):
        * bindings/scripts/test/JS/JSTestOverloadedConstructors.cpp:
        (WebCore::jsTestOverloadedConstructorsConstructor):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        (WebCore::jsTestSerializedScriptValueInterfaceConstructor):
        * bindings/scripts/test/JS/JSTestTypedefs.cpp:
        (WebCore::jsTestTypedefsConstructor):
        * bindings/scripts/test/JS/JSattribute.cpp:
        (WebCore::jsattributeConstructor):
        * bindings/scripts/test/JS/JSreadonly.cpp:
        (WebCore::jsreadonlyConstructor):

2014-01-28  Enrica Casucci  <enrica@apple.com>

        Add support for ActionSheets in WK2 for iOS.
        https://bugs.webkit.org/show_bug.cgi?id=127586
        <rdar://problem/15283667>

        Reviewed by Benjamin Poulain.

        This patch contains some WebCore changes required to
        implement support for ActionSheets.
        It adds copyURL implementation for iOS in the Editor
        class and fixes some bugs in the iOS specific pasteboard
        writing code.
        The changes to Localizable.strings are the result of
        running update-webkit-localizedstrings script.

        * English.lproj/Localizable.strings:
        * WebCore.exp.in:
        * editing/Editor.cpp:
        * editing/Editor.h:
        * editing/ios/EditorIOS.mm:
        (WebCore::Editor::writeImageToPasteboard):
        * platform/ios/PasteboardIOS.mm:
        (WebCore::Pasteboard::write):
        * platform/ios/PlatformPasteboardIOS.mm:
        (WebCore::PlatformPasteboard::write):

2014-01-28  Andy Estes  <aestes@apple.com>

        [iOS] REGRESSION (r162663): Webpages have strange artifacts or corruption around tile boundaries
        https://bugs.webkit.org/show_bug.cgi?id=127823

        Reviewed by Daniel Bates.

        Original patch by Simon Fraser.

        * platform/ScrollView.cpp: Specify LegacyIOSDocumentViewRect when calling visibleContentRect().

2014-01-28  Zoltan Horvath  <zoltan@webkit.org>

        [CSS Shapes] Adjust inset sizing syntax to the latest specification
        https://bugs.webkit.org/show_bug.cgi?id=127785

        Reviewed by Bem Jones-Bey.

        According to the latest CSS Shapes specification [1], the width arguments of inset should
        follow the syntax of the margin shorthand, which let us set all four insets with one, two
        or four values. This patch updates the behavior and updates the affected tests.

        [1] http://dev.w3.org/csswg/css-shapes/#funcdef-inset

        Existing tests have been updated.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseInsetRoundedCorners):
        (WebCore::CSSParser::parseBasicShapeInset):

2014-01-28  Oliver Hunt  <oliver@apple.com>

        Make DOM attributes appear to be faux accessor properties
        https://bugs.webkit.org/show_bug.cgi?id=127797

        Reviewed by Michael Saboff.

        Refactor the bindings generator, and make sure we emit
        the CustomAccessor flag on properties that should 
        appear to be accessors.

        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateGetOwnPropertySlotBody):
        (GenerateAttributesHashTable):
        (GenerateImplementation):

2014-01-27  Chris Fleizach  <cfleizach@apple.com>

        AX: Support @scope in HTML tables
        https://bugs.webkit.org/show_bug.cgi?id=127688

        Reviewed by Mario Sanchez Prada.

        Add support for scope attribute so that row headers and column headers
        are now exposed at the table cell level where appropriate.

        Test: platform/mac/accessibility/table-scope.html

        * accessibility/AccessibilityARIAGridCell.cpp:
        (WebCore::AccessibilityARIAGridCell::parentTable):
        * accessibility/AccessibilityARIAGridCell.h:
        * accessibility/AccessibilityARIAGridRow.cpp:
        (WebCore::AccessibilityARIAGridRow::parentTable):
        * accessibility/AccessibilityARIAGridRow.h:
        * accessibility/AccessibilityTable.cpp:
        (WebCore::AccessibilityTable::columns):
        (WebCore::AccessibilityTable::rows):
        * accessibility/AccessibilityTable.h:
        * accessibility/AccessibilityTableCell.cpp:
        (WebCore::AccessibilityTableCell::parentTable):
        (WebCore::AccessibilityTableCell::isTableHeaderCell):
        (WebCore::AccessibilityTableCell::isTableCellInSameRowGroup):
        (WebCore::AccessibilityTableCell::isTableCellInSameColGroup):
        (WebCore::AccessibilityTableCell::columnHeaders):
        (WebCore::AccessibilityTableCell::rowHeaders):
        * accessibility/AccessibilityTableCell.h:
        * accessibility/AccessibilityTableRow.cpp:
        (WebCore::AccessibilityTableRow::parentTable):
        * accessibility/AccessibilityTableRow.h:
        * accessibility/mac/WebAccessibilityObjectWrapperMac.mm:
        (-[WebAccessibilityObjectWrapper accessibilityAttributeNames]):
        (-[WebAccessibilityObjectWrapper accessibilityAttributeValue:]):

2014-01-28  Brent Fulgham  <bfulgham@apple.com>

        Improve latching behavior for wheel events
        https://bugs.webkit.org/show_bug.cgi?id=127386
        <rdar://problem/12176858>

        Reviewed by Simon Fraser.

        * page/scrolling/ScrollingTree.cpp:
        (WebCore::ScrollingTree::clearLatchedNode): Added
        (WebCore::ScrollingTree::latchedNode): Added
        (WebCore::ScrollingTree::removeDestroyedNodes): Clear latched node if it's being removed.
        (WebCore::ScrollingTree::ScrollingTree): Initialize new value used for tracking
        scroll latching state.
        (WebCore::ScrollingTree::setLatchedNode): Added
        (WebCore::ScrollingTree::setOrClearLatchedNode): Added
        Set latched node when beginning a swipe event, or clear latched node when scroll/momentum ends.
        (WebCore::ScrollingTree::shouldHandleWheelEventSynchronously): Check for an existing
        latched node and stay in fast scrolling mode if possible. If the current event should
        start a swipe event, clear the current latched node so we can correctly find and assign
        the new latch node.
        * page/scrolling/ScrollingTree.h:
        (WebCore::ScrollingTree::hasLatchedNode): Added
        * page/scrolling/mac/ScrollingTreeScrollingNodeMac.mm:
        (WebCore::ScrollingTreeScrollingNodeMac::handleWheelEvent): Determine latching state
        based on wheel event state and position of mouse pointer in the document.
        * platform/ScrollAnimator.cpp:
        (ScrollAnimator::handleWheelEvent): Always treat PlatformWheelEventPhaseMayBegin
        as successfully handled so that it does not "bubble back up" to the root of
        the scrolling tree.   

2014-01-23  Myles C. Maxfield  <mmaxfield@apple.com>

        ASSERT_WITH_SECURITY_IMPLICATION in WebCore::InlineTextBox::paint
        https://bugs.webkit.org/show_bug.cgi?id=114586

        Reviewed by Dave Hyatt.

        Taken mostly from https://chromium.googlesource.com/chromium/blink/+/cb2297db16f2e9328cb4dd8b552093d6b22340a8

        If RenderQuote is a subclass of RenderObject, it can't be split by the first-letter CSS pseudoclass.
        Instead, we should make it a subclass of RenderElement, so that it can be split properly.

        Test: fast/css-generated-content/quote-first-letter.html

        * dom/PseudoElement.cpp:
        (WebCore::PseudoElement::didRecalcStyle):
        * rendering/RenderQuote.cpp:
        (WebCore::RenderQuote::RenderQuote):
        (WebCore::RenderQuote::willBeDestroyed):
        (WebCore::RenderQuote::willBeRemovedFromTree):
        (WebCore::RenderQuote::styleDidChange):
        (WebCore::RenderQuote::updateText):
        (WebCore::RenderQuote::computeText):
        (WebCore::RenderQuote::updateDepth):
        * rendering/RenderQuote.h:
        * rendering/style/ContentData.cpp:
        (WebCore::QuoteContentData::createContentRenderer):

2014-01-28  Antti Koivisto  <antti@apple.com>

        Document::topDocument() should return a reference
        https://bugs.webkit.org/show_bug.cgi?id=127786

        Reviewed by Darin Adler.

        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::mainFrame):
        (WebCore::AccessibilityObject::topDocument):
        * accessibility/ios/WebAccessibilityObjectWrapperIOS.mm:
        (-[WebAccessibilityObjectWrapper accessibilityContainer]):
        * dom/Document.cpp:
        (WebCore::Document::~Document):
        (WebCore::Document::createRenderTree):
        (WebCore::Document::destroyRenderTree):
        (WebCore::Document::clearAXObjectCache):
        (WebCore::Document::existingAXObjectCache):
        (WebCore::Document::axObjectCache):
        (WebCore::Document::implicitClose):
        (WebCore::Document::topDocument):
        (WebCore::Document::topOrigin):
        (WebCore::Document::webkitCancelFullScreen):
        (WebCore::Document::webkitDidExitFullScreenForElement):
        * dom/Document.h:
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::incrementScrollEventListenersCount):
        (WebCore::DOMWindow::decrementScrollEventListenersCount):
        * rendering/RenderEmbeddedObject.cpp:
        (WebCore::RenderEmbeddedObject::isReplacementObscured):
        * rendering/RenderView.cpp:
        (WebCore::RenderView::RepaintRegionAccumulator::RepaintRegionAccumulator):
        
2014-01-28  Viatcheslav Ostapenko  <sl.ostapenko@samsung.com>

        Sticky positioning is broken for table rows
        https://bugs.webkit.org/show_bug.cgi?id=112024

        Reviewed by Simon Fraser.

        Enable sticky positioning for table elements. 
        Also includes fix for bug ​wkb.ug/105654
        I don't have access to this bug, but from related commit message I 
        assume it says about "Heap use after free problem".
        Debugging showed that it wasn't heap use after free. 
        The real problem that RenderObject::container() returns object which is
        not RenderBlock and it is used as RenderBlock in 
        RenderBox::containingBlockLogicalHeightForPositioned() method.
        Added extra isRenderBlock check and search for containingBlock if 
        current block is not RenderBlock.
        
        Tests: fast/css/sticky/sticky-table-row-top.html
               fast/css/sticky/sticky-table-thead-top.html

        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::adjustRenderStyle):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::containingBlockLogicalHeightForPositioned):
        * rendering/RenderTableRow.h:

2014-01-28  Myles C. Maxfield  <mmaxfield@apple.com>

        Fixing several incorrect assumptions with handling isolated inlines.
        https://bugs.webkit.org/show_bug.cgi?id=127608

        Reviewed by Simon Fraser.

        Fixing capitalization.

        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::setUpResolverToResumeInIsolate):
        (WebCore::constructBidiRunsForSegment):

2014-01-28  Myles C. Maxfield  <mmaxfield@apple.com>

        Fixing several incorrect assumptions with handling isolated inlines.
        https://bugs.webkit.org/show_bug.cgi?id=127608

        Reviewed by Dave Hyatt.

        First, when an isolated inline spans multiple lines, we aren't guaranteed
        to exit BidiResolver with a nested inline count of zero. Removing the
        assert that says otherwise.
        
        Previously in constructBidiRunsForSegment, we called bidiFirst in
        an attempt to properly setup the isolatedResolver for any dom/style
        that applied, but this only worked on the first line the isolated
        inline appeared in. Adding a function that approaches this properly
        by recursing through the parents of the starting object for the line
        and post-fixing direction attributes to the resolver.
        
        Finally, addressing an issue where the line following a removed isolated
        inline (with a continuation) failed to be marked dirty.

        Merged from Blink: https://chromium.googlesource.com/chromium/blink/+/72698f203b1c50900e535b80945563b92b7eef23

        Tests: fast/text/nested-bidi-assert.html
               fast/text/nested-bidi-with-continuation-crash.html

        * platform/text/BidiResolver.h:
        (WebCore::Run>::~BidiResolver):
        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::setupResolverToResumeInIsolate):
        (WebCore::constructBidiRunsForSegment):
        * rendering/RenderLineBoxList.cpp:
        (WebCore::RenderLineBoxList::dirtyLinesFromChangedChild):

2014-01-28  Antti Koivisto  <antti@apple.com>

        REGRESSION(r162837): 5% regression on html5-full-render and 3% regression in DoYouEvenBench
        https://bugs.webkit.org/show_bug.cgi?id=127722

        Reviewed by Darin Adler.

        Accumulate repaint region in RendeView instead of flushing rects directly to the system.

        * dom/Document.cpp:
        (WebCore::Document::recalcStyle):
        (WebCore::Document::updateLayout):
        (WebCore::Document::topDocument):
        
            Make less silly.

        * page/FrameView.cpp:
        (WebCore::FrameView::layout):
        * rendering/RenderView.cpp:
        (WebCore::RenderView::repaintViewRectangle):
        (WebCore::RenderView::flushAccumulatedRepaintRegion):
        (WebCore::RenderView::RepaintRegionAccumulator::RepaintRegionAccumulator):
        (WebCore::RenderView::RepaintRegionAccumulator::~RepaintRegionAccumulator):
        * rendering/RenderView.h:

2014-01-28  Jeremy Jones  <jeremyj@apple.com>

        HTMLMediaElement::m_platformLayerBorrowed is uninitialized.
        https://bugs.webkit.org/show_bug.cgi?id=127759

        Reviewed by Eric Carlson.

        Initalize m_platformLayerBorrowed to false.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::HTMLMediaElement):

2014-01-28  Jer Noble  <jer.noble@apple.com>

        [Mac] Use explicit, rather than canonical, AudioFormatFlags and types.
        https://bugs.webkit.org/show_bug.cgi?id=127781

        Reviewed by Eric Carlson.

        Since every mac platform uses Float32 audio samples, use these types explicitly
        rather than the implicit, canonical AudioSampleType type. Once we're using Float32
        explicity, we can also use the explicit kAudioFormatFlagsNativeFloatPacked flag
        rather than the canonical version.

        * platform/audio/mac/AudioDestinationMac.cpp:
        (WebCore::AudioDestinationMac::configure):
        * platform/audio/mac/AudioFileReaderMac.cpp:
        (WebCore::AudioFileReader::createBus):

2014-01-27  Alexey Proskuryakov  <ap@apple.com>

        Expose SQL database creation and modification times
        https://bugs.webkit.org/show_bug.cgi?id=127728

        Reviewed by Brady Eidson.

        * platform/FileSystem.h:
        * platform/posix/FileSystemPOSIX.cpp:
        (WebCore::getFileCreationTime):
        * platform/win/FileSystemWin.cpp:
        (WebCore::getFileCreationTimeFromFindData):
        (WebCore::getFileCreationTime):
        Added functions to get file creation times. Not all OSes support that, but Darwin
        and Windows do, as (I think) various BSD flavors.

        * platform/gtk/FileSystemGtk.cpp: Added a stub for getFileCreationTime().

        * platform/sql/SQLiteFileSystem.h:
        * platform/sql/SQLiteFileSystem.cpp:
        (WebCore::SQLiteFileSystem::databaseCreationTime):
        (WebCore::SQLiteFileSystem::databaseModificationTime):
        Expose it in the same strange manner other database file operations are.

        * Modules/webdatabase/DatabaseDetails.h:
        (WebCore::DatabaseDetails::DatabaseDetails):
        (WebCore::DatabaseDetails::creationTime):
        (WebCore::DatabaseDetails::modificationTime):
        Added creation and modification times to DatabaseDetails.

        * Modules/webdatabase/DatabaseManager.cpp:
        (WebCore::DatabaseManager::ProposedDatabase::ProposedDatabase):
        (WebCore::DatabaseManager::openDatabaseBackend):
        ProposedDatabase is an unfortunate mechanism for communicating quota errors to the
        client, we should really straighten it up. But for now, just leave the times uninitialized.

        * Modules/webdatabase/DatabaseBackendBase.cpp: (WebCore::DatabaseBackendBase::details):
        This code path is for handling quota errors, so there is no need to initialize most
        of DatabaseDetails here as well.

        * Modules/webdatabase/DatabaseTracker.cpp: (WebCore::DatabaseTracker::detailsForNameAndOrigin):
        * Modules/webdatabase/DatabaseTracker.h:
        Fill in database file times. Inlined and removed usageForDatabase function to
        avoid rebuilding the path multiple times.

2014-01-28  Jer Noble  <jer.noble@apple.com>

        Setting muted attribute on <video> element is not reflected in controls
        https://bugs.webkit.org/show_bug.cgi?id=127726

        Reviewed by Eric Carlson.

        If the 'muted' IDL attribute is queried after the 'muted' and 'src' content attributes are
        set but before loading begins, it will return 'false' until loading begins, but with no
        way to query whether that value is valid, nor firing a volumechange event when its value
        changes.

        The HTML spec says that the 'muted' content attribute controls whether audio output is
        muted "when the media element is created", not when loading begins, but we don't
        necessarily have a signal that the element is fully parsed.  Additionally, this means its
        impossible to make an element via script and get this behavior.

        So the new behavior is that the 'muted' IDL attribute will always reflect the 'muted'
        content attribute up until one of the following three conditions:

        - The 'muted' IDL attribute is set via script.
        - The element is inserted in the document.
        - The element begins loading.

        After the first one of the above conditions, the 'muted' IDL attribute will no longer
        change when the 'muted' content attribute changes.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::HTMLMediaElement):
        (WebCore::HTMLMediaElement::parseAttribute):
        * html/HTMLMediaElement.h:

2014-01-28  Anders Carlsson  <andersca@apple.com>

        Add stubbed out VisitedLinkProvider class
        https://bugs.webkit.org/show_bug.cgi?id=127744

        Reviewed by Andreas Kling.

        This is a first step towards moving responsibility of visited links from 
        the page group to a separate object.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * page/PageGroup.cpp:
        (WebCore::PageGroup::PageGroup):
        * page/PageGroup.h:
        (WebCore::PageGroup::visitedLinkProvider):
        * page/VisitedLinkProvider.cpp: Added.
        (WebCore::VisitedLinkProvider::VisitedLinkProvider):
        (WebCore::VisitedLinkProvider::~VisitedLinkProvider):
        * page/VisitedLinkProvider.h: Added.
        (WebCore::VisitedLinkProvider::create):

2014-01-28  Gurpreet Kaur  <k.gurpreet@samsung.com>

        Add support for menclose element
        https://bugs.webkit.org/show_bug.cgi?id=85729

        Reviewed by Chris Fleizach.

        Added support for menclose element. MathML <menclose> element renders
        its content inside an enclosing notation specified by the notation
        attribute. The notation attribute can have values longdiv, box, left,
        right, top, bottom , radical, madruwb, actuarial, roundedbox, circle,
        updiagonalstrike, downdiagonalstrike, verticalstrike and
        horizontalstrike.

        Tests: mathml/presentation/menclose-add-children.html
               mathml/presentation/menclose-notation-attribute-add.html
               mathml/presentation/menclose-notation-attribute-change-value.html
               mathml/presentation/menclose-notation-attribute-remove.html
               mathml/presentation/menclose-notation-attribute-set1.html
               mathml/presentation/menclose-notation-attribute-set2.html
               mathml/presentation/menclose-notation-no-overlap.html
               mathml/presentation/menclose-notation-radical.html
               mathml/presentation/menclose-remove-children.html

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * css/mathml.css:
        (mo, mrow, mfenced, mfrac, msub, msup, msubsup, mmultiscripts, mprescripts, none, munder, mover, munderover, msqrt, mroot, merror, mphantom, mstyle, menclose):
        (math, mrow, mfenced, msqrt, mroot, merror, mphantom, mstyle, menclose):
        * mathml/MathMLAllInOne.cpp:
        * mathml/MathMLElement.h:
        * mathml/MathMLInlineContainerElement.cpp:
        * mathml/MathMLMencloseElement.cpp: Added.
        (WebCore::MathMLMencloseElement::MathMLMencloseElement):
        (WebCore::MathMLMencloseElement::create):
        (WebCore::MathMLMencloseElement::createElementRenderer):
        (WebCore::MathMLMencloseElement::isPresentationAttribute):
        (WebCore::MathMLMencloseElement::finishParsingChildren):
        (WebCore::MathMLMencloseElement::collectStyleForPresentationAttribute):
        (WebCore::MathMLMencloseElement::longDivLeftPadding):
        * mathml/MathMLMencloseElement.h: Added.
        (WebCore::toMathMLMencloseElement):
        * mathml/mathattrs.in:
        * mathml/mathtags.in:
        * rendering/mathml/RenderMathMLMenclose.cpp: Added.
        (WebCore::RenderMathMLMenclose::RenderMathMLMenclose):
        (WebCore::RenderMathMLMenclose::addChild):
        (WebCore::RenderMathMLMenclose::computePreferredLogicalWidths):
        (WebCore::RenderMathMLMenclose::updateLogicalHeight):
        (WebCore::RenderMathMLMenclose::paint):
        (WebCore::RenderMathMLMenclose::checkNotationalValuesValidity):
        * rendering/mathml/RenderMathMLMenclose.h: Added.
        * rendering/mathml/RenderMathMLRoot.cpp:
        (WebCore::RenderMathMLRoot::RenderMathMLRoot):
        * rendering/mathml/RenderMathMLRoot.h:
        * rendering/mathml/RenderMathMLSquareRoot.cpp:
        (WebCore::RenderMathMLSquareRoot::RenderMathMLSquareRoot):
        (WebCore::RenderMathMLSquareRoot::createAnonymousWithParentRenderer):
        * rendering/mathml/RenderMathMLSquareRoot.h:
        Added new file related to menclose element implementation. Menclose
        element is created and while parsing its notation attribute based on
        its values like top, left CSSBorder properties are applied and for
        values like circle, verticalstrike, longidv its taken care in paint.
        For radical value an anonymous RenderMathMLSquareRoot is created as
        a child of menclose.

2014-01-28  Krzysztof Czech  <k.czech@samsung.com>

        [ATK] accessibility/range-alter-by-percent.html is failing after r162587.
        https://bugs.webkit.org/show_bug.cgi?id=127774

        Reviewed by Mario Sanchez Prada.

        Implicit value of step in range type elements should be one or larger.

        No new tests. Covered by exiting one.

        * accessibility/atk/WebKitAccessibleInterfaceValue.cpp:
        (webkitAccessibleValueGetMinimumIncrement):

2014-01-28  Mark Rowe  <mrowe@apple.com>

        <https://webkit.org/b/127767> Disable some deprecation warnings to fix the build.

        Reviewed by Ryosuke Niwa.

        * accessibility/mac/AXObjectCacheMac.mm:
        (WebCore::AXObjectCache::postPlatformNotification):
        * accessibility/mac/WebAccessibilityObjectWrapperMac.mm:
        (-[WebAccessibilityObjectWrapper renderWidgetChildren]):
        * platform/audio/mac/AudioDestinationMac.cpp:
        (WebCore::AudioDestinationMac::configure):
        * platform/audio/mac/AudioFileReaderMac.cpp:
        (WebCore::AudioFileReader::createBus):

2014-01-28  Carlos Garcia Campos  <cgarcia@igalia.com>

        [SOUP] Remove soupURIToKURL
        https://bugs.webkit.org/show_bug.cgi?id=127104

        Reviewed by Martin Robinson.

        In favor of a URL constructor receiving a SoupURI. Also add a
        method to URL to create a soupURI.

        * GNUmakefile.list.am: Remove SoupURIUtils and add URLSoup.
        * PlatformEfl.cmake: Ditto.
        * PlatformGTK.cmake: Ditto.
        * platform/URL.h: Add URL constructor receiving a SoupURI and
        createSoupURI() to create a new soupURI for the URL.
        * platform/network/soup/CookieJarSoup.cpp:
        (WebCore::setCookiesFromDOM): Use URL::createSoupURI().
        (WebCore::cookiesForSession): Ditto.
        (WebCore::getRawCookies): Ditto.
        (WebCore::deleteCookie): Ditto.
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::doRedirect): Use the new URL constructor instead of
        soupURIToKURL.
        (WebCore::createSoupRequestAndMessageForHandle): Use URL::createSoupURI().
        * platform/network/soup/ResourceRequest.h: Rename soupURI as
        createSoupURI to make it clear that the method returns a newly
        created SoupURI.
        * platform/network/soup/ResourceRequestSoup.cpp:
        (WebCore::ResourceRequest::updateSoupMessageMembers): Use URL::createSoupURI().
        (WebCore::ResourceRequest::updateSoupMessage): Ditto.
        (WebCore::ResourceRequest::updateFromSoupMessage): Use the new URL
        constructor instead of soupURIToKURL.
        (WebCore::ResourceRequest::createSoupURI): Use URL::createSoupURI().
        * platform/network/soup/ResourceResponseSoup.cpp:
        (WebCore::ResourceResponse::updateFromSoupMessage): Use the new
        URL constructor instead of soupURIToKURL.
        * platform/network/soup/SoupURIUtils.cpp: Removed.
        * platform/network/soup/SoupURIUtils.h: Removed.
        * platform/soup/URLSoup.cpp: Added.
        (WebCore::URL::URL):
        (WebCore::URL::createSoupURI):

2014-01-27  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Avoid unnecessary string duplications in FileSystemGtk
        https://bugs.webkit.org/show_bug.cgi?id=127469

        Reviewed by Martin Robinson.

        We are using fileSystemRepresentation() everywhere internally
        which returns a CString that always duplicates the string.
        Add unescapedFilename() internal helper function that returns a
        GUniquePtr and used it everywhere instead of fileSystemRepresentation().

        * platform/gtk/FileSystemGtk.cpp:
        (WebCore::unescapedFilename):
        (WebCore::fileSystemRepresentation):
        (WebCore::filenameForDisplay):
        (WebCore::fileExists):
        (WebCore::deleteFile):
        (WebCore::deleteEmptyDirectory):
        (WebCore::getFileStat):
        (WebCore::getFileSize):
        (WebCore::getFileModificationTime):
        (WebCore::getFileMetadata):
        (WebCore::pathByAppendingComponent):
        (WebCore::makeAllDirectories):
        (WebCore::pathGetFileName):
        (WebCore::directoryName):
        (WebCore::listDirectory):
        (WebCore::openFile):

2014-01-27  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Make webkit_uri_scheme_request_get_web_view() work with CustomProtocols
        https://bugs.webkit.org/show_bug.cgi?id=127614

        Reviewed by Gustavo Noronha Silva.

        Add API to set the page identifier that initiated the request to
        ResourceRequest, and remove the initiatingPageID() method from the
        NetworkingContext class.

        * platform/network/NetworkingContext.h:
        * platform/network/ResourceHandle.h:
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::createSoupRequestAndMessageForHandle):
        * platform/network/soup/ResourceRequest.h:
        (WebCore::ResourceRequest::ResourceRequest):
        (WebCore::ResourceRequest::initiatingPageID):
        (WebCore::ResourceRequest::setInitiatingPageID):
        * platform/network/soup/ResourceRequestSoup.cpp:
        (WebCore::ResourceRequest::updateSoupRequest):
        (WebCore::ResourceRequest::updateFromSoupRequest):

2014-01-27  Tim Horton  <timothy_horton@apple.com>

        Lots of varied and random crashes on the scrolling thread (ScrollbarPainters are going away)
        https://bugs.webkit.org/show_bug.cgi?id=127734
        <rdar://problem/15906263>

        Reviewed by Simon Fraser.

        * page/scrolling/ScrollingStateScrollingNode.h:
        Retain the ScrollbarPainters in the scrolling state tree.

2014-01-27  Joseph Pecoraro  <pecoraro@apple.com>

        Unreviewed iOS build fix. FALLTHROUGHs for iOS.

        * accessibility/ios/WebAccessibilityObjectWrapperIOS.mm:
        (-[WebAccessibilityObjectWrapper accessibilityTraits]):
        (-[WebAccessibilityObjectWrapper determineIsAccessibilityElement]):

2014-01-27  Roger Fong  <roger_fong@apple.com>

        WebGLLoadPolicy::WebGLAsk is an unnecessary value.
        https://bugs.webkit.org/show_bug.cgi?id=127755

        Reviewed by Anders Carlsson.

        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::getContext):
        * loader/FrameLoaderTypes.h:

2014-01-27  Brady Eidson  <beidson@apple.com>

        IDB: Cursor support - Messaging, IPC, Threading plumbing
        https://bugs.webkit.org/show_bug.cgi?id=127736

        Reviewed by Sam Weinig.

        * Modules/indexeddb/IDBCursorBackendOperations.h:
        (WebCore::CursorIterationOperation::cursorID):
        (WebCore::CursorAdvanceOperation::cursorID):

        * Modules/indexeddb/IDBTransactionBackendOperations.h:
        (WebCore::OpenCursorOperation::transactionID):

        * WebCore.exp.in:

2014-01-27  Joseph Pecoraro  <pecoraro@apple.com>

        WebCore: Enable -Wimplicit-fallthrough and add FALLTHROUGH annotation where needed
        https://bugs.webkit.org/show_bug.cgi?id=127671

        Reviewed by Ryosuke Niwa.

        * Configurations/Base.xcconfig:
        Enable the warning.

        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::applyProperty):
        Caught a bug. CSSPropertyWebkitAlt could fall through to CSSPropertyQuotes.

        * css/SVGCSSParser.cpp:
        (WebCore::CSSParser::parseSVGValue):
        Caught a bug. CSSPropertyWebkitSvgShadow could fall through to CSSPropertyMaskType.

        * platform/Decimal.cpp:
        (WebCore::Decimal::fromString):
        Possible bug. Implementation doesn't seem to match its documentation.
        Filed an issue to follow-up on this unclear function.

        * css/makeprop.pl:
        * css/makevalues.pl:
        * platform/ColorData.gperf:
        Ignore implicit fallthrough warnings in generated code. gperf outputs
        a "/*FALLTHROUGH*/" comment, but is not easily customizable to change
        this output. Easiest to just ignore the warning for now.

        * rendering/AutoTableLayout.cpp:
        (WebCore::AutoTableLayout::recalcColumn):
        (WebCore::AutoTableLayout::calcEffectiveLogicalWidth):
        (WebCore::AutoTableLayout::layout):
        There has been a "fall through" comment immediately followed by a break
        since its introduction in 2003. Removing the inaccurate comment.

        * accessibility/AccessibilityNodeObject.cpp:
        (WebCore::AccessibilityNodeObject::canHaveChildren):
        (WebCore::AccessibilityNodeObject::visibleText):
        (WebCore::AccessibilityNodeObject::title):
        * accessibility/mac/WebAccessibilityObjectWrapperBase.mm:
        (-[WebAccessibilityObjectWrapperBase accessibilityDescription]):
        (-[WebAccessibilityObjectWrapperBase accessibilityHelpText]):
        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::CloneSerializer::serialize):
        (WebCore::CloneDeserializer::deserialize):
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::ComputedStyleExtractor::propertyValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        (WebCore::CSSParser::parseContent):
        (WebCore::CSSParser::realLex):
        * css/CSSSelector.cpp:
        (WebCore::CSSSelector::extractPseudoType):
        (WebCore::CSSSelector::selectorText):
        * css/StyleProperties.cpp:
        (WebCore::StyleProperties::asText):
        * css/StyleSheetContents.cpp:
        (WebCore::childRulesHaveFailedOrCanceledSubresources):
        * dom/Node.cpp:
        (WebCore::appendTextContent):
        * html/parser/HTMLTreeBuilder.cpp:
        (WebCore::HTMLTreeBuilder::processStartTag):
        (WebCore::HTMLTreeBuilder::processEndTag):
        (WebCore::HTMLTreeBuilder::processCharacterBuffer):
        (WebCore::HTMLTreeBuilder::processEndOfFile):
        * loader/cache/CachedResourceLoader.cpp:
        (WebCore::CachedResourceLoader::requestResource):
        * page/EventSource.cpp:
        (WebCore::EventSource::parseEventStream):
        * platform/DateComponents.cpp:
        (WebCore::DateComponents::toStringForTime):
        * platform/graphics/avfoundation/MediaPlayerPrivateAVFoundation.cpp:
        (WebCore::MediaPlayerPrivateAVFoundation::updateStates):
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::platformInit):
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::totalBytes):
        * platform/graphics/win/FullScreenController.cpp:
        (FullScreenController::Private::fullscreenClientWndProc):
        * platform/text/BidiResolver.h:
        (WebCore::Run>::updateStatusLastFromCurrentDirection):
        (WebCore::Run>::createBidiRunsForLine):
        * platform/text/win/LocaleWin.cpp:
        (WebCore::LocaleWin::initializeLocaleData):
        * rendering/PointerEventsHitRules.cpp:
        (WebCore::PointerEventsHitRules::PointerEventsHitRules):
        * rendering/RenderBlockFlow.cpp:
        (WebCore::RenderBlockFlow::newLine):
        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::RenderBlockFlow::updateLogicalWidthForAlignment):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::computeReplacedLogicalWidthUsing):
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::calculateFillTileSize):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::drawLineForBoxSide):
        * rendering/RenderQuote.cpp:
        (WebCore::RenderQuote::originalText):
        * rendering/RenderReplaced.cpp:
        (WebCore::RenderReplaced::replacedContentRect):
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::addChild):
        * rendering/RenderTheme.cpp:
        (WebCore::RenderTheme::adjustStyle):
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::setWordSpacing):
        * rendering/svg/RenderSVGResource.cpp:
        (WebCore::requestPaintingResource):
        * rendering/svg/SVGMarkerData.h:
        (WebCore::SVGMarkerData::updateMarkerDataForPathElement):
        * svg/SVGPathParser.cpp:
        (WebCore::SVGPathParser::parsePathDataFromSource):
        * svg/SVGTransformDistance.cpp:
        (WebCore::SVGTransformDistance::SVGTransformDistance):
        (WebCore::SVGTransformDistance::scaledDistance):
        (WebCore::SVGTransformDistance::addSVGTransforms):
        (WebCore::SVGTransformDistance::addToSVGTransform):
        (WebCore::SVGTransformDistance::distance):
        Add annotation or break before falling into a default:break;

2014-01-27  Andreas Kling  <akling@apple.com>

        Allow mmap encoded data replacement for WOFF fonts.
        <https://webkit.org/b/127737>

        We always have to convert WOFF fonts to SFNT format. This happens
        in a separate buffer from the CachedFont's internal resource buffer.
        Because of this, there's no need to protect the original buffer from
        mmap replacement.

        With this change, WOFF web fonts are no longer duplicated between
        the network and web processes.

        Reviewed by Brady Eidson.

        * loader/cache/CachedFont.cpp:
        (WebCore::CachedFont::CachedFont):
        (WebCore::CachedFont::ensureCustomFontData):
        (WebCore::CachedFont::mayTryReplaceEncodedData):
        * loader/cache/CachedFont.h:

2014-01-27  David Hyatt  <hyatt@apple.com>

        [New Multicolumn] Add support for block progression axis and reverse direction
        https://bugs.webkit.org/show_bug.cgi?id=127715

        Reviewed by thorton.

        This patch adds support for -webkit-progression-direction and -webkit-progression-axis
        to the new column code. This allows columns to stack along the block axis instead of
        the inline axis or to reverse directions along that progression axis.

        Added fast/multicol/newmulticol/progression-reverse.html and
              fast/multicol/newmulticol/progression-reverse-overflow.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::isTopLayoutOverflowAllowed):
        (WebCore::RenderBlock::isLeftLayoutOverflowAllowed):
        New functions have been added for top and left layout overflow in order to get
        a bunch of code out of RenderBox that didn't belong there. RenderBlock is overriding
        the functions for the old multicolumn layout code to keep it working.

        * rendering/RenderBlock.h:
        Added the new top/left overflow functions.

        * rendering/RenderBlockFlow.cpp:
        (WebCore::RenderBlockFlow::determineLogicalLeftPositionForChild):
        Moved from RenderBlock, since it didn't belong there.

        (WebCore::RenderBlockFlow::isTopLayoutOverflowAllowed):
        (WebCore::RenderBlockFlow::isLeftLayoutOverflowAllowed):
        * rendering/RenderBlockFlow.h:
        Overridden for the new multi-column code to specify when top/left overflow are
        allowed (e.g., when the columns go backwards).

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::addLayoutOverflow):
        Overridden to use the new top/left overflow functions.

        * rendering/RenderBox.h:
        (WebCore::RenderBox::isTopLayoutOverflowAllowed):
        (WebCore::RenderBox::isLeftLayoutOverflowAllowed):
        Added base definitions that look at direction and writing-mode.

        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::isTopLayoutOverflowAllowed):
        (WebCore::RenderFlexibleBox::isLeftLayoutOverflowAllowed):
        * rendering/RenderFlexibleBox.h:
        Overrides for flexible box of the top/left overflow functions.

        * rendering/RenderMultiColumnFlowThread.h:
        Make sure requiresBalancing() is set to false if the axis of the columns
        is block, since at least right now, we don't support balancing columns
        along the block axis. (In theory we could support this in the future, but
        nobody has requested it.)

        * rendering/RenderMultiColumnSet.cpp:
        (WebCore::RenderMultiColumnSet::updateLogicalWidth):
        Remove the code that expands the width of multi column sets. We now always
        let their logical width match the containing block's content width and instead
        add the overflow to the set itself.

        (WebCore::RenderMultiColumnSet::columnRectAt):
        (WebCore::RenderMultiColumnSet::flowThreadPortionOverflowRect):
        (WebCore::RenderMultiColumnSet::paintColumnRules):
        (WebCore::RenderMultiColumnSet::initialBlockOffsetForPainting):
        (WebCore::RenderMultiColumnSet::collectLayerFragments):
        (WebCore::RenderMultiColumnSet::adjustRegionBoundsFromFlowThreadPortionRect):
        Patch all of these functions to know how to handle a block axis or reversed
        direction.

        (WebCore::RenderMultiColumnSet::addOverflowFromChildren):
        * rendering/RenderMultiColumnSet.h:
        Make multi-column set add in its overflow in the same way that the old
        multi-column code did, by looking at the last column rect. (This is really
        not a very good way to do it, but it's the same as the old code for now.)

2014-01-27  Daniel Bates  <dabates@apple.com>

        Fix the Mac build following <http://trac.webkit.org/changeset/162887>
        (https://bugs.webkit.org/show_bug.cgi?id=127703)

        Export symbol for WebCore::AXObjectCache::enableAccessibility().

        * WebCore.exp.in:

2014-01-27  Roger Fong  <roger_fong@apple.com>

        [Mac] Unreviewed build fix. Add missing export symbol.

        * WebCore.exp.in:

2014-01-27  Roger Fong  <roger_fong@apple.com>

        [Windows] Tests crashing on Windows after r162816.
        https://bugs.webkit.org/show_bug.cgi?id=127703.

        Reviewed by Alexey Proskuryakov.

        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::enableAccessibility):
        (WebCore::AXObjectCache::disableAccessibility):
        * accessibility/AXObjectCache.h: Un-inline some methods so that they can be exported.

2014-01-27  Andy Estes  <aestes@apple.com>

        Update bindings test expectations after r162872

        * bindings/scripts/test/ObjC/DOMTestInterface.h:
        * bindings/scripts/test/ObjC/DOMTestObj.h:

2014-01-27  Andy Estes  <aestes@apple.com>

        Scrub WebKit API headers of WTF macros
        https://bugs.webkit.org/show_bug.cgi?id=127706

        Reviewed by David Kilzer.

        * Configurations/FeatureDefines.xcconfig: Added ENABLE_INSPECTOR.
        * bindings/objc/DOMEvents.h: Guarded include of
        DOM{Gesture,Touch}Event.h with TARGET_OS_IPHONE, since those features
        are always enabled on iOS.
        * platform/graphics/mac/MediaPlayerProxy.h: Replaced PLATFORM(IOS) with
        TARGET_OS_IPHONE and ensured ENABLE_IOS_AIRPLAY is defined.
        * platform/ios/SystemMemory.h: Replaced PLATFORM(IOS) with
        TARGET_OS_IPHONE.
        * platform/ios/wak/WKGraphics.h: Replaced PLATFORM(IOS_SIMULATOR) with
        TARGET_IPHONE_SIMULATOR.

2014-01-27  Jer Noble  <jer.noble@apple.com>

        [iOS] Use callOnMainThread() not dispatch_async() in MediaPlayerPrivateAVFoundationObjC
        https://bugs.webkit.org/show_bug.cgi?id=127701

        Reviewed by Eric Carlson.

        dispatch_async(dispatch_get_main_queue(), ...) used to be fine so long as the main
        thread was also the web thread. But since that's not the case on iOS, we should be
        using callOnMainThread() instead (because it dispatches to the web thread, not as
        its name implies, the main thread).

        * platform/graphics/avfoundation/objc/MediaPlayerPrivateAVFoundationObjC.h:
        (WebCore::MediaPlayerPrivateAVFoundationObjC::createWeakPtr):
        * platform/graphics/avfoundation/objc/MediaPlayerPrivateAVFoundationObjC.mm:
        (WebCore::MediaPlayerPrivateAVFoundationObjC::MediaPlayerPrivateAVFoundationObjC):
        (WebCore::MediaPlayerPrivateAVFoundationObjC::createVideoLayer):
        (WebCore::MediaPlayerPrivateAVFoundationObjC::seekToTime):
        (-[WebCoreAVFMovieObserver legibleOutput:didOutputAttributedStrings:nativeSampleBuffers:forItemTime:]):
        (-[WebCoreAVFMovieObserver outputSequenceWasFlushed:]):
        (-[WebCoreAVFLoaderDelegate resourceLoader:shouldWaitForLoadingOfRequestedResource:]):
        (-[WebCoreAVFLoaderDelegate resourceLoader:shouldWaitForResponseToAuthenticationChallenge:]):
        (-[WebCoreAVFLoaderDelegate resourceLoader:didCancelLoadingRequest:]):

2014-01-27  Maciej Stachowiak  <mjs@apple.com>

        Move Conditional=BLOB from URL interface to Blob-related methods, to prepare for adding URL API
        https://bugs.webkit.org/show_bug.cgi?id=127719

        Reviewed by Sam Weinig.

        * html/DOMURL.idl:

2014-01-27  Andreas Kling  <akling@apple.com>

        Remove unused USE(OPENTYPE_SANITIZER) code.
        <https://webkit.org/b/127710>

        This code was only used by the Chromium port.

        Reviewed by Darin Adler.

        * GNUmakefile.list.am:
        * WebCore.xcodeproj/project.pbxproj:
        * loader/cache/CachedFont.cpp:
        (WebCore::CachedFont::ensureCustomFontData):
        * platform/graphics/WOFFFileFormat.cpp:
        * platform/graphics/WOFFFileFormat.h:
        * platform/graphics/opentype/OpenTypeSanitizer.cpp: Removed.
        * platform/graphics/opentype/OpenTypeSanitizer.h: Removed.


2014-01-27  Andy Estes  <aestes@apple.com>

        Stop the code generator from adding ENABLE() macros to Objective-C DOM headers
        https://bugs.webkit.org/show_bug.cgi?id=127706

        Reviewed by David Kilzer.

        Instead of adding ENABLE() macros to generated Objective-C DOM
        headers, which might become Public or Private headers, elide generated
        code for disabled features.

        * bindings/scripts/CodeGeneratorObjC.pm:
        (GenerateInterface): Passed $defines to GenerateHeader.
        (ConditionalIsEnabled): Checked if the given conditional is found in
        $defines. Handled conditionals with '&' and '|'.
        (GenerateHeader): Rather than calling GenerateConditionalString to
        generate an "#if ENABLE(...)", called ConditionalIsEnabled() to see
        whether we should generate code for the given constant, attribute, or
        function.

2014-01-27  Zoltan Horvath  <zoltan@webkit.org>

        [CSS Shapes] Remove restriction of negative values for inset parameters
        https://bugs.webkit.org/show_bug.cgi?id=127704

        Reviewed by Darin Adler.

        The latest version of CSS Shapes (http://www.w3.org/TR/css-shapes/) specification
        doesn't contain any restriction of using negative values for the inset sizing.
        I removed the restriction from the code and added testing for them.

        Existing tests have been extended with the new cases.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseBasicShapeInset):

2014-01-27  Eric Carlson  <eric.carlson@apple.com>

        [iOS] preload=none prevents play()
        https://bugs.webkit.org/show_bug.cgi?id=127702

        Reviewed by Jer Noble.

        No new tests, covered by existing tests.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::potentiallyPlaying): Cleanup logic to make it simpler to understand,
            fix logic error introduced in r161973
        (WebCore::HTMLMediaElement::updatePlayState): Conditionalize some iOS-only code on whether or not
            we are using the plug-in proxy.

2014-01-27  Brady Eidson  <beidson@apple.com>

        IDB: LevelDB backing store shouldn't know about IDBCursor or IDBCallbacks
        https://bugs.webkit.org/show_bug.cgi?id=127708

        Reviewed by Tim Horton.

        Move that knowledge to the IDBCursorBackendOperations inside the callback.

        * Modules/indexeddb/IDBCursorBackendOperations.cpp:
        (WebCore::CursorAdvanceOperation::perform):
        (WebCore::CursorIterationOperation::perform):
        * Modules/indexeddb/IDBCursorBackendOperations.h:

        * Modules/indexeddb/IDBServerConnection.h:
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.cpp:
        (WebCore::IDBServerConnectionLevelDB::cursorAdvance):
        (WebCore::IDBServerConnectionLevelDB::cursorIterate):
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.h:

2014-01-27  Brady Eidson  <beidson@apple.com>

        IDB: Remove unused concept of "cursor prefetch"
        https://bugs.webkit.org/show_bug.cgi?id=127700

        Reviewed by Tim Horton.

        * Modules/indexeddb/IDBCursorBackend.cpp:
        * Modules/indexeddb/IDBCursorBackend.h:
        * Modules/indexeddb/IDBCursorBackendOperations.cpp:
        * Modules/indexeddb/IDBCursorBackendOperations.h:
        * Modules/indexeddb/IDBServerConnection.h:
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.cpp:
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.h:

2014-01-27  Brady Eidson  <beidson@apple.com>

        IDB: Refactor out the last of the operation callbacks that are called by the LevelDB backing store
        https://bugs.webkit.org/show_bug.cgi?id=127592

        Reviewed by Tim Horton.

        For each of the 3 remaining operations where the backing store calls callbacks directly,
        factor out the callbacks to the operation itself.


        * Modules/indexeddb/IDBTransactionBackendOperations.cpp:
        (WebCore::OpenCursorOperation::perform):
        (WebCore::CountOperation::perform):
        (WebCore::DeleteRangeOperation::perform):
        * Modules/indexeddb/IDBTransactionBackendOperations.h:

        * Modules/indexeddb/IDBServerConnection.h:
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.cpp:
        (WebCore::IDBServerConnectionLevelDB::openCursor):
        (WebCore::IDBServerConnectionLevelDB::count):
        (WebCore::IDBServerConnectionLevelDB::deleteRange):
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.h:

2014-01-27  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r162755.
        http://trac.webkit.org/changeset/162755
        https://bugs.webkit.org/show_bug.cgi?id=127696

        not quite right, breaks subframe scrolling in some cases
        (Requested by thorton on #webkit).

        * page/scrolling/ScrollingTree.cpp:
        (WebCore::ScrollingTree::ScrollingTree):
        (WebCore::ScrollingTree::shouldHandleWheelEventSynchronously):
        (WebCore::ScrollingTree::removeDestroyedNodes):
        * page/scrolling/ScrollingTree.h:
        * page/scrolling/mac/ScrollingTreeScrollingNodeMac.mm:
        (WebCore::ScrollingTreeScrollingNodeMac::handleWheelEvent):

2014-01-27  Zoltan Horvath  <zoltan@webkit.org>

        [CSS Shapes] inset() function with multiple spaces on element style
        https://bugs.webkit.org/show_bug.cgi?id=127617

        Reviewed by Dirk Schulze.

        When only a subset of parameters were defined for an inset shape, the built
        inset string contained some extra spaces. This patch fixes the behavior and
        adds tests for the case. I also removed the string allocation optimization from
        buildInsetString, since it's not worthwhile to always allocate as many memory
        as needed for a fully defined inset.

        I added the new test cases to the shapes parser code test.

        * css/CSSBasicShapes.cpp:
        (WebCore::buildInsetString):

2014-01-27  Antti Koivisto  <antti@apple.com>

        * WebCore.exp.in: Add export needed for iOS.

2014-01-27  Antti Koivisto  <antti@apple.com>

        REGRESSION(r133214): Don't invalidate style when adding classes that don't match rules
        https://bugs.webkit.org/show_bug.cgi?id=126177

        Reviewed by Anders Carlsson.
        
        Spotted by Elliott Sprehn in Chromium.

        * dom/Element.cpp:
        (WebCore::checkSelectorForClassChange):
        
            Remove unnecessary templating.

        (WebCore::Element::classAttributeChanged):
        
            Fix logic error with 'continue'.

2014-01-27  Brendan Long  <b.long@cablelabs.com>

        [GStreamer] Lockup when playing Icecast radio
        https://bugs.webkit.org/show_bug.cgi?id=127452

        Reviewed by Philippe Normand.

        No new tests. This bug can only be demonstrated with an Icecast stream, and it's
        not clear how to do that in our testing framework.

        * platform/graphics/gstreamer/WebKitWebSourceGStreamer.cpp:
        (StreamingClient::handleResponseReceived): Wait until we unlock to send notifications.

2014-01-27  Jessie Berlin  <jberlin@apple.com>

        Build fix after r162838.

        * page/FrameView.cpp:
        Remove an unused constant.

2014-01-27  Antti Koivisto  <antti@apple.com>

        Remove repaint throttling
        https://bugs.webkit.org/show_bug.cgi?id=127681

        Reviewed by Sam Weinig.

        Nowadays we throttle layer flushes. This code is unnecessary.

        * WebCore.exp.in:
        * dom/Document.cpp:
        (WebCore::Document::recalcStyle):
        * dom/Element.cpp:
        (WebCore::Element::classAttributeChanged):
        * editing/AlternativeTextController.cpp:
        (WebCore::AlternativeTextController::insertDictatedText):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::checkCompleted):
        * page/EventHandler.cpp:
        (WebCore::EventHandler::dispatchDragEvent):
        (WebCore::EventHandler::dispatchMouseEvent):
        (WebCore::EventHandler::keyEvent):
        (WebCore::EventHandler::handleTextInputEvent):
        * page/FrameView.cpp:
        (WebCore::FrameView::FrameView):
        (WebCore::FrameView::reset):
        (WebCore::FrameView::flushCompositingStateForThisFrame):
        (WebCore::FrameView::layout):
        (WebCore::FrameView::repaintContentRectangle):
        (WebCore::FrameView::disableLayerFlushThrottlingTemporarilyForInteraction):
        (WebCore::FrameView::updateLayoutAndStyleIfNeededRecursive):
        * page/FrameView.h:
        * rendering/RenderView.cpp:
        (WebCore::RenderView::setSelection):

2014-01-24  Eric Carlson  <eric.carlson@apple.com>

        Merge Chromium TextTrack cleanups
        https://bugs.webkit.org/show_bug.cgi?id=127483

        Reviewed by Darin Adler.

        Merge some TextTrack cleanups:
        https://chromium.googlesource.com/chromium/blink/+/b571b9fbc6e62e05aa77a402cf8f447e681b8ee3
        https://chromium.googlesource.com/chromium/blink/+/6b1940151258150ea01bcf21ebfd958e2af247f4
        https://chromium.googlesource.com/chromium/blink/+/397c2a2d9416f5c0d79bca22d6979f174eefcce2
        https://chromium.googlesource.com/chromium/blink/+/f42ad93e25c6310b2b0327ab7ce5d82d3c4a6c1b
        https://chromium.googlesource.com/chromium/blink/+/d55b52b53b7da05bba5fe378a4278250b9347430
        https://chromium.googlesource.com/chromium/blink/+/cac766ecaaac477a08879f0b3157d0327cc75d96
        https://chromium.googlesource.com/chromium/blink/+/6197ce278696cdd52fc2ad81893f369492468ca0

        * html/HTMLTrackElement.cpp:
        (WebCore::HTMLTrackElement::loadTimerFired): Remove the LoadableTextTrack* parameter, it isn't used.
        (WebCore::HTMLTrackElement::didCompleteLoad): Ditto.
        * html/HTMLTrackElement.h: didCompleteLoad doesn't need to be virtual.

        * html/track/LoadableTextTrack.cpp:
        (WebCore::LoadableTextTrack::loadTimerFired): Pass a reference, not a pointer.
        (WebCore::LoadableTextTrack::cueLoadingStarted): Removed, it wasn't used.
        (WebCore::LoadableTextTrack::cueLoadingCompleted): Pass a reference, not a pointer.
        * html/track/LoadableTextTrack.h: Delete LoadableTextTrackClient, it is no longer used.

        * loader/TextTrackLoader.cpp:
        (WebCore::TextTrackLoader::TextTrackLoader): Take a TextTrackLoaderClient reference.
        (WebCore::TextTrackLoader::~TextTrackLoader): Rename m_cachedCueData m_resource.
        (WebCore::TextTrackLoader::cueLoadTimerFired): m_client is a reference.
        (WebCore::TextTrackLoader::cancelLoad): m_cachedCueData -> m_resource.
        (WebCore::TextTrackLoader::processNewCueData): Ditto.
        (WebCore::TextTrackLoader::deprecatedDidReceiveCachedResource): Ditto.
        (WebCore::TextTrackLoader::notifyFinished): Ditto.
        (WebCore::TextTrackLoader::load): shouldLoadCues was removed from the client interface because
            the only implementation always returned true.
        (WebCore::TextTrackLoader::newRegionsParsed): m_client is a reference
        * loader/TextTrackLoader.h:

        * loader/cache/CachedResourceLoader.cpp:
        (WebCore::CachedResourceLoader::canRequest): Remove an outdated comment.

2014-01-27  Chris Fleizach  <cfleizach@apple.com>

        AX: Disable accessibility after every test run
        https://bugs.webkit.org/show_bug.cgi?id=127439

        Reviewed by Csaba Osztrogonác.

        Speculative fix for EFL build. Don't process these notifications unless accessibility is enabled.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::prepareForLoadStart):

2014-01-27  Csaba Osztrogonác  <ossy@webkit.org>

        Buildfix for !ENABLE(COMPARE_AND_SWAP) platforms after r162774
        https://bugs.webkit.org/show_bug.cgi?id=127678

        Reviewed by Zoltan Herczeg.

        * platform/text/TextBreakIterator.cpp:
        (WebCore::compareAndSwapNonSharedCharacterBreakIterator):
        Use std::mutex instead of Mutex and std::lock_guard instead of MutexLocker.

2014-01-26  Tim Horton  <timothy_horton@apple.com>

        Fix the iOS build (failed to correctly revert some broken changes in the last patch).

        * platform/graphics/cg/BitmapImageCG.cpp:

2014-01-26  Tim Horton  <timothy_horton@apple.com>

        Start cleaning up iOS upstreaming #ifs in platform/graphics
        https://bugs.webkit.org/show_bug.cgi?id=127641

        Reviewed by Sam Weinig.

        * platform/graphics/BitmapImage.h:
        * platform/graphics/mac/ColorMac.h:
        Use USE(APPKIT) instead of PLATFORM(MAC) && !PLATFORM(IOS) for NSImage/getNSImage().

        * platform/graphics/avfoundation/AVTrackPrivateAVFObjCImpl.mm:
        (WebCore::AVTrackPrivateAVFObjCImpl::label):
        * platform/graphics/avfoundation/objc/InbandTextTrackPrivateLegacyAVFObjC.mm:
        (WebCore::InbandTextTrackPrivateLegacyAVFObjC::label):
        * platform/graphics/avfoundation/objc/MediaPlayerPrivateAVFoundationObjC.mm:
        (WebCore::MediaPlayerPrivateAVFoundationObjC::createAVAssetForURL):
        Remove some code that was only used on OS X on Lion or below.

        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::platformInit):
        ToT WebKit doesn't build on Lion or earlier anymore, so this code can always run.

        * platform/graphics/cg/FloatPointCG.cpp:
        * platform/graphics/cg/FloatRectCG.cpp:
        * platform/graphics/cg/FloatSizeCG.cpp:
        * platform/graphics/cg/GradientCG.cpp:
        * platform/graphics/cg/ImageBufferCG.cpp:
        * platform/graphics/cg/ImageCG.cpp:
        * platform/graphics/cg/IntPointCG.cpp:
        * platform/graphics/cg/IntRectCG.cpp:
        * platform/graphics/cg/PathCG.cpp:
        * platform/graphics/cg/PatternCG.cpp:
        * platform/graphics/mac/FontCustomPlatformData.cpp:
        Use CoreGraphics/CoreGraphics.h instead of ApplicationServices/ApplicationServices.h
        even on Mac, so we can share the include.

        * platform/graphics/cg/IntSizeCG.cpp:
        Remove a random comment of a style we don't tend to use in WebKit,
        and from a file not large enough to need it.

        * platform/graphics/cocoa/FontPlatformDataCocoa.mm:
        (WebCore::FontPlatformData::FontPlatformData):
        (WebCore::FontPlatformData::setFont):
        Remove some more always-true #ifs.

        * platform/graphics/mac/WebLayer.mm:
        Move a #if'd include out to its own block as per the style guide.

2014-01-26  David Hyatt  <hyatt@apple.com>

        [New Multicolumn] Make sure the progression axis and direction are propagated to the new columns.
        https://bugs.webkit.org/show_bug.cgi?id=127670

        This patch makes sure that the progression axis and direction style properties
        are properly propagated from the style to the multi-column flow thread. Virtualizing
        and renaming updateColumnInfoFromStyle to updateColumnProgressionFromStyle lets us
        share code between the old multi-column code and the new.

        Reviewed by Sam Weinig.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::updateColumnProgressionFromStyle):
        * rendering/RenderBlock.h:
        * rendering/RenderBlockFlow.cpp:
        (WebCore::RenderBlockFlow::setComputedColumnCountAndWidth):
        (WebCore::RenderBlockFlow::updateColumnProgressionFromStyle):
        * rendering/RenderBlockFlow.h:
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::styleDidChange):
        * rendering/RenderMultiColumnFlowThread.cpp:
        (WebCore::RenderMultiColumnFlowThread::RenderMultiColumnFlowThread):
        * rendering/RenderMultiColumnFlowThread.h:
        * style/StyleResolveForDocument.cpp:
        (WebCore::Style::resolveForDocument):

2014-01-26  David Hyatt  <hyatt@apple.com>

        [New Multicolumn] Change the axis property to be a boolean like other isInline checks
        https://bugs.webkit.org/show_bug.cgi?id=127661

        Reviewed by Simon Fraser.

        * rendering/ColumnInfo.h:
        (WebCore::ColumnInfo::ColumnInfo):
        (WebCore::ColumnInfo::progressionIsInline):
        (WebCore::ColumnInfo::setProgressionIsInline):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintColumnRules):
        (WebCore::RenderBlock::initialBlockOffsetForPainting):
        (WebCore::RenderBlock::blockDeltaForPaintingNextColumn):
        (WebCore::RenderBlock::setComputedColumnCountAndWidth):
        (WebCore::RenderBlock::updateColumnInfoFromStyle):
        (WebCore::RenderBlock::columnRectAt):
        (WebCore::RenderBlock::adjustPointToColumnContents):
        (WebCore::RenderBlock::adjustRectForColumns):
        (WebCore::RenderBlock::adjustForColumns):
        * rendering/RenderMultiColumnFlowThread.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::columnNumberForOffset):

2014-01-26  Benjamin Poulain  <benjamin@webkit.org>

        Make DOMStringMap a typedef of DatasetDOMStringMap
        https://bugs.webkit.org/show_bug.cgi?id=127658

        Reviewed by Sam Weinig.

        The only concrete implementation of DOMStringMap is DatasetDOMStringMap.
        The abstract interface for a single definition is adding complexity for no gain.

        This patch removes DOMStringMap and simply keeps the name through a typedef.
        I used a typedef instead of just renaming DatasetDOMStringMap because I think
        having both name has value. DatasetDOMStringMap is a better description of what
        the implementation does. DOMStringMap is the public name and the classname is
        the same as the JavaScript type by convention.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/DOMAllInOne.cpp:
        * dom/DOMStringMap.cpp: Removed.
        * dom/DOMStringMap.h:
        * dom/DatasetDOMStringMap.h:
        * dom/Element.cpp:
        (WebCore::Element::dataset):
        * dom/Element.h:

2014-01-26  David Kilzer  <ddkilzer@apple.com>

        Part 2: Assertion failure in WebCore::PseudoElement::didRecalcStyle()
        <https://bugs.webkit.org/show_bug.cgi?id=126761>
        <rdar://problem/15793540>

        Reviewed by Simon Fraser.

        * bindings/objc/DOM.mm:
        (-[DOMElement image]):
        (-[DOMElement _imageTIFFRepresentation]):
        * platform/gtk/PasteboardGtk.cpp:
        (WebCore::Pasteboard::writeImage):
        * platform/win/PasteboardWin.cpp:
        (WebCore::Pasteboard::writeImage):
        (WebCore::getCachedImage):
        * rendering/HitTestResult.cpp:
        (WebCore::HitTestResult::image):
        - More places where toRenderImage() should be used instead of
          toImage().
        - Fixed last two places where static_cast<WebCore::RenderImage*>
          was being used instead of toRenderImage().

2014-01-26  Chris Fleizach  <cfleizach@apple.com>

        AX: Disable accessibility after every test run
        https://bugs.webkit.org/show_bug.cgi?id=127439

        Reviewed by Alexey Proskuryakov.

        If accessibility is disabled, we may still need to return the existing 
        AXObjectCache, so that objects can be cleaned up appropriately.

        A such we have to be prepared to handle a nullptr return value in more cases.

        * accessibility/AXObjectCache.h:
        (WebCore::AXObjectCache::disableAccessibility):
        * accessibility/AccessibilityNodeObject.cpp:
        (WebCore::AccessibilityNodeObject::childrenChanged):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::remoteSVGRootElement):
        * dom/Document.cpp:
        (WebCore::Document::existingAXObjectCache):

2014-01-26  Anders Carlsson  <andersca@apple.com>

        Move history item visit count handling to WebKit
        https://bugs.webkit.org/show_bug.cgi?id=127659

        Reviewed by Dan Bernstein.

        Remove all members dealing with visit handling - they're going back to WebKit.

        * WebCore.exp.in:
        * history/HistoryItem.cpp:
        (WebCore::HistoryItem::HistoryItem):
        (WebCore::HistoryItem::reset):
        (WebCore::HistoryItem::decodeBackForwardTree):
        * history/HistoryItem.h:
        (WebCore::HistoryItem::create):

2014-01-26  Anders Carlsson  <andersca@apple.com>

        Move lastVisitWasHTTPNonGet out to WebHistoryItem
        https://bugs.webkit.org/show_bug.cgi?id=127657

        Reviewed by Dan Bernstein.

        Remove m_lastVisitWasHTTPNonGet, it's only used by WebKit.

        * history/HistoryItem.cpp:
        (WebCore::HistoryItem::HistoryItem):
        (WebCore::HistoryItem::reset):
        * history/HistoryItem.h:

2014-01-26  Zalan Bujtas  <zalan@apple.com>

        Subpixel Layout: Align <input type="button", submit etc (PushButtonPart) top and bottom paddings with <button>
        https://bugs.webkit.org/show_bug.cgi?id=127640

        Reviewed by Simon Fraser.

        <button> sets padding-top: 2px and padding-bottom: 3px as default values (html.css),
        while <input type="button" (submit, etc) has the hardcoded values of 0, 0 and we center the text using the available space.
        This results in different baseline text position in normal cases. This adjustment puts the <input type='button'
        rendering back to the pre-subpixel layout state.

        * platform/mac/ThemeMac.mm:
        (WebCore::ThemeMac::controlPadding):

2014-01-26  Benjamin Poulain  <bpoulain@apple.com>

        Improve the bindings of NodeList's name accessor
        https://bugs.webkit.org/show_bug.cgi?id=127358

        Reviewed by Geoffrey Garen.

        When accessing an item of NodeList by name, the default bindings was
        going through the list of node twice:
        -First, getOwnProperty calls canGetItemsForName() to find if a property exists for
         the given name. This in turn used NodeList::namedItem() which is a slow operation.
        -Then, the value itself was queried through nameGetter(), calling NodeList::namedItem()
         a second time to find the same value.

        This patch kills the default name getter in favor of a getOwnPropertySlotDelegate() returning
        the value directly on the PropertySlot.

        Ad Hoc testing show about 15% speed up for simple cases.

        * bindings/js/JSNodeListCustom.cpp:
        (WebCore::JSNodeList::getOwnPropertySlotDelegate):
        * dom/NodeList.idl:

2014-01-26  Joseph Pecoraro  <pecoraro@apple.com>

        Web Inspector: Move InspectorDebuggerAgent into JavaScriptCore
        https://bugs.webkit.org/show_bug.cgi?id=127629

        Rubber-stamped by Sam Weinig.

        Test: inspector-protocol/debugger/pause-on-assert.html

        * CMakeLists.txt:
        * ForwardingHeaders/inspector/agents/InspectorDebuggerAgent.h: Added.
        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * inspector/InspectorAllInOne.cpp:
        - Remove InspectorDebuggerAgent.
        - Add WebDebuggerAgent (shared between Page and Worker).

        * inspector/WebDebuggerAgent.h: Added.
        (WebCore::WebDebuggerAgent::~WebDebuggerAgent):
        * inspector/WebDebuggerAgent.cpp: Added.
        (WebCore::WebDebuggerAgent::WebDebuggerAgent):
        (WebCore::WebDebuggerAgent::enable):
        (WebCore::WebDebuggerAgent::disable):
        Shared code for Page and Worker debugger agents.
        Instrumenting agents is a concept in WebCore only,
        and the Debugger agent is only in the instrumenting
        agents list when it is enabled and removed when disabled.

        * inspector/InstrumentingAgents.h:
        (WebCore::InstrumentingAgents::inspectorDebuggerAgent):
        (WebCore::InstrumentingAgents::setInspectorDebuggerAgent):
        * inspector/InspectorDOMDebuggerAgent.cpp:
        * inspector/InspectorDOMDebuggerAgent.h:
        Update namespace for debugger agent.

        * inspector/InspectorInstrumentation.cpp:
        (WebCore::isConsoleAssertMessage):
        (WebCore::InspectorInstrumentation::addMessageToConsoleImpl):
        DebuggerAgent in JavaScriptCore does not yet know about console
        types. So temporarily handle it here. We need to give JavaScriptCore
        some concept of Console messages and types.

        * inspector/PageDebuggerAgent.cpp:
        (WebCore::PageDebuggerAgent::PageDebuggerAgent):
        (WebCore::PageDebuggerAgent::enable):
        (WebCore::PageDebuggerAgent::disable):
        (WebCore::PageDebuggerAgent::sourceMapURLForScript):
        (WebCore::PageDebuggerAgent::injectedScriptForEval):
        * inspector/PageDebuggerAgent.h:
        * inspector/WorkerDebuggerAgent.cpp:
        (WebCore::WorkerDebuggerAgent::WorkerDebuggerAgent):
        (WebCore::WorkerDebuggerAgent::injectedScriptForEval):
        * inspector/WorkerDebuggerAgent.h:
        Modernize the Page and Worker debugger agents.

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        * inspector/InspectorController.h:
        * inspector/WorkerInspectorController.cpp:
        (WebCore::WorkerInspectorController::WorkerInspectorController):
        New constructors for the debugger agents.

2014-01-25  Timothy Hatcher  <timothy@apple.com>

        Remove dead code from the JSC profiler.

        https://bugs.webkit.org/show_bug.cgi?id=127643

        Reviewed by Mark Lam.

        Passes existing tests in fast/profiler.

        * bindings/js/ScriptProfile.cpp:
        (WebCore::buildInspectorObjectFor): Remove visible.
        * inspector/ScriptProfileNode.idl: Ditto.
        * inspector/protocol/Profiler.json: Ditto.

2014-01-25  Sam Weinig  <sam@webkit.org>

        Remove unused support for DRAGGABLE_REGION
        https://bugs.webkit.org/show_bug.cgi?id=127642

        Reviewed by Simon Fraser.

        * Configurations/FeatureDefines.xcconfig:
        * DerivedSources.make:
        * WebCore.exp.in:
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::ComputedStyleExtractor::propertyValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSPropertyNames.in:
        * css/CSSValueKeywords.in:
        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::applyProperty):
        * dom/Document.cpp:
        (WebCore::Document::Document):
        * dom/Document.h:
        * page/Chrome.cpp:
        * page/ChromeClient.h:
        * page/FrameView.cpp:
        (WebCore::FrameView::layout):
        (WebCore::FrameView::paintContents):
        * page/FrameView.h:
        * rendering/RenderElement.cpp:
        (WebCore::RenderElement::styleWillChange):
        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::addAnnotatedRegions):
        * rendering/RenderInline.h:
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::scrollTo):
        (WebCore::RenderLayer::setHasHorizontalScrollbar):
        (WebCore::RenderLayer::setHasVerticalScrollbar):
        (WebCore::RenderLayer::updateScrollbarsAfterLayout):
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::setHasVerticalScrollbar):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::addAnnotatedRegions):
        * rendering/RenderObject.h:
        (WebCore::AnnotatedRegionValue::operator==):
        * rendering/style/RenderStyle.h:
        * rendering/style/RenderStyleConstants.h:
        * rendering/style/StyleRareNonInheritedData.cpp:
        (WebCore::StyleRareNonInheritedData::StyleRareNonInheritedData):
        (WebCore::StyleRareNonInheritedData::operator==):
        * rendering/style/StyleRareNonInheritedData.h:

2014-01-25  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        Clean up SVGPatternElement::collectPatternAttributes 
        https://bugs.webkit.org/show_bug.cgi?id=127612

        Reviewed by Andreas Kling.

        This patch refactors SVGPatternElement::collectPatternAttributes() by extracting
        the setPatternAttributes logic into a new function. This patch also changes the
        while loop to be easier to understand and similar to collectGradientAttributes.

        * svg/SVGPatternElement.cpp:
        (WebCore::setPatternAttributes):
        (WebCore::SVGPatternElement::collectPatternAttributes):

2014-01-25  Zalan Bujtas  <zalan@apple.com>

        Subpixel layout: RenderInline is not centered when child RenderTextControl's innerTextRenderer needs bias centering.
        https://bugs.webkit.org/show_bug.cgi?id=125659

        Reviewed by Andreas Kling

        layoutMod(logicalHeightDiff, 2) fails to bias round when subpixel layout is enabled. It sets
        the denominator value to 2, which returns incorrect modulo result.
        (subpixel off: 3px % 2 = 1 vs subpixel on: (3px * 64) -> 192 % 2 = 0)

        Covered by existing tests.

        * platform/LayoutUnit.h:
        * rendering/RenderSearchField.cpp:
        (WebCore::RenderSearchField::centerContainerIfNeeded):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::centerRenderer):
        (WebCore::RenderTextControlSingleLine::layout):
        * rendering/RenderTextControlSingleLine.h:

2014-01-25  Sam Weinig  <sam@webkit.org>

        Remove more unnecessary #if PLATFORM(IOS)s in ApplicationCacheStorage.cpp
        https://bugs.webkit.org/show_bug.cgi?id=127635

        Reviewed by Antti Koivisto.

        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::executeSQLCommand):
        (WebCore::ApplicationCacheStorage::verifySchemaVersion):
        (WebCore::ApplicationCacheStorage::executeStatement):
        (WebCore::ApplicationCacheStorage::store):
        (WebCore::ApplicationCacheStorage::ensureOriginRecord):
        (WebCore::ApplicationCacheStorage::loadCache):

2014-01-25  Sam Weinig  <sam@webkit.org>

        Remove some iOS #ifdefs by adding SQLiteDatabaseTracker to all the builds
        https://bugs.webkit.org/show_bug.cgi?id=127632

        Reviewed by Darin Adler.

        Move the SQLiteDatabaseTracker and client from platform/sql/ios to platform/sql,
        as there is nothing iOS specific about it. Then, un-#ifdef all its uses. For
        ports that don't setup a client, this has no change in behavior.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * Modules/webdatabase/DatabaseBackendBase.cpp:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * loader/appcache/ApplicationCacheStorage.cpp:
        * platform/ScrollableArea.h:
        (WebCore::ScrollableArea::sendWillRevealEdgeEventsIfNeeded):
        * platform/sql/SQLiteDatabaseTracker.cpp: Copied from Source/WebCore/platform/sql/ios/SQLiteDatabaseTracker.cpp.
        * platform/sql/SQLiteDatabaseTracker.h: Copied from Source/WebCore/platform/sql/ios/SQLiteDatabaseTracker.h.
        * platform/sql/SQLiteDatabaseTrackerClient.h: Copied from Source/WebCore/platform/sql/ios/SQLiteDatabaseTrackerClient.h.
        * platform/sql/ios: Removed.
        * platform/sql/ios/SQLiteDatabaseTracker.cpp: Removed.
        * platform/sql/ios/SQLiteDatabaseTracker.h: Removed.
        * platform/sql/ios/SQLiteDatabaseTrackerClient.h: Removed.
        * storage/StorageAreaSync.cpp:
        (WebCore::StorageAreaSync::openDatabase):
        (WebCore::StorageAreaSync::sync):
        * storage/StorageTracker.cpp:

2014-01-25  Anders Carlsson  <andersca@apple.com>

        Remove an unused FrameLoaderClient function
        https://bugs.webkit.org/show_bug.cgi?id=127628

        Reviewed by Andreas Kling.

        All implementations of FrameLoaderClient::shouldStopLoadingForHistoryItem return true and this function
        was only used by Chromium so we can get rid of it.

        * loader/EmptyClients.h:
        * loader/FrameLoaderClient.h:
        * loader/HistoryController.cpp:
        (WebCore::HistoryController::shouldStopLoadingForHistoryItem):

2014-01-25  Darin Adler  <darin@apple.com>

        Call deprecatedCharacters instead of characters at more call sites
        https://bugs.webkit.org/show_bug.cgi?id=127631

        Reviewed by Sam Weinig.

        * bindings/objc/WebScriptObject.mm:
        (+[WebScriptObject _convertValueToObjcValue:JSC::originRootObject:rootObject:]):
        * editing/CompositeEditCommand.cpp:
        (WebCore::containsOnlyWhitespace):
        * editing/TypingCommand.cpp:
        (WebCore::TypingCommand::insertText):
        * editing/VisibleUnits.cpp:
        (WebCore::startOfParagraph):
        (WebCore::endOfParagraph):
        * html/parser/HTMLParserIdioms.cpp:
        (WebCore::stripLeadingAndTrailingHTMLSpaces):
        (WebCore::parseHTMLNonNegativeInteger):
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyle::newLineAndWhitespaceDelimiters):
        * inspector/InspectorStyleTextEditor.cpp:
        (WebCore::InspectorStyleTextEditor::insertProperty):
        (WebCore::InspectorStyleTextEditor::internalReplaceProperty):
        * platform/Length.cpp:
        (WebCore::newCoordsArray):
        * platform/LinkHash.cpp:
        (WebCore::visitedLinkHash):
        * platform/graphics/Color.cpp:
        (WebCore::Color::parseHexColor):
        (WebCore::Color::Color):
        * platform/graphics/TextRun.h:
        (WebCore::TextRun::TextRun):
        * platform/text/TextEncodingRegistry.cpp:
        (WebCore::atomicCanonicalTextEncodingName):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::constructTextRun):
        * rendering/RenderCombineText.cpp:
        (WebCore::RenderCombineText::width):
        * svg/SVGFontElement.cpp:
        (WebCore::SVGFontElement::registerLigaturesInGlyphCache):
        * xml/XPathFunctions.cpp:
        (WebCore::XPath::FunId::evaluate):
        Use the new name.

2014-01-25  Darin Adler  <darin@apple.com>

        Get rid of ICU_UNICODE and WCHAR_UNICODE remnants
        https://bugs.webkit.org/show_bug.cgi?id=127623

        Reviewed by Anders Carlsson.

        * CMakeLists.txt: Removed SmartReplaceICU.cpp.
        * GNUmakefile.list.am: Ditto.
        * PlatformEfl.cmake: Ditto.
        * PlatformGTK.cmake: Ditto.

        * editing/FrameSelection.cpp:
        (WebCore::FrameSelection::modifyMovingRight): Ditto.
        (WebCore::FrameSelection::modifyMovingLeft): Ditto.

        * editing/SmartReplace.cpp: Moved code here from SmartReplaceICU,
        since we always support ICU now. Added some FIXME comments about
        bugs and mistakes I spotted in the code as I was moving it.
        * editing/SmartReplaceICU.cpp: Removed.

        * editing/TextIterator.cpp: Removed unneeded checks.
        * platform/ThreadGlobalData.cpp:
        (WebCore::ThreadGlobalData::ThreadGlobalData): Ditto.
        (WebCore::ThreadGlobalData::destroy): Ditto.
        * platform/ThreadGlobalData.h: Ditto.
        * platform/URL.cpp:
        (WebCore::appendEncodedHostname): Ditto.
        * platform/graphics/SurrogatePairAwareTextIterator.cpp: Ditto.
        Also removed unneeded "using namespace".
        * platform/text/TextCodecICU.cpp: Ditto.
        * platform/text/TextEncoding.cpp:
        (WebCore::TextEncoding::encode): Ditto.
        * platform/text/TextEncodingRegistry.cpp:
        (WebCore::extendTextCodecMaps): Ditto.

2014-01-25  Darin Adler  <darin@apple.com>

        Get rid of UnicodeRange.h/cpp, using ICU instead
        https://bugs.webkit.org/show_bug.cgi?id=127622

        Reviewed by Anders Carlsson.

        * CMakeLists.txt: Remove UnicodeRange.h/cpp.
        * GNUmakefile.list.am: Ditto.
        * WebCore.vcxproj/WebCore.vcxproj: Ditto.
        * WebCore.vcxproj/WebCore.vcxproj.filters: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.

        * platform/graphics/win/FontCacheWin.cpp:
        (WebCore::FontCache::systemFallbackForCharacters): To check if a character has
        multiple code pages, use UCHAR_UNIFIED_IDEOGRAPH instead of cRangeSetCJK.
        * platform/graphics/wince/FontCacheWinCE.cpp:
        (WebCore::FontCache::systemFallbackForCharacters): Ditto. Also, to check if a
        character is in the Thai block, use UBLOCK_THAI.

        * platform/graphics/wince/FontPlatformData.cpp: Removed include of UnicodeRange.h.

        * platform/text/UnicodeRange.cpp: Removed.
        * platform/text/UnicodeRange.h: Removed.

        * rendering/svg/SVGTextLayoutEngineBaseline.cpp:
        (WebCore::SVGTextLayoutEngineBaseline::calculateGlyphOrientationAngle): To figure
        out if a character is full width, use UCHAR_EAST_ASIAN_WIDTH, instead of hard-coding
        "not Latin or Arabic" as the rule.

2014-01-25  Tim Horton  <timothy_horton@apple.com>

        Remove an unnecessary platform #if in BitmapImage(CG)::checkForSolidColor()
        https://bugs.webkit.org/show_bug.cgi?id=127610

        Reviewed by Simon Fraser.

        * platform/graphics/cg/BitmapImageCG.cpp:
        (WebCore::BitmapImage::checkForSolidColor):
        Over time, the two sides of this #if !PLATFORM(IOS) converged. Remove the #if
        and merge the code. We explicitly use kCGBitmapByteOrder32Big to be correct everywhere.

2014-01-25  Tim Horton  <timothy_horton@apple.com>

        [cg] Look in the PNG dictionary for image duration information
        https://bugs.webkit.org/show_bug.cgi?id=127611
        <rdar://problem/15408643>

        Reviewed by Simon Fraser.

        We should look in the PNG properties dictionary for frame duration and loop count data.

        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::ImageSource::repetitionCount):
        Mush repetitionCount a bit more to make it easier to read (early returns, etc.)
        Also, look in the PNG properties dictionary for a loop count.

        (WebCore::ImageSource::frameDurationAtIndex):
        Look in the PNG properties dictionary for delay time.
        Get rid of WebCoreCGImagePropertyGIFUnclampedDelayTime; it hasn't
        been needed since Snow Leopard.

2014-01-25  Anders Carlsson  <andersca@apple.com>

        Remove atomicIncrement/atomicDecrement
        https://bugs.webkit.org/show_bug.cgi?id=127625

        Reviewed by Andreas Kling.

        Replace atomicIncrement/atomicDecrement with std::atomic.

        * Modules/webaudio/AudioContext.cpp:
        (WebCore::AudioContext::incrementActiveSourceCount):
        (WebCore::AudioContext::decrementActiveSourceCount):
        * Modules/webaudio/AudioContext.h:
        * Modules/webaudio/AudioNode.cpp:
        (WebCore::AudioNode::~AudioNode):
        (WebCore::AudioNode::ref):
        (WebCore::AudioNode::finishDeref):
        * Modules/webaudio/AudioNode.h:
        * Modules/webdatabase/OriginLock.h:

2014-01-25  Alex Christensen  <achristensen@webkit.org>

        Unreviewed build fix for WinCairo.

        * platform/network/curl/CurlDownload.h:
        Included wtf/Threading.h for ThreadIdentifier definition.

2014-01-25  Anders Carlsson  <andersca@apple.com>

        Modernize HashTable threading code
        https://bugs.webkit.org/show_bug.cgi?id=127621

        Reviewed by Darin Adler.

        Explicitly include headers that used to be brought in by HashTable.h

        * platform/DragData.h:
        Change a Windows-specific typedef to avoid having to include WindDef.h from a header.

        * platform/audio/AudioSession.h:
        * platform/network/cf/SocketStreamHandle.h:

2014-01-25  Zan Dobersek  <zdobersek@igalia.com>

        Move CSSGroupingRule, CSSStyleSheet, ElementRuleCollector to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=127575

        Reviewed by Andreas Kling.

        Use std::unique_ptr and std::make_unique in place of OwnPtr and adoptPtr
        in the CSSGroupingRule, CSSStyleSheet and ElementRuleCollector classes.

        * css/CSSFunctionValue.cpp: Remove the unnecessary PassOwnPtr header inclusion.
        * css/CSSGroupingRule.cpp:
        (WebCore::CSSGroupingRule::cssRules):
        * css/CSSGroupingRule.h:
        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::cssRules):
        * css/CSSStyleSheet.h:
        * css/ElementRuleCollector.cpp:
        (WebCore::ElementRuleCollector::addMatchedRule):
        * css/ElementRuleCollector.h:

2014-01-25  Zan Dobersek  <zdobersek@igalia.com>

        Move MediaQueryMatcher, SelectorFilter to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=127574

        Reviewed by Andreas Kling.

        Replace the use of OwnPtr and adoptPtr with std::unique_ptr and std::make_unique
        in the MediaQueryMatcher and SelectorFilter classes.

        * css/MediaQueryMatcher.cpp:
        (WebCore::MediaQueryMatcher::prepareEvaluator):
        (WebCore::MediaQueryMatcher::evaluate):
        (WebCore::MediaQueryMatcher::addListener):
        (WebCore::MediaQueryMatcher::styleResolverChanged):
        * css/MediaQueryMatcher.h:
        * css/SelectorFilter.cpp:
        (WebCore::SelectorFilter::popParentStackFrame):
        (WebCore::SelectorFilter::setupParentStack):
        * css/SelectorFilter.h:

2014-01-25  Zan Dobersek  <zdobersek@igalia.com>

        Move PropertySetCSSStyleDeclaration, WebKitCSSKeyframesRule to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=127572

        Reviewed by Andreas Kling.

        Switch the PropertySetCSSStyleDeclaration and WebKitCSSKeyframesRule classes from using
        OwnPtr and adoptPtr to using std::unique_ptr and std::make_unique.

        * css/PropertySetCSSStyleDeclaration.cpp:
        (WebCore::PropertySetCSSStyleDeclaration::cloneAndCacheForCSSOM):
        (WebCore::StyleRuleCSSStyleDeclaration::didMutate):
        (WebCore::InlineCSSStyleDeclaration::didMutate):
        * css/PropertySetCSSStyleDeclaration.h:
        * css/WebKitCSSKeyframesRule.cpp:
        (WebCore::WebKitCSSKeyframesRule::cssRules):
        * css/WebKitCSSKeyframesRule.h:

2014-01-25  Zan Dobersek  <zdobersek@igalia.com>

        Move StyleProperties, StyleResolver to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=127570

        Reviewed by Andreas Kling.

        Move the StyleProperties and StyleResolver classes from using OwnPtr and adoptPtr
        to using std::unique_ptr and std::make_unique.

        * css/StyleInvalidationAnalysis.h: Remove the PassOwnPtr.h header inclusion.
        * css/StyleProperties.cpp:
        (WebCore::MutableStyleProperties::ensureCSSStyleDeclaration):
        (WebCore::MutableStyleProperties::ensureInlineCSSStyleDeclaration):
        * css/StyleProperties.h:
        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::StyleResolver):
        (WebCore::StyleResolver::addViewportDependentMediaQueryResult):
        * css/StyleResolver.h:
        * css/StyleScopeResolver.h:

2014-01-25  Zan Dobersek  <zdobersek@igalia.com>

        Move CSSFontFace, CSSFontSelector to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=127569

        Reviewed by Andreas Kling.

        Move the CSSFontFace and CSSFontSelector classes from using OwnPtr, PassOwnPtr and adoptPtr
        to using std::unique_ptr, move semantics and std::make_unique.

        * css/CSSFontFace.cpp:
        (WebCore::CSSFontFace::addSource):
        * css/CSSFontFace.h:
        * css/CSSFontSelector.cpp:
        (WebCore::CSSFontSelector::addFontFaceRule):
        (WebCore::CSSFontSelector::getFontFace):
        * css/CSSFontSelector.h:

2014-01-24  Joseph Pecoraro  <pecoraro@apple.com>

        Web Inspector: Move InspectorRuntimeAgent into JavaScriptCore
        https://bugs.webkit.org/show_bug.cgi?id=127605

        Reviewed by Timothy Hatcher.

        Covered by existing tests. No change in functionality.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * inspector/InspectorAllInOne.cpp:
        Remove WebCore InspectorRuntimeAgent.

        * ForwardingHeaders/inspector/agents/InspectorRuntimeAgent.h: Added.
        Add JavaScriptCore InspectorRuntimeAgent.

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        * inspector/WorkerInspectorController.h:
        * inspector/WorkerInspectorController.cpp:
        (WebCore::WorkerInspectorController::WorkerInspectorController):
        New constructors for the runtime agent.

        * inspector/PageRuntimeAgent.h:
        * inspector/PageRuntimeAgent.cpp:
        (WebCore::PageRuntimeAgent::PageRuntimeAgent):
        (WebCore::PageRuntimeAgent::enable):
        (WebCore::PageRuntimeAgent::disable):
        (WebCore::PageRuntimeAgent::didCreateMainWorldContext):
        (WebCore::PageRuntimeAgent::didCreateIsolatedContext):
        (WebCore::PageRuntimeAgent::globalVM):
        Modernize and implement globalVM.

        * inspector/WorkerRuntimeAgent.h:
        * inspector/WorkerRuntimeAgent.cpp:
        (WebCore::WorkerRuntimeAgent::WorkerRuntimeAgent):
        (WebCore::WorkerRuntimeAgent::injectedScriptForEval):
        (WebCore::WorkerRuntimeAgent::globalVM):
        Modernize and implement globalVM.

2014-01-25  Diego Pino Garcia  <dpino@igalia.com>

        [GTK] Add parameters from 'DOM Object Model Core' spec and 'DOM CSS' spec that can be NULL

        https://bugs.webkit.org/show_bug.cgi?id=117536

        Reviewed by Xan Lopez.

        * bindings/scripts/CodeGeneratorGObject.pm:
        (ParamCanBeNull): Add new pairs (function, parameter) that can be NULL

2014-01-25  Anders Carlsson  <andersca@apple.com>

        Get rid of BackForwardController::isActive()
        https://bugs.webkit.org/show_bug.cgi?id=127604

        Reviewed by Sam Weinig.

        BackForwardController::isActive() used to mean "my page maintains a back forward
        list that has zero capacity". Move that logic into WebKit instead, namely the
        WebFrameLoaderClient::canCachePage function so we can simplify WebCore.

        * history/BackForwardClient.h:
        * history/BackForwardController.cpp:
        * history/BackForwardController.h:
        * history/BackForwardList.h:
        * history/PageCache.cpp:
        (WebCore::logCanCachePageDecision):
        (WebCore::PageCache::canCache):

2014-01-25  Antti Koivisto  <antti@apple.com>

        REGRESSION(r162744): wsj.com paints white
        https://bugs.webkit.org/show_bug.cgi?id=127619

        Reviewed by Sam Weinig.

        Test: fast/css/stylesheet-layout-with-pending-paint.html

        * dom/Document.cpp:
        (WebCore::Document::styleResolverChanged):
        
            Ensure we switch out from IgnoreLayoutWithPendingSheets state after stylesheet loads complete.

2014-01-24  Dan Bernstein  <mitz@apple.com>

        Reverted r162760. It broke more things.

        * WebCore.exp.in:

2014-01-24  Dan Bernstein  <mitz@apple.com>

        Try to fix some 32-bit builds.

        * WebCore.exp.in:

2014-01-24  Jinwoo Song  <jinwoo7.song@samsung.com>

        [EFL] Replace usage of DEFINE_STATIC_LOCAL with NeverDestroyed in WebCore/platform/efl
        https://bugs.webkit.org/show_bug.cgi?id=127607

        Reviewed by Anders Carlsson.

        * platform/efl/EflKeyboardUtilities.cpp:
        (WebCore::keyMap): Use NeverDestroyed instead of DEFINE_STATIC_LOCAL.
        (WebCore::windowsKeyMap): Ditto.
        (WebCore::keyDownCommandsMap): Ditto.
        (WebCore::keyPressCommandsMap): Ditto.
        * platform/efl/GamepadsEfl.cpp:
        (WebCore::sampleGamepads): Ditto.
        * platform/efl/RenderThemeEfl.cpp:
        (WebCore::RenderThemeEfl::systemFont): Do not use unnecessary DEFINE_STATIC_LOCAL.

2014-01-23  Joseph Pecoraro  <pecoraro@apple.com>

        Move JavaScriptCallFrame and ScriptDebugServer into JavaScriptCore for inspector
        https://bugs.webkit.org/show_bug.cgi?id=127543

        Reviewed by Geoffrey Garen.

        Covered by existing tests.

        * ForwardingHeaders/inspector/ScriptDebugServer.h: Added.
        * GNUmakefile.list.am:
        * UseJSC.cmake:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSBindingsAllInOne.cpp:
        * inspector/JavaScriptCallFrame.idl: Removed.
        Update builds now that ScriptDebugServer moved to JavaScriptCore.

        * bindings/js/PageScriptDebugServer.h:
        * bindings/js/PageScriptDebugServer.cpp:
        (WebCore::PageScriptDebugServer::runEventLoopWhilePaused):
        (WebCore::PageScriptDebugServer::isContentScript):
        (WebCore::PageScriptDebugServer::reportException):
        * bindings/js/WorkerScriptDebugServer.h:
        * bindings/js/WorkerScriptDebugServer.cpp:
        (WebCore::WorkerScriptDebugServer::runEventLoopWhilePaused):
        (WebCore::WorkerScriptDebugServer::reportException):
        Handle ScriptDebugServer functionality depending on WebCore knowledge.

        * inspector/InspectorDebuggerAgent.h:
        * inspector/InspectorDebuggerAgent.cpp:
        (WebCore::InspectorDebuggerAgent::breakpointActionSound):
        Handle ScriptDebugServer functionality that depended on WebCore knowledge.
        This will eventually be written in a non-WebCore specific way.

        * inspector/InspectorRuntimeAgent.cpp:
        * inspector/InspectorRuntimeAgent.h:
        Update ScriptDebugServer type now that it is in namespace Inspector.

        * workers/WorkerGlobalScope.h:
        Make addConsoleMessage public again so the inspector can call it.

        * inspector/PageDebuggerAgent.cpp:
        (WebCore::PageDebuggerAgent::breakpointActionLog):
        * inspector/PageDebuggerAgent.h:
        * inspector/WorkerDebuggerAgent.cpp:
        (WebCore::WorkerDebuggerAgent::breakpointActionLog):
        * inspector/WorkerDebuggerAgent.h:
        Let each of these handle console logs in their own way. Both of these
        eventually go through the PageConsole and log through the InspectorConsoleAgent
        and ChromeClient.

2014-01-24  Brent Fulgham  <bfulgham@apple.com>

        Improve latching behavior for wheel events
        https://bugs.webkit.org/show_bug.cgi?id=127386
        <rdar://problem/12176858>

        Reviewed by Simon Fraser.

        * page/scrolling/ScrollingTree.cpp:
        (WebCore::ScrollingTree::ScrollingTree): Initialize new values used for tracking
        scroll latching state.
        (WebCore::ScrollingTree::shouldHandleWheelEventSynchronously): Check for an existing
        latched node and stay in fast scrolling mode if possible.
        (WebCore::ScrollingTree::removeDestroyedNodes): Clear latched node if it's being removed.
        (WebCore::ScrollingTree::latchedNode): Added
        (WebCore::ScrollingTree::setLatchedNode): Added
        (WebCore::ScrollingTree::clearLatchedNode): Added
        * page/scrolling/ScrollingTree.h:
        (WebCore::ScrollingTree::hasLatchedNode): Added
        * page/scrolling/mac/ScrollingTreeScrollingNodeMac.mm:
        (WebCore::shouldConsiderLatching): Added
        (WebCore::ScrollingTreeScrollingNodeMac::handleWheelEvent): Determine latching state
        based on wheel event state and position of mouse pointer in the document.

2014-01-24  Anders Carlsson  <andersca@apple.com>

        Another attempted build fix.

        Use wildcards in the the std::duration symbol.

        * WebCore.exp.in:

2014-01-24  Simon Fraser  <simon.fraser@apple.com>

        Start using the RemoteScrollingCoordinatorProxy on iOS
        https://bugs.webkit.org/show_bug.cgi?id=127598

        Reviewed by Tim Horton.

        Add a scrollPositionChangedViaDelegatedScrolling() function to
        ScrollingTree, allowing the ScrollingTree to be informed about
        external sources of scrolling.
        
        Also add a convenience getter for nodes, nodeForID().

        * WebCore.exp.in:
        * page/scrolling/ScrollingTree.cpp:
        (WebCore::ScrollingTree::scrollPositionChangedViaDelegatedScrolling):
        (WebCore::ScrollingTree::nodeForID):
        * page/scrolling/ScrollingTree.h:
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::registerAllViewportConstrainedLayers):
        To avoid assertions on iOS, bail from iOS WK1 fixed position code if
        we have a ScrollingCoordinator.
        (WebCore::RenderLayerCompositor::unregisterAllViewportConstrainedLayers):
        Ditto.

2014-01-24  Simon Fraser  <simon.fraser@apple.com>

        Add typesafe casts for ScrollingTreeNode classes
        https://bugs.webkit.org/show_bug.cgi?id=127597

        Reviewed by Tim Horton.

        Add a ScrollingNodeType member to ScrollingTreeNodes and
        use it for type-safe casting.

        * page/scrolling/ScrollingTreeNode.cpp:
        (WebCore::ScrollingTreeNode::ScrollingTreeNode):
        * page/scrolling/ScrollingTreeNode.h:
        (WebCore::ScrollingTreeNode::nodeType):
        (WebCore::ScrollingTreeNode::scrollingNodeID):
        * page/scrolling/ScrollingTreeScrollingNode.cpp:
        (WebCore::ScrollingTreeScrollingNode::ScrollingTreeScrollingNode):
        * page/scrolling/ScrollingTreeScrollingNode.h:
        * page/scrolling/mac/ScrollingTreeFixedNode.h:
        * page/scrolling/mac/ScrollingTreeFixedNode.mm:
        (WebCore::ScrollingTreeFixedNode::ScrollingTreeFixedNode):
        * page/scrolling/mac/ScrollingTreeStickyNode.h:
        * page/scrolling/mac/ScrollingTreeStickyNode.mm:
        (WebCore::ScrollingTreeStickyNode::ScrollingTreeStickyNode):

2014-01-24  Anders Carlsson  <andersca@apple.com>

        Remove back/forward list related functions from Page
        https://bugs.webkit.org/show_bug.cgi?id=127596

        Reviewed by Andreas Kling.

        * WebCore.exp.in:
        * history/BackForwardController.cpp:
        (WebCore::BackForwardController::canGoBackOrForward):
        (WebCore::BackForwardController::goBackOrForward):
        (WebCore::BackForwardController::goBack):
        (WebCore::BackForwardController::goForward):
        (WebCore::BackForwardController::count):
        * page/EventHandler.cpp:
        (WebCore::EventHandler::defaultBackspaceEventHandler):
        * page/Page.cpp:
        * page/Page.h:

2014-01-24  Antti Koivisto  <antti@apple.com>

        Update style asynchronously after style sheet load
        https://bugs.webkit.org/show_bug.cgi?id=127563

        Reviewed by Andreas Kling.
        
        Since we don't attach synchronously we don't need to recalc style synchronously either.

        * dom/Document.cpp:
        (WebCore::Document::didRemoveAllPendingStylesheet):

2014-01-24  Zalan Bujtas  <zalan@apple.com>

        Subpixel layout: Default style of input type=checkbox/radio (0.5ex) adds 1px extra margin on both left and right.
        https://bugs.webkit.org/show_bug.cgi?id=125728

        Reviewed by Simon Fraser.

        Using the 0.5ex value to set checkbox/radio left and right margins is a long-standing
        (khtml) behavior. While it indicates dynamic behavior, in order to get the margins changed,
        the widget's font size needs to be set, which is rather rare for such input types.
        It also results in odd layout, where the checkbox's indentation may seem to change randomly.

        '<input style="font-size: 30px;" type="checkbox">foo' changes neither the checkbox
        nor the text size, but it indents the line by about 15px.

        Other browsers (FF, Opera with Presto) disagree and they set static margins values.
        2px is the current default computed value.

        * css/html.css:
        (input[type="radio"], input[type="checkbox"]):

2014-01-24  Oliver Hunt  <oliver@apple.com>

        Put functions need to take a base object and a this value, and perform type checks on |this|
        https://bugs.webkit.org/show_bug.cgi?id=127594

        Reviewed by Geoffrey Garen.

        Update bindings generator to emit setters with correct type, and perform
        type checks on |this|, instead of the baseObject.

        Test: js/dom/dom-as-prototype-assignment-exception.html

        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateHeader):
        (GenerateImplementation):
        (GenerateHashTable):
        * bindings/scripts/test/JS/JSTestActiveDOMObject.cpp:
        * bindings/scripts/test/JS/JSTestCustomNamedGetter.cpp:
        * bindings/scripts/test/JS/JSTestEventConstructor.cpp:
        * bindings/scripts/test/JS/JSTestEventTarget.cpp:
        * bindings/scripts/test/JS/JSTestException.cpp:
        * bindings/scripts/test/JS/JSTestGenerateIsReachable.cpp:
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::setJSTestInterfaceConstructorImplementsStaticAttr):
        (WebCore::setJSTestInterfaceImplementsStr2):
        (WebCore::setJSTestInterfaceImplementsStr3):
        (WebCore::setJSTestInterfaceImplementsNode):
        (WebCore::setJSTestInterfaceConstructorSupplementalStaticAttr):
        (WebCore::setJSTestInterfaceSupplementalStr2):
        (WebCore::setJSTestInterfaceSupplementalStr3):
        (WebCore::setJSTestInterfaceSupplementalNode):
        * bindings/scripts/test/JS/JSTestInterface.h:
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp:
        * bindings/scripts/test/JS/JSTestNamedConstructor.cpp:
        * bindings/scripts/test/JS/JSTestNode.cpp:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::setJSTestObjConstructorStaticStringAttr):
        (WebCore::setJSTestObjTestSubObjEnabledBySettingConstructor):
        (WebCore::setJSTestObjEnumAttr):
        (WebCore::setJSTestObjByteAttr):
        (WebCore::setJSTestObjOctetAttr):
        (WebCore::setJSTestObjShortAttr):
        (WebCore::setJSTestObjUnsignedShortAttr):
        (WebCore::setJSTestObjLongAttr):
        (WebCore::setJSTestObjLongLongAttr):
        (WebCore::setJSTestObjUnsignedLongLongAttr):
        (WebCore::setJSTestObjStringAttr):
        (WebCore::setJSTestObjTestObjAttr):
        (WebCore::setJSTestObjXMLObjAttr):
        (WebCore::setJSTestObjCreate):
        (WebCore::setJSTestObjReflectedStringAttr):
        (WebCore::setJSTestObjReflectedIntegralAttr):
        (WebCore::setJSTestObjReflectedUnsignedIntegralAttr):
        (WebCore::setJSTestObjReflectedBooleanAttr):
        (WebCore::setJSTestObjReflectedURLAttr):
        (WebCore::setJSTestObjReflectedCustomIntegralAttr):
        (WebCore::setJSTestObjReflectedCustomBooleanAttr):
        (WebCore::setJSTestObjReflectedCustomURLAttr):
        (WebCore::setJSTestObjTypedArrayAttr):
        (WebCore::setJSTestObjAttrWithGetterException):
        (WebCore::setJSTestObjAttrWithSetterException):
        (WebCore::setJSTestObjStringAttrWithGetterException):
        (WebCore::setJSTestObjStringAttrWithSetterException):
        (WebCore::setJSTestObjCustomAttr):
        (WebCore::setJSTestObjWithScriptStateAttribute):
        (WebCore::setJSTestObjWithScriptExecutionContextAttribute):
        (WebCore::setJSTestObjWithScriptStateAttributeRaises):
        (WebCore::setJSTestObjWithScriptExecutionContextAttributeRaises):
        (WebCore::setJSTestObjWithScriptExecutionContextAndScriptStateAttribute):
        (WebCore::setJSTestObjWithScriptExecutionContextAndScriptStateAttributeRaises):
        (WebCore::setJSTestObjWithScriptExecutionContextAndScriptStateWithSpacesAttribute):
        (WebCore::setJSTestObjWithScriptArgumentsAndCallStackAttribute):
        (WebCore::setJSTestObjConditionalAttr1):
        (WebCore::setJSTestObjConditionalAttr2):
        (WebCore::setJSTestObjConditionalAttr3):
        (WebCore::setJSTestObjConditionalAttr4Constructor):
        (WebCore::setJSTestObjConditionalAttr5Constructor):
        (WebCore::setJSTestObjConditionalAttr6Constructor):
        (WebCore::setJSTestObjAnyAttribute):
        (WebCore::setJSTestObjMutablePoint):
        (WebCore::setJSTestObjImmutablePoint):
        (WebCore::setJSTestObjStrawberry):
        (WebCore::setJSTestObjStrictFloat):
        (WebCore::setJSTestObjId):
        (WebCore::setJSTestObjReplaceableAttribute):
        (WebCore::setJSTestObjNullableLongSettableAttribute):
        (WebCore::setJSTestObjNullableStringValue):
        (WebCore::setJSTestObjAttributeWithReservedEnumType):
        * bindings/scripts/test/JS/JSTestObj.h:
        * bindings/scripts/test/JS/JSTestOverloadedConstructors.cpp:
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        (WebCore::setJSTestSerializedScriptValueInterfaceValue):
        (WebCore::setJSTestSerializedScriptValueInterfaceCachedValue):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.h:
        * bindings/scripts/test/JS/JSTestTypedefs.cpp:
        (WebCore::setJSTestTypedefsUnsignedLongLongAttr):
        (WebCore::setJSTestTypedefsImmutableSerializedScriptValue):
        (WebCore::setJSTestTypedefsAttrWithGetterException):
        (WebCore::setJSTestTypedefsAttrWithSetterException):
        (WebCore::setJSTestTypedefsStringAttrWithGetterException):
        (WebCore::setJSTestTypedefsStringAttrWithSetterException):
        * bindings/scripts/test/JS/JSTestTypedefs.h:
        * bindings/scripts/test/JS/JSattribute.cpp:
        * bindings/scripts/test/JS/JSreadonly.cpp:

2014-01-24  Oliver Hunt  <oliver@apple.com>

        Generic JSObject::put should handle static properties in the classinfo hierarchy
        https://bugs.webkit.org/show_bug.cgi?id=127523

        Reviewed by Geoffrey Garen.

        Update the bindings generator to emit the flag indicating the presence
        of setters, and remove the many (now unnecessary) put overrides.
        Tested with run-jsc-benchmarks and shows neutral performance. A few of the
        micro benchmarks actually get a significant performance increase which
        is nice.

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::put):
            We still need a custom call to lookupPut here in order
            to get the magic security semantics of the window object.
        * bindings/scripts/CodeGeneratorJS.pm:
        (hashTableAccessor):
        (prototypeHashTableAccessor):
        (constructorHashTableAccessor):
        (GenerateImplementation):
        (GenerateHashTable):
        (GenerateConstructorHelperMethods):

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::put):
        * bindings/scripts/CodeGeneratorJS.pm:
        (hashTableAccessor):
        (prototypeHashTableAccessor):
        (constructorHashTableAccessor):
        (InstanceOverridesPutImplementation):
        (InstanceOverridesPutDeclaration):
        (GenerateHeader):
        (GenerateImplementation):
        (GenerateHashTable):
        (GenerateConstructorHelperMethods):
        * bindings/scripts/test/JS/JSTestActiveDOMObject.cpp:
        * bindings/scripts/test/JS/JSTestCustomNamedGetter.cpp:
        * bindings/scripts/test/JS/JSTestEventConstructor.cpp:
        * bindings/scripts/test/JS/JSTestEventTarget.cpp:
        * bindings/scripts/test/JS/JSTestException.cpp:
        * bindings/scripts/test/JS/JSTestGenerateIsReachable.cpp:
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::JSTestInterface::put):
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp:
        * bindings/scripts/test/JS/JSTestNamedConstructor.cpp:
        * bindings/scripts/test/JS/JSTestNode.cpp:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        * bindings/scripts/test/JS/JSTestObj.h:
        * bindings/scripts/test/JS/JSTestOverloadedConstructors.cpp:
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.h:
        * bindings/scripts/test/JS/JSTestTypedefs.cpp:
        * bindings/scripts/test/JS/JSTestTypedefs.h:
        * bindings/scripts/test/JS/JSattribute.cpp:
        * bindings/scripts/test/JS/JSreadonly.cpp:
        * html/canvas/WebGLRenderingContext.idl:
          Remove bogus attribute, as it has never been in the spec and should not
          have been added.

2014-01-24  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r162713.
        http://trac.webkit.org/changeset/162713
        https://bugs.webkit.org/show_bug.cgi?id=127593

        broke media/network-no-source-const-shadow (Requested by
        thorton on #webkit).

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::put):
        * bindings/scripts/CodeGeneratorJS.pm:
        (hashTableAccessor):
        (prototypeHashTableAccessor):
        (constructorHashTableAccessor):
        (GenerateHeader):
        (GenerateImplementation):
        (GenerateHashTable):
        (GenerateConstructorHelperMethods):
        * bindings/scripts/test/JS/JSTestActiveDOMObject.cpp:
        * bindings/scripts/test/JS/JSTestCustomNamedGetter.cpp:
        * bindings/scripts/test/JS/JSTestEventConstructor.cpp:
        * bindings/scripts/test/JS/JSTestEventTarget.cpp:
        * bindings/scripts/test/JS/JSTestException.cpp:
        * bindings/scripts/test/JS/JSTestGenerateIsReachable.cpp:
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::JSTestInterface::put):
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp:
        * bindings/scripts/test/JS/JSTestNamedConstructor.cpp:
        * bindings/scripts/test/JS/JSTestNode.cpp:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::JSTestObj::put):
        * bindings/scripts/test/JS/JSTestObj.h:
        * bindings/scripts/test/JS/JSTestOverloadedConstructors.cpp:
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        (WebCore::JSTestSerializedScriptValueInterface::put):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.h:
        * bindings/scripts/test/JS/JSTestTypedefs.cpp:
        (WebCore::JSTestTypedefs::put):
        * bindings/scripts/test/JS/JSTestTypedefs.h:
        * bindings/scripts/test/JS/JSattribute.cpp:
        * bindings/scripts/test/JS/JSreadonly.cpp:
        * html/canvas/WebGLRenderingContext.idl:

2014-01-24  Zalan Bujtas  <zalan@apple.com>

        Replace LayoutUnit() calls to a more descriptive LayoutUnit::fromPixel(int).
        https://bugs.webkit.org/show_bug.cgi?id=127580

        Reviewed by Simon Fraser.

        LayoutUnit(1) statement is ambiguous. While it is intended to set one (CSS) pixel, it
        could be interpreted as 1 layout unit (1/64th of a CSS pixel atm).

        No change in behavior.

        * inspector/InspectorOverlay.cpp:
        (WebCore::buildObjectForRegionHighlight):
        * rendering/FloatingObjects.cpp:
        (WebCore::ComputeFloatOffsetForFloatLayoutAdapter<FloatTypeValue>::heightRemaining):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::layoutShapeInsideInfo):
        * rendering/RenderBlockFlow.cpp:
        (WebCore::RenderBlockFlow::collapseMargins):
        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::mainAxisContentExtent):
        (WebCore::RenderFlexibleBox::preferredMainAxisContentExtentForChild):
        (WebCore::RenderFlexibleBox::alignChildren):
        * rendering/RenderMultiColumnFlowThread.cpp:
        (WebCore::RenderMultiColumnFlowThread::addForcedRegionBreak):
        * rendering/RenderMultiColumnSet.cpp:
        (WebCore::RenderMultiColumnSet::heightAdjustedForSetOffset):
        (WebCore::RenderMultiColumnSet::calculateBalancedHeight):

2014-01-24  Simon Fraser  <simon.fraser@apple.com>

        Prepare scrolling tree to handle > 1 scrolling node
        https://bugs.webkit.org/show_bug.cgi?id=127590

        Reviewed by Tim Horton.

        Clean up the code path called after the ScrollingTree has scrolled a node,
        to prepare for multiple scrolling nodes.
        
        Change "updateMainFrameScrollPosition" terminology to "updateScrollPositionAfterAsyncScroll",
        and pass along the ScrollingNodeID that scrolled.
        
        Move updateMainFrameScrollPosition-related code from ScrollingCoordinator to
        AsyncScrollingCoordinator, since this sync-up is only necessary when doing
        async scrolling.

        * WebCore.exp.in:
        * page/scrolling/AsyncScrollingCoordinator.cpp:
        (WebCore::AsyncScrollingCoordinator::AsyncScrollingCoordinator):
        (WebCore::AsyncScrollingCoordinator::requestScrollPositionUpdate):
        (WebCore::AsyncScrollingCoordinator::scheduleUpdateScrollPositionAfterAsyncScroll):
        (WebCore::AsyncScrollingCoordinator::updateScrollPositionAfterAsyncScrollTimerFired):
        (WebCore::AsyncScrollingCoordinator::updateScrollPositionAfterAsyncScroll):
        * page/scrolling/AsyncScrollingCoordinator.h:
        (WebCore::AsyncScrollingCoordinator::ScheduledScrollUpdate::ScheduledScrollUpdate):
        (WebCore::AsyncScrollingCoordinator::ScheduledScrollUpdate::matchesUpdateType):
        Package up the data related to a scheduled scroll into a ScheduledScrollUpdate struct,
        for easier comparison and cleaner code.
        * page/scrolling/ScrollingCoordinator.cpp:
        (WebCore::ScrollingCoordinator::ScrollingCoordinator):
        * page/scrolling/ScrollingCoordinator.h:
        * page/scrolling/ScrollingTree.h:
        * page/scrolling/ThreadedScrollingTree.cpp:
        (WebCore::ThreadedScrollingTree::scrollingTreeNodeDidScroll):
        * page/scrolling/ThreadedScrollingTree.h:
        * page/scrolling/ios/ScrollingTreeIOS.cpp:
        (WebCore::ScrollingTreeIOS::scrollingTreeNodeDidScroll):
        * page/scrolling/ios/ScrollingTreeIOS.h:
        * page/scrolling/ios/ScrollingTreeScrollingNodeIOS.mm:
        (WebCore::ScrollingTreeScrollingNodeIOS::setScrollPositionWithoutContentEdgeConstraints):
        * page/scrolling/mac/ScrollingTreeScrollingNodeMac.mm:
        (WebCore::ScrollingTreeScrollingNodeMac::setScrollPositionWithoutContentEdgeConstraints):

2014-01-24  Mark Lam  <mark.lam@apple.com>

        ASSERT(!m_markedSpace.m_currentDelayedReleaseScope) reloading page in inspector.
        <https://webkit.org/b/127582>

        Reviewed by Mark Hahnenberg.

        No new tests.

        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::attachDebugger):
        * bindings/js/WorkerScriptController.cpp:
        (WebCore::WorkerScriptController::detachDebugger):
        - Adding reasons for detaching a globalObject from the debugger.

2014-01-24  Zalan Bujtas  <zalan@apple.com>

        Subpixel rendering: Make PaintInfo layout unit aware.
        https://bugs.webkit.org/show_bug.cgi?id=127562

        Reviewed by Simon Fraser.

        Replace PaintInfo's IntRect with LayoutRect to be able to render to
        subpixel positions.

        No functional changes.

        * platform/graphics/LayoutRect.h:
        * rendering/PaintInfo.h:
        (WebCore::PaintInfo::PaintInfo):
        (WebCore::PaintInfo::applyTransform):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paint):
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintFillLayerExtended):
        * rendering/RenderLayer.cpp:
        (WebCore::cornerRect):
        (WebCore::RenderLayer::scrollCornerRect):
        (WebCore::resizerCornerRect):
        (WebCore::RenderLayer::scrollCornerAndResizerRect):
        (WebCore::RenderLayer::horizontalScrollbarStart):
        (WebCore::RenderLayer::drawPlatformResizerImage):
        (WebCore::RenderLayer::paintResizer):
        (WebCore::RenderLayer::hitTestOverflowControls):
        * rendering/RenderLayer.h:
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::paintContents):
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::paintScrollbar):
        * rendering/RenderWidget.cpp:
        (WebCore::RenderWidget::paintContents):
        * rendering/mathml/RenderMathMLOperator.cpp:
        (WebCore::RenderMathMLOperator::fillWithExtensionGlyph):
        * rendering/svg/SVGRenderingContext.h:

2014-01-24  Simon Fraser  <simon.fraser@apple.com>

        #ifdef out handleWheelEventPhase for iOS
        https://bugs.webkit.org/show_bug.cgi?id=127583

        Reviewed by Tim Horton.

        handleWheelEventPhase() doesn't make any sense for iOS, which
        has no wheel events.

        * page/scrolling/ScrollingTree.h:
        * page/scrolling/ThreadedScrollingTree.cpp:
        * page/scrolling/ThreadedScrollingTree.h:
        * page/scrolling/ios/ScrollingTreeIOS.h:

2014-01-24  David Hyatt  <hyatt@apple.com>

        [New Multicolumn] Don't destroy all the renderers when a multi-column block stops being multi-column (and vice versa)
        https://bugs.webkit.org/show_bug.cgi?id=127584

        Make the logic for when you need columns and when you don't shared between the
        old multi-column code and the new multi-column code. Make sure that the flow thread
        and sets get created lazily and destroyed on-demand when whether or not we should
        have multiple columns changes.

        Reviewed by Beth Dakin.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::updateLogicalWidthAndColumnWidth):
        No longer virtual. The new column code now uses this function too.

        (WebCore::RenderBlock::availableLogicalWidth):
        Renamed desiredColumnWidth() to computedColumnWidth().

        (WebCore::RenderBlock::computeColumnCountAndWidth):
        Renamed calcColumnWidth to computeColumnCountAndWidth.

        (WebCore::RenderBlock::setComputedColumnCountAndWidth):
        Rename setDesiredColumnCountAndWidth to computed.

        (WebCore::RenderBlock::computedColumnWidth):
        (WebCore::RenderBlock::computedColumnCount):
        Renamed desiredColumnWidth/Count to computedColumnWidth/Count and made them virtual.

        (WebCore::RenderBlock::updateFirstLetterStyle):
        desired -> computed rename.

        * rendering/RenderBlock.h:
        Renames and made a few functions virtual so that RenderBlockFlow can override.

        * rendering/RenderBlockFlow.cpp:
        (WebCore::RenderBlockFlow::RenderBlockFlow):
        Don't create the flow thread at construction time any longer.

        (WebCore::RenderBlockFlow::createMultiColumnFlowThread):
        (WebCore::RenderBlockFlow::destroyMultiColumnFlowThread):
        The methods to create and destroy flow threads. These work at any time now and will
        fix up the render tree accordingly.

        (WebCore::RenderBlockFlow::setComputedColumnCountAndWidth):
        Virtual override that creates/destroys the new multi-column information as needed.

        (WebCore::RenderBlockFlow::computedColumnWidth):
        (WebCore::RenderBlockFlow::computedColumnCount):
        Overrides to return the cached column width and count from the flow thread.

        * rendering/RenderBlockFlow.h:
        Has overrides of the virtual functions needed to turn multi-column state on/off and
        to hand back computed count/width information.

        * rendering/RenderMultiColumnFlowThread.cpp:
        * rendering/RenderMultiColumnFlowThread.h:
        Removed the algorithm to compute column count and width, since this has been combined
        with the old multi-column layout code.

        * rendering/RenderView.cpp:
        (WebCore::RenderView::computeColumnCountAndWidth):
        Renamed desired -> computed.

        * rendering/RenderView.h:
        Renamed desired -> computed.

        * style/StyleResolveTree.cpp:
        (WebCore::Style::determineChange):
        (WebCore::Style::resolveLocal):
        (WebCore::Style::resolveTree):
        * style/StyleResolveTree.h:
        The Settings argument is no longer needed now that we don't destroy and re-create
        the renderer for a block flow if it stops being (or becomes) multi-column.

2014-01-24  Anders Carlsson  <andersca@apple.com>

        Fix 32-bit build.

        * WebCore.exp.in:

2014-01-24  Brent Fulgham  <bfulgham@apple.com>

        [Win] Convert some NMake files to MSBuild project files
        https://bugs.webkit.org/show_bug.cgi?id=127579

        Reviewed by Tim Horton.

        * WebCore.vcxproj/WebCore.make: Removed.
        * WebCore.vcxproj/WebCore.proj: Added.

2014-01-24  Joseph Pecoraro  <pecoraro@apple.com>

        fast/profiler tests ASSERTing after moving recompileAllJSFunctions off a timer
        https://bugs.webkit.org/show_bug.cgi?id=127566

        Reviewed by Oliver Hunt.

        Covered by existing tests.

        * testing/Internals.cpp:
        (WebCore::Internals::closeDummyInspectorFrontend):
        Now that we don't have to fake that this is a page being destroyed to
        avoid recompilation. Use the InspectorDestroyed reason.

2014-01-24  Anders Carlsson  <andersca@apple.com>

        Get rid of monotonicallyIncreasingTimeMS and start using std::chrono instead
        https://bugs.webkit.org/show_bug.cgi?id=127571

        Reviewed by Antti Koivisto.

        WebCore.exp.in:
        Update symbols.

        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::implicitClose):
        (WebCore::Document::setParsing):
        (WebCore::Document::isLayoutTimerActive):
        (WebCore::Document::minimumLayoutDelay):
        (WebCore::Document::elapsedTime):
        (WebCore::Document::write):
        (WebCore::Document::styleResolverChanged):
        * dom/Document.h:
        Use std::chrono instead of doubles for the times and durations.

        * fileapi/FileReader.cpp:
        (WebCore::FileReader::FileReader):
        (WebCore::FileReader::didReceiveData):
        * fileapi/FileReader.h:
        Switch over to std::chrono.

        * page/FrameView.cpp:
        (WebCore::FrameView::layout):
        (WebCore::FrameView::layoutTimerFired):
        (WebCore::FrameView::scheduleRelayout):
        (WebCore::FrameView::scheduleRelayoutOfSubtree):
        Update for Document::elapsedTime() changes.

        * page/Settings.cpp:
        (WebCore::Settings::setLayoutInterval):
        * page/Settings.h:
        (WebCore::Settings::layoutInterval):
        Change layoutInterval to be std::chrono::milliseconds instead of int.

        * platform/Timer.h:
        (WebCore::TimerBase::startOneShot):
        Add an overload that takes std::chrono::milliseconds.

2014-01-24  Oliver Hunt  <oliver@apple.com>

        Generic JSObject::put should handle static properties in the classinfo hierarchy
        https://bugs.webkit.org/show_bug.cgi?id=127523

        Reviewed by Geoffrey Garen.

        Update the bindings generator to emit the flag indicating the presence
        of setters, and remove the many (now unnecessary) put overrides.
        Tested with run-jsc-benchmarks and shows neutral performance. A few of the
        micro benchmarks actually get a significant performance increase which
        is nice.

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::put):
            We still need a custom call to lookupPut here in order
            to get the magic security semantics of the window object.
        * bindings/scripts/CodeGeneratorJS.pm:
        (hashTableAccessor):
        (prototypeHashTableAccessor):
        (constructorHashTableAccessor):
        (GenerateImplementation):
        (GenerateHashTable):
        (GenerateConstructorHelperMethods):

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::put):
        * bindings/scripts/CodeGeneratorJS.pm:
        (hashTableAccessor):
        (prototypeHashTableAccessor):
        (constructorHashTableAccessor):
        (InstanceOverridesPutImplementation):
        (InstanceOverridesPutDeclaration):
        (GenerateHeader):
        (GenerateImplementation):
        (GenerateHashTable):
        (GenerateConstructorHelperMethods):
        * bindings/scripts/test/JS/JSTestActiveDOMObject.cpp:
        * bindings/scripts/test/JS/JSTestCustomNamedGetter.cpp:
        * bindings/scripts/test/JS/JSTestEventConstructor.cpp:
        * bindings/scripts/test/JS/JSTestEventTarget.cpp:
        * bindings/scripts/test/JS/JSTestException.cpp:
        * bindings/scripts/test/JS/JSTestGenerateIsReachable.cpp:
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::JSTestInterface::put):
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp:
        * bindings/scripts/test/JS/JSTestNamedConstructor.cpp:
        * bindings/scripts/test/JS/JSTestNode.cpp:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        * bindings/scripts/test/JS/JSTestObj.h:
        * bindings/scripts/test/JS/JSTestOverloadedConstructors.cpp:
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.h:
        * bindings/scripts/test/JS/JSTestTypedefs.cpp:
        * bindings/scripts/test/JS/JSTestTypedefs.h:
        * bindings/scripts/test/JS/JSattribute.cpp:
        * bindings/scripts/test/JS/JSreadonly.cpp:
        * html/canvas/WebGLRenderingContext.idl:
          Remove bogus attribute, as it has never been in the spec and should not
          have been added.

2014-01-24  David Hyatt  <hyatt@apple.com>

        [New Multicolumn] Eliminate RenderMultiColumnBlock
        https://bugs.webkit.org/show_bug.cgi?id=127565

        Reviewed by Antti Koivisto.

        This patch eliminates RenderMultiColumnBlock and folds all of its remaining code
        back into RenderBlockFlow. This allows all block flows to support multi-column
        layout, including table cells, list items, and the RenderView itself.

        * CMakeLists.txt:
        * WebCore.order:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        Remove RenderMultiColumnBlock from the makefiles.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::adjustIntrinsicLogicalWidthsForColumns):
        Tweak the comment, since it was no longer accurate.

        * rendering/RenderBlock.h:
        Move some functions down into RenderBlockFlow.

        * rendering/RenderBlockFlow.cpp:
        (WebCore::RenderBlockFlow::RenderBlockFlow):
        (WebCore::RenderBlockFlow::createMultiColumnFlowThreadIfNeeded):
        (WebCore::RenderBlockFlow::styleDidChange):
        (WebCore::RenderBlockFlow::relayoutForPagination):
        (WebCore::RenderBlockFlow::layoutSpecialExcludedChild):
        (WebCore::RenderBlockFlow::updateLogicalWidthAndColumnWidth):
        (WebCore::RenderBlockFlow::addChild):
        (WebCore::RenderBlockFlow::checkForPaginationLogicalHeightChange):
         * rendering/RenderBlockFlow.h:
         Move a bunch of functions from RenderMultiColumnBlock up into RenderBlockFlow.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::isUnsplittableForPagination):
        Calls isMultiColumnBlockFlow() now instead of testing for a specific renderer type.

        * rendering/RenderElement.cpp:
        (WebCore::RenderElement::createFor):
        Remove the multicolumn block creation code, since we always make a block flow now.

        * rendering/RenderMultiColumnBlock.cpp: Removed.
        * rendering/RenderMultiColumnBlock.h: Removed.
        Nuke the files.

        * rendering/RenderMultiColumnFlowThread.cpp:
        (WebCore::RenderMultiColumnFlowThread::initialLogicalWidth):
        (WebCore::RenderMultiColumnFlowThread::autoGenerateRegionsToBlockOffset):
        * rendering/RenderMultiColumnSet.cpp:
        (WebCore::RenderMultiColumnSet::heightAdjustedForSetOffset):
        (WebCore::RenderMultiColumnSet::addForcedBreak):
        (WebCore::RenderMultiColumnSet::recalculateBalancedHeight):
        (WebCore::RenderMultiColumnSet::updateLogicalWidth):
        (WebCore::RenderMultiColumnSet::prepareForLayout):
        (WebCore::RenderMultiColumnSet::columnGap):
        (WebCore::RenderMultiColumnSet::paintColumnRules):
        Change all of the functions in the multicolumnset and multicolumnflowthread classes
        to cast the parent to a RenderBlockFlow now instead of a RenderMultiColumnBlock.
        Change the code to call through to multiColumnFlowThread() for column-specific information
        for that parent block.

        * rendering/RenderObject.h:
        (WebCore::RenderObject::isMultiColumnBlockFlow):
        Remove isRenderMultiColumnBlock() and replace with isMultiColumnBlockFlow().

        * rendering/RenderingAllInOne.cpp:
        Remove RenderMultiColumnBlock include.
        
2014-01-24  Brady Eidson  <beidson@apple.com>

        IDB: support createIndex/deleteIndex messaging
        https://bugs.webkit.org/show_bug.cgi?id=127546

        Reviewed by Tim Horton.

        * WebCore.exp.in: Export a needed CrossThreadCopier

2014-01-24  Daniel Bates  <dabates@apple.com>

        Fix the Windows build after <http://trac.webkit.org/changeset/162704>
        (https://bugs.webkit.org/show_bug.cgi?id=127293)

        Only include TargetConditionals.h when building on a Darwin-based OS.
        Also, check that TARGET_OS_IPHONE is defined before referencing its value
        since it will be undefined when building on Windows.

        * bindings/objc/PublicDOMInterfaces.h:

2014-01-24  Daniel Bates  <dabates@apple.com>

        Bindings generation tests hit an error trying to include wtf/Platform.h after r161638
        https://bugs.webkit.org/show_bug.cgi?id=127293

        Reviewed by Alexey Proskuryakov.

        Include TargetConditionals.h instead of wtf/Platform.h as the latter isn't available
        in the public SDK.

        As a side effect of this change, replace usage of PLATFORM(IOS) with TARGET_OS_IPHONE.

        * bindings/objc/PublicDOMInterfaces.h:

2014-01-21  David Hyatt  <hyatt@apple.com>

        [New Multicolumn] Table cells and list items need to work as multicolumn blocks.
        https://bugs.webkit.org/show_bug.cgi?id=127365
        
        This patch is a first step towards eliminating RenderMultiColumnBlock and moving
        all its functionality into RenderBlockFlow. Doing so will allow table cells, list
        items and the RenderView to use the new multi-column layout.
        
        Reviewed by Simon Fraser.

        * rendering/RenderBlockFlow.cpp:
        (WebCore::RenderBlockFlow::setMultiColumnFlowThread):
        * rendering/RenderBlockFlow.h:
        (WebCore::RenderBlockFlow::RenderBlockFlowRareData::RenderBlockFlowRareData):
        (WebCore::RenderBlockFlow::multiColumnFlowThread):
        Add the flow thread pointer to the multi-column flow thread to RenderBlockFlow's
        rare data. This lets us use only one pointer in the rare data to point to an object
        that can hold all of the rest of the multi-column info.

        * rendering/RenderMultiColumnBlock.cpp:
        (WebCore::RenderMultiColumnBlock::RenderMultiColumnBlock):
        Move the construction of the flow thread to the constructor. This ensures we
        never have a null flow thread and lets us avoid having to null check it for
        empty multi-column blocks.

        (WebCore::RenderMultiColumnBlock::columnHeightAvailable):
        (WebCore::RenderMultiColumnBlock::columnWidth):
        (WebCore::RenderMultiColumnBlock::columnCount):
        (WebCore::RenderMultiColumnBlock::updateLogicalWidthAndColumnWidth):
        The above functions now call through to the multi-column flow thread for results.

        (WebCore::RenderMultiColumnBlock::checkForPaginationLogicalHeightChange):
         Set the column height available on the flow thread.

        (WebCore::RenderMultiColumnBlock::relayoutForPagination):
        The balancing pass and guard is in the multi-column flow thread now.

        (WebCore::RenderMultiColumnBlock::addChild):
        Don't have to create the flow thread here any longer, since we do it up front
        in the constructor of RenderMultiColumnBlock.

        (WebCore::RenderMultiColumnBlock::layoutSpecialExcludedChild):
        Don't need the null check of the flow thread any more.

        * rendering/RenderMultiColumnBlock.h:
        Change the inlined functions to not be inlined, since they need to call
        RenderMultiColumnFlowThread functions now.

        * rendering/RenderMultiColumnFlowThread.cpp:
        (WebCore::RenderMultiColumnFlowThread::RenderMultiColumnFlowThread):
        Init the new member variables we moved here from RenderMultiColumnBlock.

        (WebCore::RenderMultiColumnFlowThread::computeColumnCountAndWidth):
        Moved from RenderMultiColumnBlock.

        * rendering/RenderMultiColumnFlowThread.h:
        Add public getters/setters to the member variables so that RenderMultiColumnBlock can
        still see them. Move the member variables here from RenderMultiColumnBlock.

        * rendering/RenderMultiColumnSet.cpp:
        (WebCore::RenderMultiColumnSet::calculateBalancedHeight):
        (WebCore::RenderMultiColumnSet::prepareForLayout):
        (WebCore::RenderMultiColumnSet::columnCount):
        Call through to the flow thread instead.

2014-01-24  Zan Dobersek  <zdobersek@igalia.com>

        Unreviewed GTK build fix after r162663.

        * platform/gtk/ScrollViewGtk.cpp:
        (WebCore::ScrollView::visibleContentRectInternal): Renamed from visibleContentRect.

2014-01-24  Zan Dobersek  <zdobersek@igalia.com>

        Move HistoryItem to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=127275

        Reviewed by Darin Adler.

        Replace the uses of OwnPtr and PassOwnPtr in the HistoryItem class with std::unique_ptr.

        * history/HistoryItem.cpp:
        (WebCore::HistoryItem::HistoryItem):
        (WebCore::HistoryItem::reset):
        (WebCore::HistoryItem::addRedirectURL):
        (WebCore::HistoryItem::setRedirectURLs):
        * history/HistoryItem.h:
        * history/mac/HistoryItemMac.mm:
        (WebCore::HistoryItem::setTransientProperty):
        WebCore.exp.in: Update the symbol.

2014-01-23  Morten Stenshorne  <mstensho@opera.com>

        Region based multicol: unresolvable percent height results in 1px tall multicol
        https://bugs.webkit.org/show_bug.cgi?id=122826

        Reviewed by David Hyatt.

        If a box has a percentage height, but the computed height of its
        containing block is auto, the computed height of the box also becomes
        auto. computeContentLogicalHeight() returns -1 if the height isn't
        resolvable, and we need to make sure that such a value doesn't
        constrain the height of the multicol container.

        Tests: fast/multicol/newmulticol/unresolvable-percent-height-2.html
               fast/multicol/newmulticol/unresolvable-percent-height.html
               fast/multicol/newmulticol/unresolvable-percent-max-height-2.html
               fast/multicol/newmulticol/unresolvable-percent-max-height.html

        * rendering/RenderMultiColumnSet.cpp:
        (WebCore::RenderMultiColumnSet::RenderMultiColumnSet):
        (WebCore::RenderMultiColumnSet::calculateBalancedHeight):
        (WebCore::RenderMultiColumnSet::recalculateBalancedHeight):
        (WebCore::RenderMultiColumnSet::prepareForLayout):

2014-01-23  Joseph Pecoraro  <pecoraro@apple.com>

        Move ContentSearchUtils, ScriptBreakpoint, and ScriptDebugListener into JavaScriptCore for inspector
        https://bugs.webkit.org/show_bug.cgi?id=127537

        Reviewed by Timothy Hatcher.

          - Rename ContentSearchUtils => ContentSearchUtilities and move to JavaScriptCore.
          - Move ScriptBreakpoint and ScriptDebugListener to JavaScriptCore.
          - Move them all to namespace Inspector.
          - Update build files and users to the new names.

        No change in functionality, just moving code.

        * CMakeLists.txt:
        * ForwardingHeaders/inspector/ContentSearchUtilities.h: Added.
        * ForwardingHeaders/inspector/ScriptBreakpoint.h: Added.
        * ForwardingHeaders/inspector/ScriptDebugListener.h: Added.
        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/PageScriptDebugServer.cpp:
        * bindings/js/PageScriptDebugServer.h:
        * bindings/js/ScriptDebugServer.cpp:
        * bindings/js/ScriptDebugServer.h:
        * bindings/js/WorkerScriptDebugServer.cpp:
        * bindings/js/WorkerScriptDebugServer.h:
        * inspector/InspectorAllInOne.cpp:
        * inspector/InspectorDebuggerAgent.cpp:
        (WebCore::InspectorDebuggerAgent::searchInContent):
        (WebCore::InspectorDebuggerAgent::sourceMapURLForScript):
        (WebCore::InspectorDebuggerAgent::didParseSource):
        * inspector/InspectorDebuggerAgent.h:
        * inspector/InspectorPageAgent.cpp:
        (WebCore::InspectorPageAgent::sourceMapURLForResource):
        (WebCore::InspectorPageAgent::searchInResource):
        (WebCore::InspectorPageAgent::searchInResources):
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::buildSourceRangeObject):
        (WebCore::InspectorStyleSheet::lineEndings):
        (WebCore::InspectorStyleSheetForInlineStyle::lineEndings):

2014-01-23  Joseph Pecoraro  <pecoraro@apple.com>

        Move RegularExpression into JavaScriptCore for inspector
        https://bugs.webkit.org/show_bug.cgi?id=127526

        Reviewed by Geoffrey Garen.

        Update as appropriate for the moved file and namespace
        change for class RegularExpression.

        * CMakeLists.txt:
        * ForwardingHeaders/yarr/RegularExpression.h: Added.
        * GNUmakefile.list.am:
        * WebCore.exp.in:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/DOMImplementation.h:
        * html/BaseCheckableInputType.cpp:
        * html/BaseTextInputType.cpp:
        (WebCore::BaseTextInputType::patternMismatch):
        * html/EmailInputType.cpp:
        (WebCore::isValidEmailAddress):
        * html/InputType.cpp:
        * inspector/ContentSearchUtils.cpp:
        (WebCore::ContentSearchUtils::getRegularExpressionMatchesByLines):
        (WebCore::ContentSearchUtils::createSearchRegex):
        (WebCore::ContentSearchUtils::countRegularExpressionMatches):
        (WebCore::ContentSearchUtils::searchInTextByLines):
        * inspector/ContentSearchUtils.h:
        * inspector/InspectorDebuggerAgent.cpp:
        (WebCore::matches):
        (WebCore::InspectorDebuggerAgent::breakpointActionLog):
        (WebCore::InspectorDebuggerAgent::breakpointActionSound):
        * inspector/InspectorDebuggerAgent.h:
        * inspector/InspectorPageAgent.cpp:
        (WebCore::InspectorPageAgent::searchInResources):
        * inspector/InspectorPageAgent.h:
        * inspector/InspectorRuntimeAgent.cpp:
        * inspector/InspectorRuntimeAgent.h:
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::selectorsFromSource):
        * inspector/WorkerDebuggerAgent.cpp:
        * page/Frame.cpp:
        (WebCore::createRegExpForLabels):
        (WebCore::Frame::searchForLabelsAboveCell):
        (WebCore::Frame::searchForLabelsBeforeElement):
        (WebCore::matchLabelsAgainstString):
        * page/Frame.h:
        * platform/graphics/opengl/GraphicsContext3DOpenGLCommon.cpp:
        (WebCore::GraphicsContext3D::getUnmangledInfoLog):

2014-01-23  Brady Eidson  <beidson@apple.com>

        IDB: Support IDBObjectStore.clear()
        https://bugs.webkit.org/show_bug.cgi?id=127541
        
        Reviewed by Anders Carlsson.

        The backing store should never be performing callbacks directly:
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.cpp:
        (WebCore::IDBServerConnectionLevelDB::clearObjectStore):

        Instead, the transaction operations should do that themselves:
        * Modules/indexeddb/IDBTransactionBackendOperations.cpp:
        (WebCore::ClearObjectStoreOperation::perform):
        * Modules/indexeddb/IDBTransactionBackendOperations.h:
        (WebCore::ClearObjectStoreOperation::transaction):

2014-01-23  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/15875326> REGRESSION (r162257): Assertion failure (should not be reached) in CSSPreloadScanner::tokenize()
        https://bugs.webkit.org/show_bug.cgi?id=127540

        Reviewed by Anders Carlsson.

        No new tests, because I could not reproduce the bug reliably and I don’t know how to trigger
        it.

        * html/parser/CSSPreloadScanner.cpp:
        (WebCore::CSSPreloadScanner::scan): Check for the DoneParsingImportRules before tokenizing
        a character, not after. This restores the logic from before r162257.

2014-01-23  Jer Noble  <jer.noble@apple.com>

        [iOS] Protect against possbile deadlock by delaying video layer creation
        https://bugs.webkit.org/show_bug.cgi?id=127505

        Reviewed by Eric Carlson.

        Work around a possible deadlock on iOS when creating a media element
        backed by AVFoundation by delaying creation of the AVPlayerLayer.
        The deadlock can occur when the web thread is doing CALayer layout
        while taking the web thread lock, while CoreMedia is doing property
        access on an async thread while taking the CM lock, and each is waiting
        for the other's lock to be released.

        * platform/graphics/avfoundation/objc/MediaPlayerPrivateAVFoundationObjC.mm:
        (WebCore::MediaPlayerPrivateAVFoundationObjC::createVideoLayer):

2014-01-23  Jer Noble  <jer.noble@apple.com>

        [MSE][Mac] Crash when reloading a page during playback
        https://bugs.webkit.org/show_bug.cgi?id=126903

        Reviewed by Eric Carlson.

        Periodic time observers added to AVSampleBufferRenderSynchronizer will execute their
        callback block even after being removed with -removeTimeObserver:, which is tracked by
        <rdar://problem/15798050>. Work around this problem by passing a WeakPtr into the block
        and bail early if the owning media player has been destroyed.

        * platform/graphics/avfoundation/objc/MediaPlayerPrivateMediaSourceAVFObjC.h:
        (WebCore::MediaPlayerPrivateMediaSourceAVFObjC::createWeakPtr):
        * platform/graphics/avfoundation/objc/MediaPlayerPrivateMediaSourceAVFObjC.mm:
        (WebCore::MediaPlayerPrivateMediaSourceAVFObjC::MediaPlayerPrivateMediaSourceAVFObjC):

2014-01-23  ChangSeok Oh  <changseok.oh@collabora.com>

        Dragging from inner side of video to outside causes a crash
        https://bugs.webkit.org/show_bug.cgi?id=126338

        Reviewed by Jer Noble.

        The crash happens while dragging mouse cursor through timeline control to outside
        of video region. This is beacause media controls are selected with the drag.
        The media controls disappear when mouse cursor goes outside of video though
        the dragging/selection proceeds. If once media controls are hidden, related element
        lose their renderers. However the drag is still under going. it requires shadowPseudoId
        of the selected controls. Untorntunately, SliderThumbElement/SliderContainerElement
        don't return a static value for the shadowPseudoId unlike other media controls,
        but they need a renderer to determine it. This is the reason of crash.

        Test: media/media-controller-drag-crash.html

        * html/shadow/SliderThumbElement.cpp:
        (WebCore::SliderThumbElement::shadowPseudoId):
        (WebCore::SliderContainerElement::shadowPseudoId):

2014-01-23  Brady Eidson  <beidson@apple.com>

        IDB: Implement SQLite backing store 'get' support
        https://bugs.webkit.org/show_bug.cgi?id=127502

        Reviewed by Tim Horton.

        Get a KeyRange from a KeyRangeData:
        * Modules/indexeddb/IDBKeyRangeData.cpp:
        (WebCore::IDBKeyRangeData::maybeCreateIDBKeyRange):
        * Modules/indexeddb/IDBKeyRangeData.h:

        Add collation function support to SQLiteDatabase:
        * platform/sql/SQLiteDatabase.cpp:
        (WebCore::destroyCollationFunction):
        (WebCore::callCollationFunction):
        (WebCore::SQLiteDatabase::setCollationFunction):
        (WebCore::SQLiteDatabase::removeCollationFunction):
        * platform/sql/SQLiteDatabase.h:

        * WebCore.exp.in:

2014-01-23  Jon Honeycutt  <jhoneycutt@apple.com>

        Assertion failure in WebCore::PseudoElement::didRecalcStyle()
        <https://bugs.webkit.org/show_bug.cgi?id=126761>
        <rdar://problem/15793540>

        Reviewed by Andy Estes.

        Test: fast/images/animate-list-item-image-assertion.html

        * dom/PseudoElement.cpp:
        (WebCore::PseudoElement::didRecalcStyle):
        Check isRenderImage() rather than isImage() before casting to
        RenderImage.

        * editing/ios/EditorIOS.mm:
        (WebCore::getImage):
        Ditto.

        * editing/mac/EditorMac.mm:
        (WebCore::getImage):
        Ditto.

        * html/HTMLImageElement.cpp:
        (WebCore::HTMLImageElement::parseAttribute):
        (WebCore::HTMLImageElement::didAttachRenderers):
        Ditto.

        * loader/ImageLoader.cpp:
        (WebCore::ImageLoader::renderImageResource):
        Ditto.

        * page/DragController.cpp:
        (WebCore::getCachedImage):
        Ditto.

        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::isDirectlyCompositedImage):
        (WebCore::RenderLayerBacking::updateImageContents):
        Ditto.

2014-01-23  Joseph Pecoraro  <pecoraro@apple.com>

        Web Inspector: Remove recompileAllJSFunctions timer in ScriptDebugServer
        https://bugs.webkit.org/show_bug.cgi?id=127409

        Reviewed by Geoffrey Garen.

        Covered by existing tests.

        * bindings/js/ScriptDebugServer.h:
        * bindings/js/ScriptDebugServer.cpp:
        (WebCore::ScriptDebugServer::ScriptDebugServer):
        Remove m_recompileTimer and the recompile soon function.
        We can just recompile immediately in all existing cases.

        * bindings/js/PageScriptDebugServer.h:
        * bindings/js/PageScriptDebugServer.cpp:
        (WebCore::PageScriptDebugServer::addListener):
        (WebCore::PageScriptDebugServer::removeListener):
        (WebCore::PageScriptDebugServer::recompileAllJSFunctions):
        (WebCore::PageScriptDebugServer::didAddFirstListener):
        (WebCore::PageScriptDebugServer::didRemoveLastListener):
        Add a "didAddFirstListener" to match "didRemoveLastListener".
        Only recompile functions when we attach the debugger and when
        we detach the last listener.

        * bindings/js/WorkerScriptDebugServer.cpp:
        (WebCore::WorkerScriptDebugServer::addListener):
        (WebCore::WorkerScriptDebugServer::removeListener):
        (WebCore::WorkerScriptDebugServer::recompileAllJSFunctions):
        Same thing. Also rearrange the functions to read better.

        * inspector/InspectorProfilerAgent.cpp:
        Use the direct recompile function instead of the removed "soon" version.

        * WebCore.exp.in:
        Update disconnectFrontend symbol.

        * page/PageDebuggable.cpp:
        (WebCore::PageDebuggable::disconnect):
        * testing/Internals.cpp:
        (WebCore::Internals::closeDummyInspectorFrontend):
        * workers/WorkerMessagingProxy.cpp:
        (WebCore::disconnectFromWorkerGlobalScopeInspectorTask):
        Include an InspectorDisconnectReason when calling disconnectFrontend.

        * inspector/InspectorDatabaseAgent.h:
        * inspector/InspectorDebuggerAgent.cpp:
        (WebCore::InspectorDebuggerAgent::disable):
        (WebCore::InspectorDebuggerAgent::willDestroyFrontendAndBackend):
        If the disconnect reason is the page will be destroyed, don't recompile when disconnecting.

        * inspector/InspectorProfilerAgent.h:
        * inspector/InspectorProfilerAgent.cpp:
        (WebCore::InspectorProfilerAgent::enable):
        (WebCore::InspectorProfilerAgent::disable):
        (WebCore::InspectorProfilerAgent::willDestroyFrontendAndBackend):
        If the disconnect reason is the page will be destroyed, don't recompile when disconnecting.

        * inspector/InspectorController.h:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::inspectedPageDestroyed):
        (WebCore::InspectorController::disconnectFrontend):
        (WebCore::InspectorController::close):
        Pass different reasons for the different disconnect reasons.

        * inspector/WorkerInspectorController.h:
        * inspector/WorkerInspectorController.cpp:
        (WebCore::WorkerInspectorController::~WorkerInspectorController):
        (WebCore::WorkerInspectorController::disconnectFrontend):
        Pass different reasons for the different disconnect reasons.

        * inspector/InspectorApplicationCacheAgent.cpp:
        (WebCore::InspectorApplicationCacheAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorApplicationCacheAgent.h:
        * inspector/InspectorCSSAgent.cpp:
        (WebCore::InspectorCSSAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorCSSAgent.h:
        * inspector/InspectorCanvasAgent.cpp:
        (WebCore::InspectorCanvasAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorCanvasAgent.h:
        * inspector/InspectorConsoleAgent.cpp:
        (WebCore::InspectorConsoleAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorConsoleAgent.h:
        * inspector/InspectorDOMAgent.cpp:
        (WebCore::InspectorDOMAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorDOMAgent.h:
        * inspector/InspectorDOMDebuggerAgent.cpp:
        (WebCore::InspectorDOMDebuggerAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorDOMDebuggerAgent.h:
        * inspector/InspectorDOMStorageAgent.cpp:
        (WebCore::InspectorDOMStorageAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorDOMStorageAgent.h:
        * inspector/InspectorDatabaseAgent.cpp:
        (WebCore::InspectorDatabaseAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorDebuggerAgent.h:
        * inspector/InspectorHeapProfilerAgent.cpp:
        (WebCore::InspectorHeapProfilerAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorHeapProfilerAgent.h:
        * inspector/InspectorIndexedDBAgent.cpp:
        (WebCore::InspectorIndexedDBAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorIndexedDBAgent.h:
        * inspector/InspectorInputAgent.cpp:
        (WebCore::InspectorInputAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorInputAgent.h:
        * inspector/InspectorLayerTreeAgent.cpp:
        (WebCore::InspectorLayerTreeAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorLayerTreeAgent.h:
        * inspector/InspectorMemoryAgent.cpp:
        (WebCore::InspectorMemoryAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorMemoryAgent.h:
        * inspector/InspectorPageAgent.cpp:
        (WebCore::InspectorPageAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorPageAgent.h:
        * inspector/InspectorResourceAgent.cpp:
        (WebCore::InspectorResourceAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorResourceAgent.h:
        * inspector/InspectorTimelineAgent.cpp:
        (WebCore::InspectorTimelineAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorTimelineAgent.h:
        * inspector/InspectorWorkerAgent.cpp:
        (WebCore::InspectorWorkerAgent::willDestroyFrontendAndBackend):
        * inspector/InspectorWorkerAgent.h:
        * inspector/PageDebuggerAgent.cpp:
        (WebCore::PageDebuggerAgent::disable):
        (WebCore::PageDebuggerAgent::stopListeningScriptDebugServer):
        * inspector/PageDebuggerAgent.h:
        * inspector/PageRuntimeAgent.cpp:
        (WebCore::PageRuntimeAgent::willDestroyFrontendAndBackend):
        * inspector/PageRuntimeAgent.h:
        * inspector/WorkerDebuggerAgent.cpp:
        (WebCore::WorkerDebuggerAgent::stopListeningScriptDebugServer):
        * inspector/WorkerDebuggerAgent.h:
        * inspector/WorkerRuntimeAgent.cpp:
        (WebCore::WorkerRuntimeAgent::willDestroyFrontendAndBackend):
        * inspector/WorkerRuntimeAgent.h:
        Include InspectorDisconnectReason param.

2014-01-23  Simon Fraser  <simon.fraser@apple.com>

        Another Windows fix: include <algorithm> for std::min and std::max.
        
        * platform/graphics/IntSize.h:

2014-01-23  Simon Fraser  <simon.fraser@apple.com>

        Try to fix Windows build.

        * platform/win/PopupMenuWin.cpp:
        (WebCore::PopupMenuWin::visibleSize):
        * platform/win/PopupMenuWin.h:

2014-01-23  Simon Fraser  <simon.fraser@apple.com>

        Make visibleContentRect() return actualVisibleContentRect() on iOS most of the time
        https://bugs.webkit.org/show_bug.cgi?id=127456
        
        Reviewed by Antti Koivisto.
        
        On iOS, visibleContentRect() returns the entire document rect for historical
        reasons, and actualVisibleContentRect() returns what visibleContentRect()
        returns on other platforms.
        
        In addition, actualVisibleContentRect() was returning an empty rect in WK2.
        
        Reduce the confusion of #ifdefs by making visibleContentRect() behave like
        actualVisibleContentRect() by default on iOS. Where it needs the old behavior,
        an optional parameter, LegacyIOSDocumentVisibleRect, provides this.
        
        Achieve this by having the virtual ScrollableArea::visibleContentRectInternal(),
        which is called by non-virtual visibleContentRect() and visibleContentRectIncludingScrollbars().
        
        Similarly clean up visibleHeight/visibleWidth functions by having visibleSize() be virtual,
        with non-virtual visibleHeight() and visibleWidth().
        
        ScrollableArea subclasses override visibleContentRectInternal() and visibleSize() where necessary.
        
        Mechanically change all the call sites of actualVisibleContentRect() to
        use visibleContentRect(), and the call sites of visibleContentRect()
        to visibleContentRect(..., LegacyIOSDocumentVisibleRect), adding comments
        where this may not be appropriate.
        
        Change callers of visibleContentRect(IncludeScrollbars...) to visibleContentRectIncludingScrollbars().
        
        Also add actualScrollPosition(), and clean up some actualScroll* call sites.
        
        No behavior change.

        * WebCore.exp.in:
        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::isOnscreen):
        (WebCore::AccessibilityObject::scrollToMakeVisibleWithSubFocus):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::isOffScreen):
        * dom/Document.cpp:
        (WebCore::Document::adjustFloatQuadsForScrollAndAbsoluteZoomAndFrameScale):
        (WebCore::Document::adjustFloatRectForScrollAndAbsoluteZoomAndFrameScale):
        * dom/MouseRelatedEvent.cpp:
        (WebCore::MouseRelatedEvent::MouseRelatedEvent):
        * editing/Editor.cpp:
        (WebCore::Editor::countMatchesForText):
        * editing/FrameSelection.cpp:
        (WebCore::FrameSelection::bounds):
        (WebCore::FrameSelection::getClippedVisibleTextRectangles):
        * html/HTMLBodyElement.cpp:
        (WebCore::HTMLBodyElement::scrollLeft):
        (WebCore::HTMLBodyElement::scrollTop):
        * html/ImageDocument.cpp:
        (WebCore::ImageDocument::imageFitsInWindow):
        (WebCore::ImageDocument::windowSizeChanged):
        * inspector/InspectorOverlay.cpp:
        (WebCore::InspectorOverlay::update):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::innerHeight):
        (WebCore::DOMWindow::innerWidth):
        (WebCore::DOMWindow::scrollX):
        (WebCore::DOMWindow::scrollY):
        (WebCore::DOMWindow::scrollBy):
        * page/FrameView.cpp:
        (WebCore::FrameView::calculateScrollbarModesForLayout):
        (WebCore::FrameView::layout):
        (WebCore::FrameView::scrollContentsSlowPath):
        (WebCore::FrameView::repaintContentRectangle):
        (WebCore::FrameView::sendResizeEventIfNeeded):
        (WebCore::FrameView::windowClipRect):
        (WebCore::FrameView::isScrollable):
        (WebCore::FrameView::paintControlTints):
        * page/SpatialNavigation.cpp:
        (WebCore::canScrollInDirection):
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::unscaledVisibleContentSize):
        (WebCore::ScrollView::visibleContentRectInternal):
        (WebCore::ScrollView::updateScrollbars):
        (WebCore::ScrollView::paint):
        * platform/ScrollView.h:
        (WebCore::ScrollView::scrollOffset):
        (WebCore::ScrollView::actualScrollX):
        (WebCore::ScrollView::actualScrollY):
        (WebCore::ScrollView::actualScrollPosition):
        * platform/ScrollableArea.cpp:
        (WebCore::ScrollableArea::visibleContentRect):
        (WebCore::ScrollableArea::visibleContentRectIncludingScrollbars):
        (WebCore::ScrollableArea::visibleContentRectInternal):
        * platform/ScrollableArea.h:
        (WebCore::ScrollableArea::visibleWidth):
        (WebCore::ScrollableArea::visibleHeight):
        * platform/graphics/IntSize.h:
        (WebCore::IntSize::expandedTo): Drive-by cleanup.
        (WebCore::IntSize::shrunkTo):
        * platform/gtk/ScrollViewGtk.cpp:
        (WebCore::ScrollView::visibleContentRect):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::scrollRectToVisible):
        (WebCore::RenderLayer::maximumScrollPosition):
        (WebCore::RenderLayer::visibleContentRectInternal):
        (WebCore::RenderLayer::hitTest):
        * rendering/RenderLayer.h:
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::updateCompositedBounds):
        * rendering/RenderListBox.cpp:
        * rendering/RenderListBox.h:
        * rendering/RenderView.cpp:
        (WebCore::RenderView::viewRect):
        (WebCore::RenderView::viewportSize):

2014-01-20  Myles C. Maxfield  <mmaxfield@apple.com>

       Turn text-decoration-skip: ink on for all underlines
       https://bugs.webkit.org/show_bug.cgi?id=127331

       Reviewed by Antti Koivisto.

       No new tests are necessary because tests already exist

       * rendering/style/RenderStyle.h:

2014-01-23  Hans Muller  <hmuller@adobe.com>

        [CSS Shapes] Image valued shape size and position should conform to the spec
        https://bugs.webkit.org/show_bug.cgi?id=123295

        Reviewed by Andreas Kling.

        Implement image valued shape-outside scaling and translation per the spec,
        http://dev.w3.org/csswg/css-shapes/#shapes-from-image:

        "The image is sized and positioned as if it were a replaced element whose
        specified width and height are the same as the element’s used content box size."

        This change doesn't completely fulfill the spec, it's limited to image elements
        and shape-outside.

        Tests: fast/shapes/shape-outside-floats/shape-outside-image-fit-001.html
               fast/shapes/shape-outside-floats/shape-outside-image-fit-002.html
               fast/shapes/shape-outside-floats/shape-outside-image-fit-003.html
               fast/shapes/shape-outside-floats/shape-outside-image-fit-004.html

        * rendering/shapes/Shape.h:
        * rendering/shapes/Shape.cpp:
        (WebCore::Shape::createRasterShape):
        Added an imageRect parameter which specifies where the shape image is to
        appear relative to the content box. The imageRect implies both scaling and
        translation of the shape image.

        * rendering/shapes/ShapeInfo.cpp:
        (WebCore::ShapeInfo<RenderType>::computedShape):
        (WebCore::getShapeImageRect):
        For replaced elements, compute the shape's imageRect with
        RenderReplaced::replacedContentRect().


2014-01-23  Max Vujovic  <mvujovic@adobe.com>

        Remove CSS Custom Filters code and tests
        https://bugs.webkit.org/show_bug.cgi?id=127382

        Reviewed by Simon Fraser.

        No new tests. Removing functionality.

        * CMakeLists.txt:
        * Configurations/FeatureDefines.xcconfig:
        * DerivedSources.cpp:
        * DerivedSources.make:
        * GNUmakefile.list.am:
        * WebCore.order:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSCSSRuleCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSCSSValueCustom.cpp:
        (WebCore::toJS):
        * bindings/objc/DOMCSS.mm:
        (kitClass):
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::ComputedStyleExtractor::valueForFilter):
        (WebCore::ComputedStyleExtractor::propertyValue):
        * css/CSSComputedStyleDeclaration.h:
        * css/CSSGrammar.y.in:
        * css/CSSParser.cpp:
        (WebCore::CSSParserContext::CSSParserContext):
        (WebCore::operator==):
        (WebCore::CSSParser::CSSParser):
        (WebCore::CSSParser::parseValue):
        (WebCore::filterInfoForName):
        (WebCore::CSSParser::parseFilter):
        (WebCore::CSSParser::detectAtToken):
        * css/CSSParser.h:
        * css/CSSParserMode.h:
        * css/CSSPropertyNames.in:
        * css/CSSPropertySourceData.h:
        * css/CSSRule.h:
        * css/CSSRule.idl:
        * css/CSSValue.cpp:
        (WebCore::CSSValue::equals):
        (WebCore::CSSValue::cssText):
        (WebCore::CSSValue::destroy):
        (WebCore::CSSValue::cloneForCSSOM):
        * css/CSSValue.h:
        * css/CSSValueKeywords.in:
        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::State::clear):
        (WebCore::StyleResolver::applyProperty):
        (WebCore::filterOperationForType):
        (WebCore::StyleResolver::createFilterOperations):
        (WebCore::StyleResolver::loadPendingResources):
        * css/StyleResolver.h:
        (WebCore::StyleResolver::State::State):
        * css/StyleRule.cpp:
        (WebCore::StyleRuleBase::destroy):
        (WebCore::StyleRuleBase::copy):
        (WebCore::StyleRuleBase::createCSSOMWrapper):
        * css/StyleRule.h:
        * css/StyleSheetContents.cpp:
        (WebCore::childRulesHaveFailedOrCanceledSubresources):
        * css/WebKitCSSArrayFunctionValue.cpp: Removed.
        * css/WebKitCSSArrayFunctionValue.h: Removed.
        * css/WebKitCSSFilterRule.cpp: Removed.
        * css/WebKitCSSFilterRule.h: Removed.
        * css/WebKitCSSFilterRule.idl: Removed.
        * css/WebKitCSSFilterValue.cpp:
        (WebCore::WebKitCSSFilterValue::WebKitCSSFilterValue):
        (WebCore::WebKitCSSFilterValue::customCSSText):
        * css/WebKitCSSFilterValue.h:
        * css/WebKitCSSFilterValue.idl:
        * css/WebKitCSSMatFunctionValue.cpp: Removed.
        * css/WebKitCSSMatFunctionValue.h: Removed.
        * css/WebKitCSSMixFunctionValue.cpp: Removed.
        * css/WebKitCSSMixFunctionValue.h: Removed.
        * css/WebKitCSSMixFunctionValue.idl: Removed.
        * css/WebKitCSSShaderValue.cpp: Removed.
        * css/WebKitCSSShaderValue.h: Removed.
        * loader/cache/CachedResource.cpp:
        (WebCore::defaultPriorityForResourceType):
        * loader/cache/CachedResource.h:
        * loader/cache/CachedResourceLoader.cpp:
        (WebCore::createResource):
        (WebCore::CachedResourceLoader::checkInsecureContent):
        (WebCore::CachedResourceLoader::canRequest):
        * loader/cache/CachedResourceLoader.h:
        * loader/cache/CachedShader.cpp: Removed.
        * loader/cache/CachedShader.h: Removed.
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        * page/Settings.h:
        * page/animation/CSSPropertyAnimation.cpp:
        (WebCore::blendFilter):
        * platform/graphics/ca/mac/PlatformCALayerMac.mm:
        (PlatformCALayerMac::filtersCanBeComposited):
        * platform/graphics/filters/CustomFilterArrayParameter.h: Removed.
        * platform/graphics/filters/CustomFilterColorParameter.h: Removed.
        * platform/graphics/filters/CustomFilterCompiledProgram.cpp: Removed.
        * platform/graphics/filters/CustomFilterCompiledProgram.h: Removed.
        * platform/graphics/filters/CustomFilterConstants.h: Removed.
        * platform/graphics/filters/CustomFilterGlobalContext.cpp: Removed.
        * platform/graphics/filters/CustomFilterGlobalContext.h: Removed.
        * platform/graphics/filters/CustomFilterMesh.cpp: Removed.
        * platform/graphics/filters/CustomFilterMesh.h: Removed.
        * platform/graphics/filters/CustomFilterMeshGenerator.cpp: Removed.
        * platform/graphics/filters/CustomFilterMeshGenerator.h: Removed.
        * platform/graphics/filters/CustomFilterNumberParameter.h: Removed.
        * platform/graphics/filters/CustomFilterOperation.cpp: Removed.
        * platform/graphics/filters/CustomFilterOperation.h: Removed.
        * platform/graphics/filters/CustomFilterParameter.h: Removed.
        * platform/graphics/filters/CustomFilterParameterList.cpp: Removed.
        * platform/graphics/filters/CustomFilterParameterList.h: Removed.
        * platform/graphics/filters/CustomFilterProgram.cpp: Removed.
        * platform/graphics/filters/CustomFilterProgram.h: Removed.
        * platform/graphics/filters/CustomFilterProgramClient.h: Removed.
        * platform/graphics/filters/CustomFilterProgramInfo.cpp: Removed.
        * platform/graphics/filters/CustomFilterProgramInfo.h: Removed.
        * platform/graphics/filters/CustomFilterRenderer.cpp: Removed.
        * platform/graphics/filters/CustomFilterRenderer.h: Removed.
        * platform/graphics/filters/CustomFilterTransformParameter.h: Removed.
        * platform/graphics/filters/CustomFilterValidatedProgram.cpp: Removed.
        * platform/graphics/filters/CustomFilterValidatedProgram.h: Removed.
        * platform/graphics/filters/FECustomFilter.cpp: Removed.
        * platform/graphics/filters/FECustomFilter.h: Removed.
        * platform/graphics/filters/FilterOperation.h:
        * platform/graphics/filters/FilterOperations.cpp:
        (WebCore::FilterOperations::outsets):
        * platform/graphics/filters/FilterOperations.h:
        * platform/graphics/filters/ValidatedCustomFilterOperation.cpp: Removed.
        * platform/graphics/filters/ValidatedCustomFilterOperation.h: Removed.
        * platform/graphics/filters/texmap/CustomFilterValidatedProgramTextureMapper.cpp: Removed.
        * platform/graphics/filters/texmap/TextureMapperPlatformCompiledProgram.h: Removed.
        * platform/graphics/gpu/Texture.cpp:
        * platform/graphics/texmap/TextureMapper.h:
        * platform/graphics/texmap/TextureMapperGL.cpp:
        (WebCore::getPassesRequiredForFilter):
        (WebCore::BitmapTextureGL::applyFilters):
        * platform/graphics/texmap/TextureMapperGL.h:
        * platform/graphics/texmap/coordinated/CompositingCoordinator.cpp:
        (WebCore::CompositingCoordinator::clearPendingStateChanges):
        (WebCore::CompositingCoordinator::syncLayerState):
        * platform/graphics/texmap/coordinated/CompositingCoordinator.h:
        * platform/graphics/texmap/coordinated/CoordinatedCustomFilterOperation.h: Removed.
        * platform/graphics/texmap/coordinated/CoordinatedCustomFilterProgram.h: Removed.
        * platform/graphics/texmap/coordinated/CoordinatedGraphicsScene.cpp:
        (WebCore::CoordinatedGraphicsScene::setLayerFiltersIfNeeded):
        (WebCore::CoordinatedGraphicsScene::commitSceneState):
        (WebCore::CoordinatedGraphicsScene::setLayerAnimationsIfNeeded):
        * platform/graphics/texmap/coordinated/CoordinatedGraphicsScene.h:
        * platform/graphics/texmap/coordinated/CoordinatedGraphicsState.h:
        * rendering/FilterEffectRenderer.cpp:
        (WebCore::FilterEffectRenderer::FilterEffectRenderer):
        (WebCore::FilterEffectRenderer::build):
        (WebCore::FilterEffectRenderer::computeSourceImageRectForDirtyRect):
        * rendering/FilterEffectRenderer.h:
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::setFilterBackendNeedsRepaintingInRect):
        (WebCore::RenderLayer::calculateClipRects):
        * rendering/RenderLayer.h:
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::updateFilters):
        * rendering/RenderLayerFilterInfo.cpp:
        (WebCore::RenderLayer::FilterInfo::~FilterInfo):
        * rendering/RenderLayerFilterInfo.h:
        * rendering/RenderView.cpp:
        * rendering/RenderView.h:
        * rendering/style/StyleCachedShader.cpp: Removed.
        * rendering/style/StyleCachedShader.h: Removed.
        * rendering/style/StyleCustomFilterProgram.cpp: Removed.
        * rendering/style/StyleCustomFilterProgram.h: Removed.
        * rendering/style/StyleCustomFilterProgramCache.cpp: Removed.
        * rendering/style/StyleCustomFilterProgramCache.h: Removed.
        * rendering/style/StylePendingShader.h: Removed.
        * rendering/style/StyleShader.h: Removed.

2014-01-22  Jon Honeycutt  <jhoneycutt@apple.com>

        REGRESSION(r161967): Crash in WebCore::CachedSVGDocumentReference::load
        <https://webkit.org/b/127151>
        <rdar://problem/15840760>

        There were two issues introduced here; the first is a use-after-free of
        CachedSVGDocumentReference objects.

        The previous code kept a map from FilterOperation ->
        RefPtr<WebKitCSSSVGDocumentValue>, which retained the
        CachedSVGDocument. In r161967, this was changed to use a weak HashSet,
        which allows stale CachedSVGDocumentReferences in the pending document
        set if the owning FilterOperation is deleted. To fix this, we'll keep a
        vector of RefPtr<FilterOperation> with pending SVG documents.

        The second issue is a null deref in CachedSVGDocumentReference::load();
        CachedResourceLoader::requestSVGDocument() can return 0 if (for
        example) an invalid URL is passed. r161967 removed a null check as part
        of the refactoring.

        Reviewed by Dirk Schulze.

        Tests: css3/filters/crash-filter-animation-invalid-url.html
               css3/filters/crash-invalid-url.html

        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::State::clear):
        Use new member var name.
        (WebCore::StyleResolver::loadPendingSVGDocuments):
        For each FilterOperation with a pending SVG document, get or create a
        CachedSVGDocumentReference, and tell it to load. Changed to use new
        function names.
        (WebCore::StyleResolver::createFilterOperations):
        Append the FilterOperation to the list of FilterOperations with
        unloaded SVG documents.

        * css/StyleResolver.h:
        Changed from using PendingSVGDocumentSet, a weak set, to
        a Vector<RefPtr<ReferenceFilterOperation>>.
        (WebCore::StyleResolver::State::filtersWithPendingSVGDocuments):
        Return the vector.

        * loader/cache/CachedSVGDocumentReference.cpp:
        (WebCore::CachedSVGDocumentReference::~CachedSVGDocumentReference):
        Null check m_document rather than checking m_loadRequested.
        m_loadRequested may be true when m_document is 0.
        (WebCore::CachedSVGDocumentReference::load):
        Null check the result of CachedResourceLoader::requestSVGDocument().

        * platform/graphics/filters/FilterOperation.cpp:
        (WebCore::ReferenceFilterOperation::getOrCreateCachedSVGDocumentReference):
        Create, if necessary, and return the CachedSVGDocumentReference.

        * platform/graphics/filters/FilterOperation.h:
        Replaced createCachedSVGDocumentReference() with
        getOrCreateCachedSVGDocumentReference(), which makes for slightly
        cleaner code.

2014-01-23  Antti Koivisto  <antti@apple.com>

        Don't enable speculative tiles immediately after main load stops progressing
        https://bugs.webkit.org/show_bug.cgi?id=127507

        Reviewed by Andreas Kling.

        It is common for timers and events to trigger more loading after the initial main frame loading
        has completed. We should delay a bit before enabling speculative tiles and keep them disabled 
        if loading still continues.

        * page/FrameView.cpp:
        (WebCore::FrameView::FrameView):
        (WebCore::FrameView::adjustTiledBackingCoverage):
        (WebCore::shouldEnableSpeculativeTilingDuringLoading):
        (WebCore::FrameView::enableSpeculativeTilingIfNeeded):
        
            When load progression stops wait 0.5s before enabling speculative tiles.

        (WebCore::FrameView::speculativeTilingEnableTimerFired):
        
            Don't enable speculative tiles if the progression has started again. Instead restart the timer.

        * page/FrameView.h:
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::RenderLayerBacking):
        (WebCore::computeTileCoverage):
        
            Move the FrameView level code to FrameView (so we don't need to add a timer to every RenderLayerBacking).

        * rendering/RenderLayerBacking.h:

2014-01-23  Antti Koivisto  <antti@apple.com>

        Loads started soon after main frame completion should be considered part of the main load
        https://bugs.webkit.org/show_bug.cgi?id=127504

        Reviewed by Andreas Kling.

        ProgressTracker currently decides that main load is complete when the main frame stops loading. 
        However it is common that timers and onload events trigger more loads immediately (for example 
        by inserting iframes) and loading continues visually. These should be considered as part of the
        main load for paint throttling and speculative tiling coverage purposes.

        * loader/ProgressTracker.cpp:
        (WebCore::ProgressTracker::ProgressTracker):
        (WebCore::ProgressTracker::progressStarted):
        
            Track whether this is considered part of the main load or not with a boolean. 
            It is set for subframe loads too if they start loading soon (within 1s) after the main frame load completes.

        (WebCore::ProgressTracker::finalProgressComplete):
        
            Get a timestamp.

        (WebCore::ProgressTracker::isMainLoadProgressing):

            New definition of "main load".

        * loader/ProgressTracker.h:

2014-01-23  peavo@outlook.com  <peavo@outlook.com>

        [WinCairo] Compile error.
        https://bugs.webkit.org/show_bug.cgi?id=127499

        Reviewed by Brent Fulgham.

        * platform/network/curl/ResourceError.h: Include <winsock2.h> before <curl/curl.h>.

2014-01-23  Brady Eidson  <beidson@apple.com>

        IDB: Implement cross-thread and IPC plumbing for 'get' support
        https://bugs.webkit.org/show_bug.cgi?id=127501

        Reviewed by Anders Carlsson.

        Add isolatedCopy to the IDBGetResult object:
        * Modules/indexeddb/IDBGetResult.h:
        (WebCore::IDBGetResult::isolatedCopy):

        Add a cross-thread and cross-IPC appropriate object for IDBKeyRanges:
        * Modules/indexeddb/IDBKeyRangeData.cpp: Copied from Source/WebCore/Modules/indexeddb/IDBGetResult.h.
        (WebCore::IDBKeyRangeData::isolatedCopy):
        * Modules/indexeddb/IDBKeyRangeData.h: Copied from Source/WebCore/Modules/indexeddb/IDBGetResult.h.
        (WebCore::IDBKeyRangeData::IDBKeyRangeData):

        Add a few more cross-thread copiers:
        * platform/CrossThreadCopier.cpp:
        (WebCore::IDBGetResult>::copy):
        (WebCore::IDBKeyRangeData>::copy):
        * platform/CrossThreadCopier.h:

        Project file gunk:
        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.exp.in:
        * WebCore.xcodeproj/project.pbxproj:

2014-01-23  Jer Noble  <jer.noble@apple.com>

        [MSE][Mac] Adopt new AVStreamDataParser delegate API
        https://bugs.webkit.org/show_bug.cgi?id=127498

        Reviewed by Eric Carlson.

        Adopt a new delegate API which passes in whether or not the new AVAsset
        is discontinuous, implying the AVAsset is entirely new rather than
        just updated with new information.

        * platform/graphics/avfoundation/objc/SourceBufferPrivateAVFObjC.mm:
        (-[WebAVStreamDataParserListener streamDataParser:didParseStreamDataAsAsset:withDiscontinuity:]):

2014-01-23  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Use PDFPlugin even if there's an external plugin installed, if it's blocked
        https://bugs.webkit.org/show_bug.cgi?id=127415
        <rdar://problem/12482452>

        Reviewed by Sam Weinig.

        * English.lproj/Localizable.strings:
        * WebCore.exp.in:
        * platform/LocalizedStrings.cpp:
        (WebCore::useBlockedPlugInContextMenuTitle):
        * platform/LocalizedStrings.h:
        Add a localizable string for the generic case, where the client
        didn't provide a more specific string for the context menu item.

2014-01-23  peavo@outlook.com  <peavo@outlook.com>

        [Curl] There is no way to specify cache folder.
        https://bugs.webkit.org/show_bug.cgi?id=125028

        Reviewed by Brent Fulgham.

        Fixed logical test, disc cache should be disabled if creating cache folder fails.

        * platform/network/curl/CurlCacheManager.cpp:
        (WebCore::CurlCacheManager::setCacheDirectory):

2014-01-23  Brady Eidson  <beidson@apple.com>

        Unreviewed build fix.

        * WebCore.xcodeproj/project.pbxproj: Export the new header so WebKit can see it

2014-01-22  Brent Fulgham  <bfulgham@apple.com>

        [Win] Update project and solution files for 64-bit builds
        https://bugs.webkit.org/show_bug.cgi?id=127457

        Reviewed by Eric Carlson.

        * WebCore.vcxproj/QTMovieWin/QTMovieWin.vcxproj: Update for VS2013
        * WebCore.vcxproj/WebCore.submit.sln: Add x64 targets
        * WebCore.vcxproj/WebCore.vcxproj: Update for VS2013. Also exclude 32-bit specific
        assembly when building 64-bit target.
        * WebCore.vcxproj/WebCore.vcxproj.filters: Update for VS2013
        * config.h: Handle 64-bit type definitions.
        * platform/graphics/ca/win/PlatformCAAnimationWin.cpp:
        (PlatformCAAnimation::setFromValue): Use CGFloat to support 64-bit builds
        (PlatformCAAnimation::setToValue): Ditto
        (PlatformCAAnimation::setValues): Ditto
        * platform/graphics/win/FontCustomPlatformData.cpp:
        (WebCore::FontCustomPlatformData::fontPlatformData): Add cast to
        support 32- and 64-bit targets.
        * platform/graphics/win/GraphicsContextCGWin.cpp:
        (WebCore::GraphicsContext::drawLineForDocumentMarker): Use CGFloat to
        support 64-bit builds.
        * platform/win/PasteboardWin.cpp:
        (WebCore::Pasteboard::writeURLToDataObject): Specialize std::min to
        work on 32- and 64-bit code.
        (WebCore::createGlobalImageFileDescriptor): Ditto
        * platform/win/StructuredExceptionHandlerSuppressor.cpp:
        (WebCore::StructuredExceptionHandlerSuppressor::StructuredExceptionHandlerSuppressor):
        Comment out 32-bit inline assembly.
        (WebCore::StructuredExceptionHandlerSuppressor::~StructuredExceptionHandlerSuppressor):
        Ditto

2014-01-23  Brady Eidson  <beidson@apple.com>

        Make IDBGetResult work with IDBKeyData instead of IDBKey.
        https://bugs.webkit.org/show_bug.cgi?id=127493

        Reviewed by Eric Carlson.

        Also break it into its own header to work better with IPC messages.

        * Modules/indexeddb/IDBGetResult.h: Added.
        (WebCore::IDBGetResult::IDBGetResult):

        * Modules/indexeddb/IDBServerConnection.h:

        * Modules/indexeddb/IDBTransactionBackendOperations.cpp:
        (WebCore::GetOperation::perform):

        * WebCore.xcodeproj/project.pbxproj:

2014-01-23  Mátyás Mustoha  <mmatyas@inf.u-szeged.hu>

        [curl] Add storage limit to cache manager
        https://bugs.webkit.org/show_bug.cgi?id=125779

        Reviewed by Brent Fulgham.

        Sets a local disc storage size limit for the cache manager
        used by the curl network backend.

        * platform/network/curl/CurlCacheEntry.cpp:
        (WebCore::CurlCacheEntry::CurlCacheEntry):
        (WebCore::CurlCacheEntry::isCached):
        (WebCore::CurlCacheEntry::saveCachedData):
        (WebCore::CurlCacheEntry::readCachedData):
        (WebCore::CurlCacheEntry::didFail):
        (WebCore::CurlCacheEntry::didFinishLoading):
        (WebCore::CurlCacheEntry::loadFileToBuffer):
        (WebCore::CurlCacheEntry::parseResponseHeaders):
        (WebCore::CurlCacheEntry::entrySize):
        * platform/network/curl/CurlCacheEntry.h:
        (WebCore::CurlCacheEntry::requestHeaders):
        * platform/network/curl/CurlCacheManager.cpp:
        (WebCore::CurlCacheManager::CurlCacheManager):
        (WebCore::CurlCacheManager::setStorageSizeLimit):
        (WebCore::CurlCacheManager::loadIndex):
        (WebCore::CurlCacheManager::saveIndex):
        (WebCore::CurlCacheManager::makeRoomForNewEntry):
        (WebCore::CurlCacheManager::didReceiveResponse):
        (WebCore::CurlCacheManager::didReceiveData):
        (WebCore::CurlCacheManager::invalidateCacheEntry):
        (WebCore::CurlCacheManager::readCachedData):
        * platform/network/curl/CurlCacheManager.h:
        (WebCore::CurlCacheManager::cacheDirectory):

2014-01-23  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix automake warning.

        * GNUmakefile.list.am: Remove trailing whitespaces.

2014-01-23  Mihai Maerean  <mmaerean@adobe.com>

        [CSS Regions] Fix positioning composited layers when the region has overflow:hidden
        https://bugs.webkit.org/show_bug.cgi?id=124042

        Reviewed by Mihnea Ovidenie.

        If there's a clipping GraphicsLayer on the hierarchy, substract its offset, since it's its
        parent that positions us.

        Tests: compositing/regions/position-layer-inside-region-overflow-hidden.html
               compositing/regions/position-layer-inside-overflow-hidden.html
               compositing/regions/position-layers-inside-region-overflow-hidden.html
               compositing/regions/position-layers-inside-regions-overflow-hidden.html

        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::adjustAncestorCompositingBoundsForFlowThread): The position
        must also be correct when the region has box-shadow that inflates the region's layer. The
        composited layers from the flow thread should be rendered in the same position whether the
        associated region has clipping or not.
        Using the position of the clipping layer instead of the location of the clipbox makes it
        also work with box-shadow that inflates the region's graphics layer.

2014-01-23  Andrei Bucur  <abucur@adobe.com>

        [CSS Regions] Convert regions iterator loops to range-based loops
        https://bugs.webkit.org/show_bug.cgi?id=127464

        Reviewed by Antti Koivisto.

        Replace most of the iterator loops in the region implementation with
        range based for loops. The for loops that iterate only over subsets
        of collections have not been changed.

        Tests: no new tests, this is a refactoring patch.

        * dom/WebKitNamedFlow.cpp:
        (WebCore::WebKitNamedFlow::firstEmptyRegionIndex):
        (WebCore::WebKitNamedFlow::getRegionsByContent):
        (WebCore::WebKitNamedFlow::getRegions):
        (WebCore::WebKitNamedFlow::getContent):
        * inspector/InspectorOverlay.cpp:
        (WebCore::buildObjectForCSSRegionsHighlight):
        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::validateRegions):
        (WebCore::RenderFlowThread::updateLogicalWidth):
        (WebCore::RenderFlowThread::computeLogicalHeight):
        (WebCore::RenderFlowThread::repaintRectangleInRegions):
        (WebCore::RenderFlowThread::removeRenderBoxRegionInfo):
        (WebCore::RenderFlowThread::logicalWidthChangedInRegionsForBlock):
        (WebCore::RenderFlowThread::clearRenderBoxRegionInfoAndCustomStyle):
        (WebCore::RenderFlowThread::isAutoLogicalHeightRegionsCountConsistent):
        (WebCore::RenderFlowThread::markAutoLogicalHeightRegionsForLayout):
        (WebCore::RenderFlowThread::markRegionsForOverflowLayoutIfNeeded):
        (WebCore::RenderFlowThread::updateRegionsFlowThreadPortionRect):
        (WebCore::RenderFlowThread::collectLayerFragments):
        (WebCore::RenderFlowThread::fragmentsBoundingBox):
        * rendering/RenderNamedFlowFragment.cpp:
        (WebCore::RenderNamedFlowFragment::setRegionObjectsRegionStyle):
        (WebCore::RenderNamedFlowFragment::restoreRegionObjectsOriginalStyle):
        * rendering/RenderNamedFlowThread.cpp:
        (WebCore::RenderNamedFlowThread::clearContentElements):
        (WebCore::RenderNamedFlowThread::nextRendererForNode):
        (WebCore::RenderNamedFlowThread::dependsOn):
        (WebCore::RenderNamedFlowThread::computeOversetStateForRegions):
        (WebCore::RenderNamedFlowThread::checkInvalidRegions):
        (WebCore::RenderNamedFlowThread::pushDependencies):
        (WebCore::RenderNamedFlowThread::registerNamedFlowContentElement):
        (WebCore::isContainedInElements):
        (WebCore::RenderNamedFlowThread::getRanges):
        (WebCore::RenderNamedFlowThread::checkRegionsWithStyling):
        (WebCore::RenderNamedFlowThread::clearRenderObjectCustomStyle):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::writeRenderRegionList):

2014-01-23  László Langó  <llango.u-szeged@partner.samsung.com>

        Range should be constructable.
        https://bugs.webkit.org/show_bug.cgi?id=115639

        Reviewed by Ryosuke Niwa.

        http://www.w3.org/TR/2013/WD-dom-20131107/#interface-range
        Now we can do `new Range()` instead of `document.createRange()`.

        Backported from Blink: https://chromium.googlesource.com/chromium/blink/+/47ca40efdf58a4787aa33aa75a35778899b1c002%5E%21

        Test: fast/dom/Range/range-constructor.html

        * dom/Range.cpp:
        (WebCore::Range::create):
        * dom/Range.h:
        * dom/Range.idl:

2014-01-23  ChangSeok Oh  <changseok.oh@collabora.com>

        Unreviewed build fix for gles after r162565. Add missing definitions.

        * platform/graphics/opengl/GraphicsContext3DOpenGLES.cpp:
        (WebCore::GraphicsContext3D::drawArraysInstanced):
        (WebCore::GraphicsContext3D::drawElementsInstanced):
        (WebCore::GraphicsContext3D::vertexAttribDivisor):

2014-01-22  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GLIB] Use GUniquePtr instead of GOwnPtr
        https://bugs.webkit.org/show_bug.cgi?id=127431

        Reviewed by Martin Robinson.

        GUniquePtr is a template alias of std::unique_ptr with a custom
        deleter that replaces GOwnPtr. GOwnPtr is still used for the cases
        where the output pointer is needed, but it will also be replaced soon.

        * GNUmakefile.list.am:
        * PlatformGTK.cmake:
        * accessibility/atk/AXObjectCacheAtk.cpp:
        * accessibility/atk/WebKitAccessibleInterfaceText.cpp:
        (getAttributeSetForAccessibilityObject):
        (accessibilityObjectLength):
        (textExtents):
        (webkitAccessibleTextGetChar):
        (numberOfReplacedElementsBeforeOffset):
        * page/ContextMenuController.cpp:
        * platform/SharedBuffer.h:
        * platform/audio/gstreamer/WebKitWebAudioSourceGStreamer.cpp:
        (webKitWebAudioSrcConstructed):
        (webKitWebAudioSrcLoop):
        * platform/audio/gtk/AudioBusGtk.cpp:
        (WebCore::AudioBus::loadPlatformResource):
        * platform/geoclue/GeolocationProviderGeoclue.cpp:
        * platform/graphics/gstreamer/ImageGStreamerCairo.cpp:
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::setAudioStreamProperties):
        (WebCore::MediaPlayerPrivateGStreamer::handleMessage):
        * platform/graphics/gstreamer/WebKitMediaSourceGStreamer.cpp:
        (webKitMediaSrcAddSrc):
        * platform/graphics/gstreamer/WebKitWebSourceGStreamer.cpp:
        (webKitWebSrcStart):
        (ResourceHandleStreamingClient::wasBlocked):
        (ResourceHandleStreamingClient::cannotShowURL):
        * platform/graphics/gtk/ImageBufferGtk.cpp:
        (WebCore::encodeImage):
        (WebCore::ImageBuffer::toDataURL):
        * platform/graphics/gtk/ImageGtk.cpp:
        (WebCore::getThemeIconFileName):
        (WebCore::Image::loadPlatformResource):
        * platform/gtk/ContextMenuGtk.cpp:
        (WebCore::ContextMenu::itemCount):
        (WebCore::contextMenuItemVector):
        * platform/gtk/ContextMenuItemGtk.cpp:
        (WebCore::createPlatformMenuItemDescription):
        * platform/gtk/DataObjectGtk.cpp:
        (WebCore::DataObjectGtk::setURIList):
        (WebCore::DataObjectGtk::setURL):
        * platform/gtk/FileSystemGtk.cpp:
        (WebCore::filenameToString):
        (WebCore::fileSystemRepresentation):
        (WebCore::filenameForDisplay):
        (WebCore::pathGetFileName):
        (WebCore::applicationDirectoryPath):
        (WebCore::sharedResourcesPath):
        (WebCore::directoryName):
        (WebCore::listDirectory):
        (WebCore::openTemporaryFile):
        * platform/gtk/GOwnPtrGtk.cpp: Removed.
        * platform/gtk/GOwnPtrGtk.h: Removed.
        * platform/gtk/GUniquePtrGtk.h: Added.
        * platform/gtk/GamepadsGtk.cpp:
        (WebCore::GamepadsGtk::GamepadsGtk):
        * platform/gtk/GtkClickCounter.cpp:
        (WebCore::GtkClickCounter::shouldProcessButtonEvent):
        * platform/gtk/GtkInputMethodFilter.cpp:
        (WebCore::GtkInputMethodFilter::sendCompositionAndPreeditWithFakeKeyEvents):
        * platform/gtk/GtkPopupMenu.cpp:
        (WebCore::GtkPopupMenu::popUp):
        (WebCore::GtkPopupMenu::typeAheadFind):
        * platform/gtk/LanguageGtk.cpp:
        (WebCore::platformLanguage):
        * platform/gtk/LocalizedStringsGtk.cpp:
        (WebCore::imageTitle):
        (WebCore::localizedMediaTimeDescription):
        * platform/gtk/PasteboardHelper.cpp:
        (WebCore::selectionDataToUTF8String):
        (WebCore::PasteboardHelper::getClipboardContents):
        (WebCore::PasteboardHelper::fillSelectionData):
        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenuGtk::createGtkActionForMenuItem):
        (WebCore::PopupMenuGtk::show):
        * platform/gtk/WebKitAuthenticationWidget.cpp:
        (webkitAuthenticationWidgetInitialize):
        * platform/network/ResourceHandleInternal.h:
        * platform/network/gtk/CredentialBackingStore.cpp:
        (WebCore::credentialForChallengeAsyncReadyCallback):
        * platform/network/soup/CookieJarSoup.cpp:
        (WebCore::setCookiesFromDOM):
        (WebCore::cookiesForSession):
        (WebCore::getRawCookies):
        (WebCore::deleteCookie):
        (WebCore::getHostnamesWithCookies):
        (WebCore::deleteCookiesForHostname):
        (WebCore::deleteAllCookies):
        * platform/network/soup/DNSSoup.cpp:
        * platform/network/soup/GUniquePtrSoup.h: Added.
        * platform/network/soup/ResourceErrorSoup.cpp:
        (WebCore::failingURI):
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::ensureReadBuffer):
        (WebCore::cleanupSoupRequestOperation):
        (WebCore::createSoupRequestAndMessageForHandle):
        * platform/network/soup/ResourceRequestSoup.cpp:
        (WebCore::ResourceRequest::updateSoupMessageMembers):
        (WebCore::ResourceRequest::updateSoupMessage):
        * platform/network/soup/ResourceResponseSoup.cpp:
        * platform/network/soup/SoupURIUtils.cpp:
        (WebCore::soupURIToKURL):
        * platform/soup/SharedBufferSoup.cpp:
        (WebCore::SharedBuffer::SharedBuffer):
        (WebCore::SharedBuffer::clearPlatformData):
        (WebCore::SharedBuffer::maybeTransferPlatformData):
        (WebCore::SharedBuffer::hasPlatformData):
        * plugins/gtk/PluginPackageGtk.cpp:
        (WebCore::PluginPackage::fetchInfo):
        (WebCore::PluginPackage::load):

2014-01-22  Simon Fraser  <simon.fraser@apple.com>

        Surround fixedVisibleContentRect code with USE(TILED_BACKING_STORE)
        https://bugs.webkit.org/show_bug.cgi?id=127461

        Reviewed by Andreas Kling.

        The "fixedVisibleContentRect" code path is only used by platforms
        which enabled TILED_BACKING_STORE, so to reduce confusion, surround
        this code with #if USE(TILED_BACKING_STORE).

        * page/Frame.cpp:
        (WebCore::Frame::createView):
        * page/FrameView.cpp:
        * page/FrameView.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::unscaledVisibleContentSize):
        (WebCore::ScrollView::visibleContentRect):
        * platform/ScrollView.h:
        (WebCore::ScrollView::visibleSize):

2014-01-22  Myles C. Maxfield  <mmaxfield@apple.com>

        ASSERTION FAILED: v.isFixed() in WebCore::RenderStyle::setWordSpacing
        https://bugs.webkit.org/show_bug.cgi?id=126987

        Reviewed by Simon Fraser.

        When "inherit" is specified and there is no parent, Length values have an "Auto" type

        Test: fast/css3-text/css3-word-spacing-percentage/word-spacing-crash.html

        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::setWordSpacing):

2014-01-22  Samuel White  <samuel_white@apple.com>

        AX: Can't always increment web sliders.
        https://bugs.webkit.org/show_bug.cgi?id=127451

        Reviewed by Chris Fleizach.

        Clamping the decrement/increment amount to one when necessary (if a percent change would result in a change of less than one).

        Test: accessibility/range-alter-by-percent.html

        * accessibility/AccessibilityNodeObject.cpp:
        (WebCore::AccessibilityNodeObject::changeValueByPercent):

2014-01-22  Myles C. Maxfield  <mmaxfield@apple.com>

        Remove CSS3_TEXT_DECORATION define
        https://bugs.webkit.org/show_bug.cgi?id=127333

        Reviewed by Simon Fraser.

        This is required for unprefixing the text-decoration-* CSS properties.

        No new tests are necessary becase the flag was already on by default.

        * Configurations/FeatureDefines.xcconfig:
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::renderTextDecorationSkipFlagsToCSSValue):
        (WebCore::ComputedStyleExtractor::propertyValue):
        * css/CSSParser.cpp:
        (WebCore::isColorPropertyID):
        (WebCore::CSSParser::parseValue):
        (WebCore::CSSParser::addTextDecorationProperty):
        (WebCore::CSSParser::parseTextUnderlinePosition):
        * css/CSSParser.h:
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::operator TextUnderlinePosition):
        * css/CSSPropertyNames.in:
        * css/CSSValueKeywords.in:
        * css/DeprecatedStyleBuilder.cpp:
        (WebCore::DeprecatedStyleBuilder::DeprecatedStyleBuilder):
        * css/StylePropertyShorthand.cpp:
        (WebCore::webkitTextDecorationShorthand):
        (WebCore::shorthandForProperty):
        (WebCore::matchingShorthandsForLonghand):
        * css/StylePropertyShorthand.h:
        * css/StyleResolver.cpp:
        (WebCore::shouldApplyPropertyInParseOrder):
        (WebCore::isValidVisitedLinkProperty):
        (WebCore::StyleResolver::applyProperty):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContext::setPlatformStrokeStyle):
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::platformInit):
        * platform/graphics/wince/GraphicsContextWinCE.cpp:
        (WebCore::createPen):
        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::computeMaxLogicalTop):
        * rendering/InlineFlowBox.h:
        * rendering/InlineTextBox.cpp:
        (WebCore::textDecorationStyleToStrokeStyle):
        (WebCore::boundingBoxForAllActiveDecorations):
        (WebCore::InlineTextBox::paintDecoration):
        * rendering/RenderObject.cpp:
        (WebCore::decorationColor):
        * rendering/RootInlineBox.cpp:
        (WebCore::RootInlineBox::maxLogicalTop):
        * rendering/RootInlineBox.h:
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::changeRequiresRepaintIfTextOrBorderOrOutline):
        (WebCore::RenderStyle::colorIncludingFallback):
        (WebCore::RenderStyle::visitedDependentColor):
        * rendering/style/RenderStyle.h:
        * rendering/style/RenderStyleConstants.h:
        * rendering/style/StyleRareInheritedData.cpp:
        (WebCore::StyleRareInheritedData::StyleRareInheritedData):
        (WebCore::StyleRareInheritedData::operator==):
        * rendering/style/StyleRareInheritedData.h:
        * rendering/style/StyleRareNonInheritedData.cpp:
        (WebCore::StyleRareNonInheritedData::StyleRareNonInheritedData):
        (WebCore::StyleRareNonInheritedData::operator==):
        * rendering/style/StyleRareNonInheritedData.h:

2014-01-22  Chris Fleizach  <cfleizach@apple.com>

        AX: Do not return an accessible name for an object just because it has tabindex=0
        https://bugs.webkit.org/show_bug.cgi?id=126914

        Reviewed by Mario Sanchez Prada.

        WebKit has code to return an accessible name for any object that is "generically" focusable (ie. tabindex=0).
        This behavior, which is not supported in ARIA, has caused many problems for VoiceOver. Often VoiceOver will
        speak all the text underneath any type of group.

        I think we need to revert this behavior and follow the ARIA spec more closely.

        Test: accessibility/aria-describedby-ensures-visibility.html

        * accessibility/AccessibilityNodeObject.cpp:
        (WebCore::AccessibilityNodeObject::visibleText):
        (WebCore::AccessibilityNodeObject::title):

2014-01-22  Brady Eidson  <beidson@apple.com>

        The IDB backing store get() method shouldn't call IDB callbacks directly
        https://bugs.webkit.org/show_bug.cgi?id=127453

        Reviewed by Beth Dakin.

        * Modules/indexeddb/IDBServerConnection.h:
        (WebCore::IDBGetResult::IDBGetResult): Add a new structure to hold all of the
          possible results of a get() call.

        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.cpp:
        (WebCore::IDBServerConnectionLevelDB::get): Don't call IDBCallbacks directly.
          Instead, return the GetResult to the GetOperation which will make IDBCallbacks.
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.h:

        * Modules/indexeddb/IDBTransactionBackendOperations.cpp:
        (WebCore::GetOperation::perform): Get all of the IDBGetResults in the completion callback
          make the appropriate IDBCallback.
        * Modules/indexeddb/IDBTransactionBackendOperations.h:

2014-01-22  Dean Jackson  <dino@apple.com>

        Unreviewed attempt to fix 32-bit builds.

        Use long long rather than GC3Dintptr.

        * html/canvas/ANGLEInstancedArrays.cpp:
        (WebCore::ANGLEInstancedArrays::drawElementsInstancedANGLE):
        * html/canvas/ANGLEInstancedArrays.h:
        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::drawElementsInstanced):
        * html/canvas/WebGLRenderingContext.h:

2014-01-21  Brady Eidson  <beidson@apple.com>

        IDB: "Put" support
        <rdar://problem/15779643> and https://bugs.webkit.org/show_bug.cgi?id=127401

        Reviewed by Alexey Proskuryakov.

        Add persistent encode/decode for storage to the database:
        * Modules/indexeddb/IDBKey.cpp:
        (WebCore::IDBKey::encode):
        (WebCore::IDBKey::decode):
        * Modules/indexeddb/IDBKey.h:

        Add a data class to represent IDBKey suitable for crossing IPC:
        * Modules/indexeddb/IDBKeyData.cpp: Added.
        (WebCore::IDBKeyData::IDBKeyData):
        (WebCore::IDBKeyData::maybeCreateIDBKey):
        (WebCore::IDBKeyData::isolatedCopy):
        * Modules/indexeddb/IDBKeyData.h: Added.
        (WebCore::IDBKeyData::IDBKeyData):

        * platform/CrossThreadCopier.cpp:
        (WebCore::IDBKeyData>::copy):
        * platform/CrossThreadCopier.h:

        * WebCore.exp.in:
        * WebCore.xcodeproj/project.pbxproj:

2014-01-22  Dean Jackson  <dino@apple.com>

        [WebGL] Implement ANGLE_instanced_arrays
        https://bugs.webkit.org/show_bug.cgi?id=127257

        Reviewed by Brent Fulgham.

        Implement the instanced drawing WebGL extension,
        ANGLE_instanced_arrays. This is currently Mac-only,
        but should be portable to other platforms if their
        OpenGL exposes the functions. It's also done in a way
        that will make exposing it to WebGL2 simple.

        Test: fast/canvas/webgl/angle-instanced-arrays.html

        * CMakeLists.txt:
        * DerivedSources.cpp:
        * DerivedSources.make:
        * GNUmakefile.list.am:
        * WebCore.vcxproj/WebCore.vcxproj:
        * WebCore.vcxproj/WebCore.vcxproj.filters:
        * WebCore.xcodeproj/project.pbxproj:
        Add the new files to all the build systems.

        * bindings/js/JSWebGLRenderingContextCustom.cpp:
        (WebCore::toJS): Link JS side to C++ side.

        * html/canvas/ANGLEInstancedArrays.cpp: Added.
        (WebCore::ANGLEInstancedArrays::ANGLEInstancedArrays):
        * html/canvas/ANGLEInstancedArrays.h: Added.
        * html/canvas/ANGLEInstancedArrays.idl: Added.
        New boilerplate files that expose the extension methods.

        * html/canvas/WebGLExtension.h: New extension enum.

        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::validateVertexAttributes): Add an optional
        parameter representing the number of instance primitives we are asked
        to draw. Use that for the draw count if looking at an instanced attribute.
        Also make sure we see at least one non-instanced attribute.
        (WebCore::WebGLRenderingContext::validateDrawArrays): Update this so it could
        be used from either drawArrays or drawArraysInstanced.
        (WebCore::WebGLRenderingContext::drawArrays):
        (WebCore::WebGLRenderingContext::validateDrawElements): Same here, now can be
        used by the instanced and non-instanced versions.
        (WebCore::WebGLRenderingContext::drawElements):
        (WebCore::WebGLRenderingContext::getExtension): Create and return the new extension.
        (WebCore::WebGLRenderingContext::getSupportedExtensions): Add new extension to the list.
        (WebCore::WebGLRenderingContext::getVertexAttrib): Intercept a query to the divisor
        attribute and return the value we kept in the state.
        (WebCore::WebGLRenderingContext::drawArraysInstanced): Call the GC3D method.
        (WebCore::WebGLRenderingContext::drawElementsInstanced): Ditto.
        (WebCore::WebGLRenderingContext::vertexAttribDivisor): Ditto.

        * html/canvas/WebGLRenderingContext.h: Define the new methods and parameters.

        * html/canvas/WebGLVertexArrayObjectOES.cpp:
        (WebCore::WebGLVertexArrayObjectOES::setVertexAttribDivisor): Keep a record of the
        divisor if we set it.
        * html/canvas/WebGLVertexArrayObjectOES.h:
        (WebCore::WebGLVertexArrayObjectOES::VertexAttribState::VertexAttribState):

        * platform/graphics/GraphicsContext3D.h: New enum.
        * platform/graphics/mac/GraphicsContext3DMac.mm:
        (WebCore::GraphicsContext3D::drawArraysInstanced): The actual calls into OpenGL.
        (WebCore::GraphicsContext3D::drawElementsInstanced): Ditto.
        (WebCore::GraphicsContext3D::vertexAttribDivisor): Ditto.

        * platform/graphics/opengl/GraphicsContext3DOpenGL.cpp: Empty implementations
        for non-mac platforms.

        * platform/graphics/ios/GraphicsContext3DIOS.h: Define the iOS names for the
        functions.

2014-01-22  Zalan Bujtas  <zalan@apple.com>

        [CSS Shapes] shape-inside rectangle layout can fail
        https://bugs.webkit.org/show_bug.cgi?id=124784

        Reviewed by Darin Adler.

        Early subpixel rounding/flooring/ceiling can have unwanted
        side effect on the final pixel value. Delay pixel
        conversions as much as possible.

        Existing test is changed to reflect subpixel functionality.

        * rendering/shapes/RectangleShape.cpp:
        (WebCore::RectangleShape::firstIncludedIntervalLogicalTop):

2014-01-22  Jochen Eisinger  <jochen@chromium.org>

        Add protocolIsInHTTPFamily for strings and use it where appropriate
        https://bugs.webkit.org/show_bug.cgi?id=127336

        Reviewed by Alexey Proskuryakov.

        * html/HTMLAnchorElement.cpp:
        (WebCore::HTMLAnchorElement::parseAttribute):
        * page/ContentSecurityPolicy.cpp:
        (WebCore::CSPSource::schemeMatches):
        * page/SecurityPolicy.cpp:
        (WebCore::SecurityPolicy::generateReferrerHeader):
        * platform/URL.cpp:
        (WebCore::protocolIsInHTTPFamily):
        * platform/URL.h:

2014-01-22  Zalan Bujtas  <zalan@apple.com>

        Subpixel Layout: SimpleLineLayout needs more position rounding to match InlineFlowBox layout.
        https://bugs.webkit.org/show_bug.cgi?id=127404

        Reviewed by Antti Koivisto.

        In order to produce a CSS pixel perfect layout, SimpleLineLayout needs to
        round line positions to CSS (integral) position similarly to InlineFlowBox.

        Existing tests cover it.

        * rendering/SimpleLineLayoutResolver.h:
        (WebCore::SimpleLineLayout::RunResolver::Run::rect):
        (WebCore::SimpleLineLayout::RunResolver::Run::baseline):

2014-01-22  Joseph Pecoraro  <pecoraro@apple.com>

        Unreviewed rollout of r162534, this caused inspector test failures.

        * bindings/js/PageScriptDebugServer.cpp:
        (WebCore::PageScriptDebugServer::addListener):
        (WebCore::PageScriptDebugServer::removeListener):
        (WebCore::PageScriptDebugServer::recompileAllJSFunctions):
        (WebCore::PageScriptDebugServer::didRemoveLastListener):
        * bindings/js/PageScriptDebugServer.h:
        * bindings/js/ScriptDebugServer.cpp:
        (WebCore::ScriptDebugServer::ScriptDebugServer):
        (WebCore::ScriptDebugServer::recompileAllJSFunctionsSoon):
        (WebCore::ScriptDebugServer::recompileAllJSFunctionsTimerFired):
        * bindings/js/ScriptDebugServer.h:
        * bindings/js/WorkerScriptDebugServer.cpp:
        (WebCore::WorkerScriptDebugServer::addListener):
        (WebCore::WorkerScriptDebugServer::recompileAllJSFunctions):
        (WebCore::WorkerScriptDebugServer::removeListener):
        * inspector/InspectorProfilerAgent.cpp:

2014-01-22  peavo@outlook.com  <peavo@outlook.com>

        Crashes in setTextForIterator
        https://bugs.webkit.org/show_bug.cgi?id=127424

        Reviewed by Brent Fulgham.

        * platform/text/icu/UTextProviderLatin1.cpp:
        (WebCore::uTextLatin1Clone): Provide correct buffer size in utext_setup function call.
        (WebCore::uTextLatin1Access): Give correct buffer size to memset call.
        (WebCore::openLatin1UTextProvider): Ditto.

2014-01-22  Jer Noble  <jer.noble@apple.com>

        [Mac] MediaPlayerPrivateMediaSourceAVFObjC::load ASSERTs on lots of tests
        https://bugs.webkit.org/show_bug.cgi?id=127430

        Reviewed by Eric Carlson.

        When other registered media engines cannot load a URL, the engine selection
        will eventually pick MediaPlayerPrivateMediaSourceAVFObjC and ask it to load
        the URL. Instead of ASSERTing here, simply reject the URL by setting the
        network state to FormatError.

        * platform/graphics/avfoundation/objc/MediaPlayerPrivateMediaSourceAVFObjC.mm:
        (WebCore::MediaPlayerPrivateMediaSourceAVFObjC::load):

2014-01-22  Thiago de Barros Lacerda  <thiago.lacerda@openbossa.org>

        [EFL][GTK] Get EFL and GTK compiling with ACCESSIBILITY disabled
        https://bugs.webkit.org/show_bug.cgi?id=127119

        Reviewed by Mario Sanchez Prada.

        At build time, the compiler was not able to determine which Timer's constructor to call in AXObjectCache when
        ACCESSIBILITY is not enabled, fixing that.
        Also guarding some members in AccessibilityObject that are only being used by EFL and GTK with ACCESSIBILITY.

        * accessibility/AXObjectCache.h:
        (WebCore::AXObjectCache::AXObjectCache):
        * accessibility/AccessibilityObject.h:

2014-01-22  Peter Molnar  <pmolnar.u-szeged@partner.samsung.com>

        Refactor calculation of hasRx and hasRy values in SVGPathData
        https://bugs.webkit.org/show_bug.cgi?id=127423

        Reviewed by Darin Adler.

        This is a follow-up on https://bugs.webkit.org/show_bug.cgi?id=127337

        * rendering/svg/SVGPathData.cpp:
        (WebCore::updatePathFromRectElement):

2014-01-21  Joseph Pecoraro  <pecoraro@apple.com>

        Web Inspector: Remove recompileAllJSFunctions timer in ScriptDebugServer
        https://bugs.webkit.org/show_bug.cgi?id=127409

        Reviewed by Timothy Hatcher.

        * bindings/js/ScriptDebugServer.h:
        * bindings/js/ScriptDebugServer.cpp:
        (WebCore::ScriptDebugServer::ScriptDebugServer):
        Remove m_recompileTimer and the recompile soon function.
        We can just recompile immediately in all existing cases.

        * bindings/js/PageScriptDebugServer.h:
        * bindings/js/PageScriptDebugServer.cpp:
        (WebCore::PageScriptDebugServer::addListener):
        (WebCore::PageScriptDebugServer::removeListener):
        (WebCore::PageScriptDebugServer::recompileAllJSFunctions):
        (WebCore::PageScriptDebugServer::didAddFirstListener):
        (WebCore::PageScriptDebugServer::didRemoveLastListener):
        Add a "didAddFirstListener" to match "didRemoveLastListener".
        Only recompile functions when we attach the debugger and when
        we detach the last listener.

        * bindings/js/WorkerScriptDebugServer.cpp:
        (WebCore::WorkerScriptDebugServer::addListener):
        (WebCore::WorkerScriptDebugServer::removeListener):
        (WebCore::WorkerScriptDebugServer::recompileAllJSFunctions):
        Same thing. Also rearrange the functions to read better.

        * inspector/InspectorProfilerAgent.cpp:
        Use the direct recompile function instead of the removed "soon" version.

2014-01-22  Robert Sipka  <sipka@inf.u-szeged.hu>

        [curl] Improve detecting and handling of SSL client certificate
        https://bugs.webkit.org/show_bug.cgi?id=125006

        Reviewed by Brent Fulgham.

        Add client certificate handling.

        * platform/network/ResourceHandle.h:
        * platform/network/curl/ResourceError.h:
        (WebCore::ResourceError::hasSSLConnectError):
        * platform/network/curl/ResourceHandleCurl.cpp:
        (WebCore::ResourceHandle::setClientCertificateInfo):
        * platform/network/curl/ResourceHandleManager.cpp:
        (WebCore::ResourceHandleManager::initializeHandle):
        * platform/network/curl/SSLHandle.cpp:
        (WebCore::addAllowedClientCertificate):
        (WebCore::setSSLClientCertificate):
        * platform/network/curl/SSLHandle.h:

2014-01-22  Mihai Maerean  <mmaerean@adobe.com>

        [CSS Regions] layerOwner in RenderNamedFlowFragment cannot return null
        https://bugs.webkit.org/show_bug.cgi?id=127343

        Reviewed by Sam Weinig.

        RenderNamedFlowFragment::layerOwner cannot return null because regions create stacking
        contexts which create layers.

        No new tests, no functional change.

        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::hasCompositingRegionDescendant):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::calculateClipRects):
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::adjustAncestorCompositingBoundsForFlowThread):
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::computeRegionCompositingRequirements):
        * rendering/RenderNamedFlowFragment.h:

2014-01-22  Antti Koivisto  <antti@apple.com>

        Avoid unthrottled layer flushes triggered by RenderLayerCompositor::ensureRootLayer
        https://bugs.webkit.org/show_bug.cgi?id=127426

        Reviewed by Anders Carlsson.
        
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::updateScrollLayerPosition):
        (WebCore::RenderLayerCompositor::frameViewDidScroll):

            Factor scroll layer position update to a function.

        (WebCore::RenderLayerCompositor::ensureRootLayer):
        
            Stop calling frameViewDidChangeSize/frameViewDidScroll. Instead call the relevent functions
            directly. This avoid unthrottled layer flush that is done when the view actually scrolls.

        * rendering/RenderLayerCompositor.h:

2014-01-22  Mihai Tica  <mitica@adobe.com>

        [CSS Background Blending] -webkit-background-blend-mode fails for certain SVG files
        https://bugs.webkit.org/show_bug.cgi?id=127350

        Reviewed by Dirk Schulze.

        The graphics context of the SVG inherits the blend mode set
        on the background layer. Fix consists in drawing the SVG
        in a transparency layer.

        Test: css3/compositing/background-blend-mode-svg.html

        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImage::draw): Begin a transparency layer if a blend mode is set.

2014-01-22  Antti Koivisto  <antti@apple.com>

        Update overlay scrollbars in single pass
        https://bugs.webkit.org/show_bug.cgi?id=127289

        Reviewed by Anders Carlsson.

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::updateScrollbars):
        
            Multi-pass scrollbar resolution is only needed for traditional scrollbars. Overlay scrollbars don't affect layout.

2014-01-22  Mihnea Ovidenie  <mihnea@adobe.com>

        [CSSRegions] Incorrect layout of a region pseudo children
        https://bugs.webkit.org/show_bug.cgi?id=126146

        Reviewed by David Hyatt.

        Test: fast/regions/collapse-anonymous-region.html

        A region behaviour, styled using -webkit-flow-from, is modeled using an anonymous
        block created to fragment the named flow content inside the region. We have to prevent
        the behaviour of anonymous children collapsing for this block to make sure that the
        region element children are still laid out properly when the region element becomes an ordinary
        element.

        * rendering/RenderBlockFlow.h:

2014-01-21  Ryuan Choi  <ryuan.choi@samsung.com>

        Remove unused "acceleratedCompositingForScrollableFramesEnabled" setting
        https://bugs.webkit.org/show_bug.cgi?id=127402

        Reviewed by Anders Carlsson.

        compositing/iframes/iframe-composited-scrolling.html is updated because
        there are no usages in WebCore.

        * page/Settings.in:

2014-01-21  Alex Christensen  <achristensen@webkit.org>

        Compile fix for using libsoup on Windows.
        https://bugs.webkit.org/show_bug.cgi?id=127377

        Reviewed by Daniel Bates.

        * platform/network/soup/ProxyResolverSoup.cpp:
        (soupProxyResolverWkSetProperty):
        (soupProxyResolverWkGetProperty):
        (soupProxyResolverWkGetProxyURISync):
        Replaced uint with unsigned.

2014-01-21  Daniel Bates  <dabates@apple.com>

        Break up single assertion into two assertions in HTMLMediaElement::returnPlatformLayer()

        Following up after <http://trac.webkit.org/changeset/162473>, we should break up
        the assertion into two assertions as suggested by Darin Adler. Separating the single
        assertion into two assertions makes it straightforward to determine the conjunct that
        failed among other benefits.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::parseAttribute):

2014-01-21  Brady Eidson  <beidson@apple.com>

        The IDB backing store put() method shouldn't call IDB callbacks directly
        https://bugs.webkit.org/show_bug.cgi?id=127399

        Reviewed by Beth Dakin.

        Refactor the put() callback to take a resulting key or an error.
        * Modules/indexeddb/IDBServerConnection.h:

        * Modules/indexeddb/IDBTransactionBackendOperations.cpp:
        (WebCore::PutOperation::perform): Call to the backing store, then perform the
          appropriate IDB callback whether a key or an error was returned.
        * Modules/indexeddb/IDBTransactionBackendOperations.h:

        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.cpp:
        (WebCore::IDBServerConnectionLevelDB::put): Don’t call IDB callbacks directly.
          Instead, pass the resulting key/error back to the PutOperation.
        * Modules/indexeddb/leveldb/IDBServerConnectionLevelDB.h:

2014-01-21  Jae Hyun Park  <jae.park@company100.net>

        Use nullptr in HTMLCanvasElement
        https://bugs.webkit.org/show_bug.cgi?id=127388

        Reviewed by Gyuyoung Kim.

        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::getContext):
        (WebCore::HTMLCanvasElement::drawingContext):
        (WebCore::HTMLCanvasElement::existingDrawingContext):

2014-01-21  László Langó  <llango.u-szeged@partner.samsung.com>

        Assertion failure in Range::nodeWillBeRemoved
        https://bugs.webkit.org/show_bug.cgi?id=121694

        Reviewed by Ryosuke Niwa.

        Based on Blink a change: https://chromium.googlesource.com/chromium/blink/+/407c1d7b2c45974aa614b3f847ffe9e8fce205fa

        This patch fix an assertion failure. Range::nodeWillBeRemoved() might
        be called with removed node in ContainerNode, when DOMNodeRemovedFromDocument
        event handler calls removeChild(), for node being removed.

        Test: fast/dom/Range/remove-twice-crash.html

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::willRemoveChild):
        * dom/ContainerNode.h:

2014-01-21  Tim Horton  <timothy_horton@apple.com>

        REGRESSION (r161580): Some PDFs render outside their <img>
        https://bugs.webkit.org/show_bug.cgi?id=127381
        <rdar://problem/15872168>

        Reviewed by Simon Fraser.

        * platform/graphics/cg/PDFDocumentImage.cpp:
        (WebCore::transformContextForPainting):
        Only try to make the scale uniform if it isn't already, and use the minimum
        of the two original scales when doing so, so that it is absolutely certain
        to fit inside space allocated for the image during layout.

2014-01-21  Simon Fraser  <simon.fraser@apple.com>

        Remove #if PLATFORM(IOS) in various places around customFixedPositionLayoutRect() code
        https://bugs.webkit.org/show_bug.cgi?id=127373

        Reviewed by Beth Dakin.

        Instead of PLATFORM(IOS) #idefs at every call site for viewportConstrainedVisibleContentRect(),
        move the #ifdef inside viewportConstrainedVisibleContentRect().
        
        The one call site that needs special handling is RenderLayerBacking::updateCompositedBounds(),
        which needs to avoid clipping fixed layers to the custom fixed position rect, but instead to
        visibleContentRect() (which is really the document bounds on iOS). This ensures that the
        fixed layers aren't clipped when zooming out.

        * page/FrameView.cpp:
        (WebCore::FrameView::viewportConstrainedVisibleContentRect):
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::stickyPositionOffset):
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::updateCompositedBounds):
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::requiresCompositingForPosition):
        (WebCore::RenderLayerCompositor::computeFixedViewportConstraints):
        (WebCore::RenderLayerCompositor::computeStickyViewportConstraints):

2014-01-21  Andy Estes  <aestes@apple.com>

        [iOS] Allow all clients to link against WebCore
        https://bugs.webkit.org/show_bug.cgi?id=127372
        
        Reviewed by Dan Bernstein.

        * Configurations/WebCore.xcconfig:

2014-01-21  Bear Travis  <betravis@adobe.com>

        [CSS Shapes] Preserve box-shape order when serializing shape values
        https://bugs.webkit.org/show_bug.cgi?id=127200

        Reviewed by Dirk Schulze.

        Convert the parsed shape-box pair to a CSSValueList rather than directly
        adding the box value to BasicShape. The CSSValueList preserves the
        shape-box ordering, and cleans up a little bit of the code shared between
        clip and shape values.

        Modifying existing parsing tests.

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::shapePropertyValue): Factor out code common to generating shape
        values.
        (WebCore::ComputedStyleExtractor::propertyValue): Generate a CSSValueList when
        you have both a shape and a box.
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseBasicShapeAndOrBox): Factor out code common to clip
        paths and shape properties that parses the [basic-shape || box] syntax from
        the CSS Shapes spec.
        (WebCore::CSSParser::parseShapeProperty): Parse shape-box pairs as a CSSValueList.
        * css/DeprecatedStyleBuilder.cpp:
        (WebCore::ApplyPropertyShape::applyValue): Use the CSSValueList for shape-box pairs.
        * css/CSSValueList.h:
        (WebCore::CSSValueList::itemWithoutBoundsCheck): Add a const version.
        * page/animation/CSSPropertyAnimation.cpp:
        (WebCore::blendFunc): Specify a box when blending.
        * rendering/style/ShapeValue.h:
        (WebCore::ShapeValue::createShapeValue): Add a box parameter.
        (WebCore::ShapeValue::ShapeValue): Ditto.

2014-01-21  Daniel Bates  <dabates@apple.com>

        Fix the iOS Simulator release build

        Substitute ASSERT_UNUSED() for ASSERT() to resolve a compiler warning
        that the argument platformLayer is unused. The argument platformLayer
        is only used in the asserted condition, which isn't compiled in a
        release build; => the argument is unused in a release build.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::parseAttribute):

2014-01-21  Zoltan Horvath  <zoltan@webkit.org>

        Since MidpointState is a class, it should behave like a class
        https://bugs.webkit.org/show_bug.cgi?id=127154

        Reviewed by David Hyatt.

        I modified MidpointState to behave like a class, updated the call sites also.

        No new tests, no behavior change.

        * platform/text/BidiResolver.h:
        (WebCore::MidpointState::reset):
        (WebCore::MidpointState::startIgnoringSpaces):
        (WebCore::MidpointState::stopIgnoringSpaces):
        (WebCore::MidpointState::midpoints):
        (WebCore::MidpointState::numMidpoints):
        (WebCore::MidpointState::currentMidpoint):
        (WebCore::MidpointState::incrementCurrentMidpoint):
        (WebCore::MidpointState::decreaseNumMidpoints):
        (WebCore::MidpointState::betweenMidpoints):
        (WebCore::MidpointState::setBetweenMidpoints):
        (WebCore::MidpointState::addMidpoint): Renamed from deprecatedAddMidpoint, since now
        its private, we no longer need to discourage callers from using it.
        * rendering/InlineIterator.h:
        (WebCore::IsolateTracker::addFakeRunIfNecessary):
        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::RenderBlockFlow::appendRunsForObject):
        (WebCore::constructBidiRunsForLine):
        * rendering/line/BreakingContextInlineHeaders.h:
        (WebCore::checkMidpoints):
        * rendering/line/TrailingObjects.cpp:
        (WebCore::TrailingObjects::updateMidpointsForTrailingBoxes):

2014-01-21  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r162452.
        http://trac.webkit.org/changeset/162452
        https://bugs.webkit.org/show_bug.cgi?id=127366

        broke a few tests on all Mac WebKit1 bots (Requested by
        thorton on #webkit).

        * WebCore.exp.in:
        * page/FocusController.cpp:
        (WebCore::FocusController::FocusController):
        (WebCore::FocusController::setFocused):
        (WebCore::FocusController::setActive):
        (WebCore::FocusController::setContentIsVisible):
        * page/FocusController.h:
        (WebCore::FocusController::isActive):
        (WebCore::FocusController::isFocused):
        * page/Page.cpp:
        (WebCore::Page::Page):
        (WebCore::Page::setIsInWindow):
        (WebCore::Page::setIsVisuallyIdle):
        (WebCore::Page::setIsVisible):
        (WebCore::Page::visibilityState):
        (WebCore::Page::hiddenPageCSSAnimationSuspensionStateChanged):
        * page/Page.h:
        (WebCore::Page::isVisible):
        (WebCore::Page::isInWindow):

2014-01-21  Chris Fleizach  <cfleizach@apple.com>

        AX: Mac: Expose the visible text of a password field to AX
        https://bugs.webkit.org/show_bug.cgi?id=127353

        Reviewed by Brent Fulgham.

        The Mac platform should now expose the rendered value of password fields through AX.

        Test: accessibility/password-field-value.html

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::textLength):
        (WebCore::AccessibilityRenderObject::passwordFieldValue):

2014-01-21  Robert Sipka  <sipka@inf.u-szeged.hu>

        Support SSL error handling in case of synchronous job.
        https://bugs.webkit.org/show_bug.cgi?id=125301

        Reviewed by Brent Fulgham.

        Set ssl error informations for the users.

        * platform/network/curl/ResourceHandleManager.cpp:
        (WebCore::ResourceHandleManager::dispatchSynchronousJob):

2014-01-21  Simon Fraser  <simon.fraser@apple.com>

        Export systemTotalMemory() and systemMemoryLevel() for MobileSafari
        https://bugs.webkit.org/show_bug.cgi?id=127360

        Reviewed by Andy Estes.
        
        MobileSafari inappropriately calls these WebCore functions directly,
        so export them.

        * WebCore.exp.in:

2014-01-21  Simon Fraser  <simon.fraser@apple.com>

        Clean up PLATFORM(IOS) code related to the custom fixed position layout rect
        https://bugs.webkit.org/show_bug.cgi?id=127362

        Reviewed by Dave Hyatt.

        Various platforms customize the rect used to layout position:fixed elements,
        and each modified RenderBox::availableLogicalHeight/WidthUsing() in different
        ways.
        
        Clean this up by adding RenderView::clientLogicalWidth/HeightForFixedPosition(),
        and moving the platform hacks into it.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::availableLogicalHeightUsing):
        (WebCore::RenderBox::containingBlockLogicalWidthForPositioned):
        (WebCore::RenderBox::containingBlockLogicalHeightForPositioned):
        * rendering/RenderView.cpp:
        (WebCore::RenderView::clientLogicalWidthForFixedPosition):
        (WebCore::RenderView::clientLogicalHeightForFixedPosition):
        * rendering/RenderView.h:

2014-01-21  Tamas Gergely  <tgergely.u-szeged@partner.samsung.com>

        ASSERT(time.isFinite()) in SVGSMILElement::createInstanceTimesFromSyncbase
        <https://webkit.org/b/108184>

        Reviewed by Philip Rogers.

        In the case a SMILElement timing had a syncbase dependency on an indefinite value
        the assert were raised. The assert has been removed and a check has been added
        instead that prevents the addition of indefinite times to the time list.

        Test: svg/animations/smil-syncbase-self-dependency.svg

        * svg/animation/SVGSMILElement.cpp:
        (WebCore::SVGSMILElement::createInstanceTimesFromSyncbase):
          ASSERT removed.

2014-01-21  Tim Horton  <timothy_horton@apple.com>

        Address late review naming comments after r162453.

        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/ca/mac/PlatformCALayerMac.mm:
        * platform/graphics/mac/CALayerWebAdditions.h: Removed.
        * platform/graphics/mac/CALayerWebAdditions.mm: Removed.
        * platform/graphics/mac/WebCoreCALayerExtras.h: Added.
        * platform/graphics/mac/WebCoreCALayerExtras.mm: Added.
        (-[CALayer web_disableAllActions]):

2014-01-21  Tim Horton  <timothy_horton@apple.com>

        Keep CALayer implicit animation disabling code in a single place
        https://bugs.webkit.org/show_bug.cgi?id=127355

        Reviewed by Simon Fraser.

        * WebCore.xcodeproj/project.pbxproj:
        Add CALayerWebAdditions.{h,mm}.

        * platform/graphics/ca/mac/PlatformCALayerMac.mm:
        (PlatformCALayerMac::commonInit):
        Remove nullActionsDictionary() and use [CALayer(WebAdditions) web_disableAllActions] instead.

        * platform/graphics/mac/CALayerWebAdditions.h: Added.
        * platform/graphics/mac/CALayerWebAdditions.mm: Added.
        (-[CALayer web_disableAllActions]):
        Added. Disable all implicit actions on the layer.

2014-01-21  Gavin Barraclough  <barraclough@apple.com>

        Change Page, FocusController to use ViewState
        https://bugs.webkit.org/show_bug.cgi?id=126533

        Reviewed by Tim Horton.

        These classes currently maintain a set of separate fields to represent the view state;
        combine these into a single field, and allow WebPage to send the combined update rather
        than individual changes.

        Maintain existing interface for WebKit1 clients.

        * WebCore.exp.in:
            - Added WebCore::setViewState, removed WebCore::setIsVisuallyIdle.
        * page/FocusController.cpp:
        (WebCore::FocusController::FocusController):
            - Initialize combined m_viewState.
        (WebCore::FocusController::setFocused):
            - Calls setViewState.
        (WebCore::FocusController::setFocusedInternal):
            - setFocused -> setFocusedInternal.
        (WebCore::FocusController::setViewState):
            - Added, update all ViewState flags.
        (WebCore::FocusController::setActive):
            - Calls setViewState.
        (WebCore::FocusController::setActiveInternal):
            - setActive -> setActiveInternal.
        (WebCore::FocusController::setContentIsVisible):
            - Calls setViewState.
        (WebCore::FocusController::setContentIsVisibleInternal):
            - setContentIsVisible -> setContentIsVisibleInternal.
        * page/FocusController.h:
        (WebCore::FocusController::isActive):
        (WebCore::FocusController::isFocused):
        (WebCore::FocusController::contentIsVisible):
            - Implemented in terms of ViewState.
        * page/Page.cpp:
        (WebCore::Page::Page):
            - Initialize using PageInitialViewState.
        (WebCore::Page::setIsInWindow):
            - Calls setViewState.
        (WebCore::Page::setIsInWindowInternal):
            - setIsInWindow -> setIsInWindowInternal.
        (WebCore::Page::setIsVisuallyIdleInternal):
            - setIsVisuallyIdle -> setIsVisuallyIdleInternal.
        (WebCore::Page::setViewState):
            - Added, update all ViewState flags, including FocusController.
        (WebCore::Page::setIsVisible):
            - Calls setViewState.
        (WebCore::Page::setIsVisibleInternal):
            - setIsVisible -> setIsVisibleInternal.
        (WebCore::Page::visibilityState):
            - m_isVisible -> isVisible()
        (WebCore::Page::hiddenPageCSSAnimationSuspensionStateChanged):
            - m_isVisible -> isVisible()
        * page/Page.h:
        (WebCore::Page::isVisible):
        (WebCore::Page::isInWindow):
            - Implemented in terms of ViewState.
        (WebCore::Page::scriptedAnimationsSuspended):
            - Combined member fields into ViewState::Flags.

2014-01-21  Lauro Neto  <lauro.neto@openbossa.org>

        Remove PLATFORM(NIX) from WebCore
        https://bugs.webkit.org/show_bug.cgi?id=127299

        Reviewed by Anders Carlsson.

        * editing/Editor.cpp:
        (WebCore::Editor::cut):
        (WebCore::Editor::copy):
        (WebCore::Editor::copyImage):
        * editing/Editor.h:
        * html/HTMLCanvasElement.h:
        * loader/EmptyClients.h:
        * loader/FrameLoader.cpp:
